/* umockdev.c generated by valac 0.56.3, the Vala compiler
 * generated from umockdev.vala, do not modify */

/*
 * Copyright (C) 2012-2013 Canonical Ltd.
 * Author: Martin Pitt <martin.pitt@ubuntu.com>
 *
 * umockdev is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * umockdev is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * SECTION:umockdev
 * @title: umockdev
 * @short_description: Build a test bed for testing software that handles Linux
 * hardware devices.
 *
 * Please see README.md about an overview of the parts of umockdev, and how
 * they fit together.
 */
/**
 * SECTION:functions
 * @title: global functions
 * @short_description: Global functions
 *
 * These work independently from #UMockdevTestbed objects.
 */
/**
 * SECTION:umockdeverror
 * @title: umockdev errors
 * @short_description: #GError types for parsing umockdev files
 * hardware devices.
 *
 * See #GError for more information on error domains.
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include "umockdev.h"
#include "uevent_sender.h"
#include <glib-object.h>
#include "umockdev-utils.h"
#include <unistd.h>
#include <gio/gio.h>
#include <stdarg.h>
#include <sys/socket.h>
#include "linux/input.h"
#include <time.h>
#include <pty.h>
#include <termios.h>
#include <stdio.h>
#include <sys/select.h>
#include <sys/time.h>
#include <errno.h>
#include <gobject/gvaluecollector.h>
#include <gio/gunixsocketaddress.h>
#include <sys/stat.h>
#include <sys/types.h>

#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))

#define UMOCKDEV_TYPE_SCRIPT_RUNNER (umockdev_script_runner_get_type ())
#define UMOCKDEV_SCRIPT_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_SCRIPT_RUNNER, UMockdevScriptRunner))
#define UMOCKDEV_SCRIPT_RUNNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_SCRIPT_RUNNER, UMockdevScriptRunnerClass))
#define UMOCKDEV_IS_SCRIPT_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_SCRIPT_RUNNER))
#define UMOCKDEV_IS_SCRIPT_RUNNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_SCRIPT_RUNNER))
#define UMOCKDEV_SCRIPT_RUNNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_SCRIPT_RUNNER, UMockdevScriptRunnerClass))

typedef struct _UMockdevScriptRunner UMockdevScriptRunner;
typedef struct _UMockdevScriptRunnerClass UMockdevScriptRunnerClass;

#define UMOCKDEV_TYPE_SOCKET_SERVER (umockdev_socket_server_get_type ())
#define UMOCKDEV_SOCKET_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_SOCKET_SERVER, UMockdevSocketServer))
#define UMOCKDEV_SOCKET_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_SOCKET_SERVER, UMockdevSocketServerClass))
#define UMOCKDEV_IS_SOCKET_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_SOCKET_SERVER))
#define UMOCKDEV_IS_SOCKET_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_SOCKET_SERVER))
#define UMOCKDEV_SOCKET_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_SOCKET_SERVER, UMockdevSocketServerClass))

typedef struct _UMockdevSocketServer UMockdevSocketServer;
typedef struct _UMockdevSocketServerClass UMockdevSocketServerClass;
enum  {
	UMOCKDEV_TESTBED_0_PROPERTY,
	UMOCKDEV_TESTBED_NUM_PROPERTIES
};
static GParamSpec* umockdev_testbed_properties[UMOCKDEV_TESTBED_NUM_PROPERTIES];
#define _umockdev_socket_server_unref0(var) ((var == NULL) ? NULL : (var = (umockdev_socket_server_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _uevent_sender_close0(var) ((var == NULL) ? NULL : (var = (uevent_sender_close (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

#define UMOCKDEV_TYPE_IOCTL_SPI_BASE (umockdev_ioctl_spi_base_get_type ())
#define UMOCKDEV_IOCTL_SPI_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_SPI_BASE, UMockdevIoctlSpiBase))
#define UMOCKDEV_IOCTL_SPI_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_SPI_BASE, UMockdevIoctlSpiBaseClass))
#define UMOCKDEV_IS_IOCTL_SPI_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_SPI_BASE))
#define UMOCKDEV_IS_IOCTL_SPI_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_SPI_BASE))
#define UMOCKDEV_IOCTL_SPI_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_SPI_BASE, UMockdevIoctlSpiBaseClass))

typedef struct _UMockdevIoctlSpiBase UMockdevIoctlSpiBase;
typedef struct _UMockdevIoctlSpiBaseClass UMockdevIoctlSpiBaseClass;

#define UMOCKDEV_TYPE_IOCTL_SPI_HANDLER (umockdev_ioctl_spi_handler_get_type ())
#define UMOCKDEV_IOCTL_SPI_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER, UMockdevIoctlSpiHandler))
#define UMOCKDEV_IOCTL_SPI_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER, UMockdevIoctlSpiHandlerClass))
#define UMOCKDEV_IS_IOCTL_SPI_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER))
#define UMOCKDEV_IS_IOCTL_SPI_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER))
#define UMOCKDEV_IOCTL_SPI_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER, UMockdevIoctlSpiHandlerClass))

typedef struct _UMockdevIoctlSpiHandler UMockdevIoctlSpiHandler;
typedef struct _UMockdevIoctlSpiHandlerClass UMockdevIoctlSpiHandlerClass;

#define UMOCKDEV_TYPE_IOCTL_TREE_HANDLER (umockdev_ioctl_tree_handler_get_type ())
#define UMOCKDEV_IOCTL_TREE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandler))
#define UMOCKDEV_IOCTL_TREE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandlerClass))
#define UMOCKDEV_IS_IOCTL_TREE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER))
#define UMOCKDEV_IS_IOCTL_TREE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER))
#define UMOCKDEV_IOCTL_TREE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandlerClass))

typedef struct _UMockdevIoctlTreeHandler UMockdevIoctlTreeHandler;
typedef struct _UMockdevIoctlTreeHandlerClass UMockdevIoctlTreeHandlerClass;

#define UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER (umockdev_ioctl_usb_pcap_handler_get_type ())
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandler))
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandlerClass))
#define UMOCKDEV_IS_IOCTL_USB_PCAP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER))
#define UMOCKDEV_IS_IOCTL_USB_PCAP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER))
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandlerClass))

typedef struct _UMockdevIoctlUsbPcapHandler UMockdevIoctlUsbPcapHandler;
typedef struct _UMockdevIoctlUsbPcapHandlerClass UMockdevIoctlUsbPcapHandlerClass;
#define _umockdev_script_runner_unref0(var) ((var == NULL) ? NULL : (var = (umockdev_script_runner_unref (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _UMockdevScriptRunnerPrivate UMockdevScriptRunnerPrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _UMockdevParamSpecScriptRunner UMockdevParamSpecScriptRunner;
typedef struct _UMockdevSocketServerPrivate UMockdevSocketServerPrivate;
typedef struct _UMockdevParamSpecSocketServer UMockdevParamSpecSocketServer;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Block1Data {
	int _ref_count_;
	GMainLoop* loop;
};

struct _UMockdevTestbedPrivate {
	gchar* root_dir;
	gchar* sys_dir;
	GRegex* re_record_val;
	GRegex* re_record_keyval;
	GRegex* re_record_optval;
	uevent_sender* ev_sender;
	GHashTable* dev_fd;
	GHashTable* dev_script_runner;
	UMockdevSocketServer* socket_server;
	GHashTable* custom_handlers;
	GThread* worker_thread;
	GMainContext* worker_ctx;
	GMainLoop* worker_loop;
};

struct _UMockdevScriptRunner {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UMockdevScriptRunnerPrivate * priv;
};

struct _UMockdevScriptRunnerClass {
	GTypeClass parent_class;
	void (*finalize) (UMockdevScriptRunner *self);
};

struct _UMockdevScriptRunnerPrivate {
	gchar* _device;
	gchar* script_file;
	GThread* thread;
	FILE* script;
	gint fd;
	gboolean running;
	guint fuzz;
};

struct _UMockdevParamSpecScriptRunner {
	GParamSpec parent_instance;
};

struct _UMockdevSocketServer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UMockdevSocketServerPrivate * priv;
};

struct _UMockdevSocketServerClass {
	GTypeClass parent_class;
	void (*finalize) (UMockdevSocketServer *self);
};

struct _UMockdevSocketServerPrivate {
	GSocket** listen_sockets;
	gint listen_sockets_length1;
	gint _listen_sockets_size_;
	GHashTable* socket_scriptfile;
	GHashTable* script_runners;
	GThread* thread;
	gboolean running;
	gint ctrl_r;
	gint ctrl_w;
};

struct _UMockdevParamSpecSocketServer {
	GParamSpec parent_instance;
};

/**
 * UMockdevError:
 * @UMOCKDEV_ERROR_PARSE:
 * There is a malformed or missing line in the device description.
 * @UMOCKDEV_ERROR_VALUE:
 * A value in the device description has an invalid value, for example a device
 * path does not start with "/devices/".
 *
 * Error codes for parsing umockdev files.
 */

VALA_EXTERN gboolean umockdev___in_mock_env_initialized;
gboolean umockdev___in_mock_env_initialized = FALSE;
VALA_EXTERN gboolean umockdev___in_mock_env_result;
gboolean umockdev___in_mock_env_result = FALSE;
static gint UMockdevTestbed_private_offset;
static gpointer umockdev_testbed_parent_class = NULL;
static GHashTable* umockdev_testbed_bus_lookup_table;
static GHashTable* umockdev_testbed_bus_lookup_table = NULL;
static gint UMockdevScriptRunner_private_offset;
static gpointer umockdev_script_runner_parent_class = NULL;
static gint UMockdevSocketServer_private_offset;
static gpointer umockdev_socket_server_parent_class = NULL;

VALA_EXTERN void umockdev_checked_mkdir (const gchar* path,
                             gint mode);
VALA_EXTERN void umockdev_checked_mkdir_with_parents (const gchar* path,
                                          gint mode);
VALA_EXTERN GThread* umockdev_create_worker_thread (GMainLoop* loop);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda4_ (Block1Data* _data1_);
static gpointer ___lambda4__gthread_func (gpointer self);
VALA_EXTERN gpointer umockdev_script_runner_ref (gpointer instance);
VALA_EXTERN void umockdev_script_runner_unref (gpointer instance);
VALA_EXTERN GParamSpec* umockdev_param_spec_script_runner (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void umockdev_value_set_script_runner (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void umockdev_value_take_script_runner (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer umockdev_value_get_script_runner (const GValue* value);
VALA_EXTERN GType umockdev_script_runner_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer umockdev_socket_server_ref (gpointer instance);
VALA_EXTERN void umockdev_socket_server_unref (gpointer instance);
VALA_EXTERN GParamSpec* umockdev_param_spec_socket_server (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void umockdev_value_set_socket_server (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void umockdev_value_take_socket_server (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer umockdev_value_get_socket_server (const GValue* value);
VALA_EXTERN GType umockdev_socket_server_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void umockdev_script_runner_stop (UMockdevScriptRunner* self);
static void _umockdev_testbed___lambda5_ (UMockdevTestbed* self,
                                   const gchar* key,
                                   UMockdevIoctlBase* val);
VALA_EXTERN void umockdev_ioctl_base_unregister_path (UMockdevIoctlBase* self,
                                          const gchar* devnode);
static void __umockdev_testbed___lambda5__gh_func (gconstpointer key,
                                            gconstpointer value,
                                            gpointer self);
VALA_EXTERN void umockdev_socket_server_stop (UMockdevSocketServer* self);
static void _g_free0_ (gpointer var);
static void _umockdev_script_runner_unref0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN void umockdev_ioctl_base_register_path (UMockdevIoctlBase* self,
                                        GMainContext* ctx,
                                        const gchar* devnode,
                                        const gchar* sockpath);
static gchar* umockdev_testbed_get_attribute (UMockdevTestbed* self,
                                       const gchar* devpath,
                                       const gchar* name);
static gchar* umockdev_testbed_add_devicev_no_uevent (UMockdevTestbed* self,
                                               const gchar* subsystem,
                                               const gchar* name,
                                               const gchar* parent,
                                               gchar** attributes,
                                               gchar** properties);
static gboolean umockdev_testbed_subsystem_is_bus (const gchar* subsystem);
VALA_EXTERN gchar* umockdev_make_dotdots (const gchar* path);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gchar* umockdev_find_devnode (const gchar* devpath);
static gchar* umockdev_testbed_add_dev_from_string (UMockdevTestbed* self,
                                             const gchar* data,
                                             GError** error);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
VALA_EXTERN UMockdevIoctlSpiHandler* umockdev_ioctl_spi_handler_new (const gchar* file);
VALA_EXTERN UMockdevIoctlSpiHandler* umockdev_ioctl_spi_handler_construct (GType object_type,
                                                               const gchar* file);
VALA_EXTERN GType umockdev_ioctl_spi_base_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType umockdev_ioctl_spi_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UMockdevIoctlTreeHandler* umockdev_ioctl_tree_handler_new (const gchar* file);
VALA_EXTERN UMockdevIoctlTreeHandler* umockdev_ioctl_tree_handler_construct (GType object_type,
                                                                 const gchar* file);
VALA_EXTERN GType umockdev_ioctl_tree_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType umockdev_ioctl_usb_pcap_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UMockdevIoctlUsbPcapHandler* umockdev_ioctl_usb_pcap_handler_new (const gchar* file,
                                                                  gint bus,
                                                                  gint device);
VALA_EXTERN UMockdevIoctlUsbPcapHandler* umockdev_ioctl_usb_pcap_handler_construct (GType object_type,
                                                                        const gchar* file,
                                                                        gint bus,
                                                                        gint device);
VALA_EXTERN UMockdevScriptRunner* umockdev_script_runner_new (const gchar* device,
                                                  const gchar* script_file,
                                                  gint fd,
                                                  GError** error);
VALA_EXTERN UMockdevScriptRunner* umockdev_script_runner_construct (GType object_type,
                                                        const gchar* device,
                                                        const gchar* script_file,
                                                        gint fd,
                                                        GError** error);
VALA_EXTERN UMockdevSocketServer* umockdev_socket_server_new (void);
VALA_EXTERN UMockdevSocketServer* umockdev_socket_server_construct (GType object_type);
VALA_EXTERN void umockdev_socket_server_add (UMockdevSocketServer* self,
                                 const gchar* sock_path,
                                 gint fd,
                                 const gchar* record_file);
VALA_EXTERN gchar* umockdev_script_runner_encode (guint8* data,
                                      gint data_length1);
static GHashTable* umockdev_testbed_create_bus_lookup (void);
static gchar* umockdev_testbed_record_parse_line (UMockdevTestbed* self,
                                           const gchar* data,
                                           gchar* type,
                                           gchar** key,
                                           gchar** val);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN guint8* umockdev_decode_hex (const gchar* data,
                             gint* result_length1,
                             GError** error);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void umockdev_testbed_create_node_for_device (UMockdevTestbed* self,
                                              const gchar* subsystem,
                                              const gchar* node_path,
                                              guint8* node_contents,
                                              gint node_contents_length1,
                                              const gchar* majmin,
                                              GError** error);
static void umockdev_testbed_finalize (GObject * obj);
static GType umockdev_testbed_get_type_once (void);
VALA_EXTERN guint8 umockdev_hexdigit (gchar c);
static void umockdev_script_runner_set_device (UMockdevScriptRunner* self,
                                        const gchar* value);
static void* umockdev_script_runner_run (UMockdevScriptRunner* self);
static gpointer _umockdev_script_runner_run_gthread_func (gpointer self);
VALA_EXTERN const gchar* umockdev_script_runner_get_device (UMockdevScriptRunner* self);
static guint8* umockdev_script_runner_next_line (UMockdevScriptRunner* self,
                                          gchar* op,
                                          guint32* delta,
                                          gint* result_length1);
static void umockdev_script_runner_op_write (UMockdevScriptRunner* self,
                                      guint8* data,
                                      gint data_length1,
                                      guint32 delta);
static guint8* umockdev_script_runner_decode (const gchar* quoted,
                                       gint* result_length1);
static guint umockdev_script_runner_hamming (guint8* d1,
                                      gint d1_length1,
                                      guint8* d2,
                                      gint d2_length1);
static void _vala_array_add12 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add13 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add14 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add15 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add16 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add17 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add18 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add19 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void umockdev_script_runner_finalize (UMockdevScriptRunner * obj);
static GType umockdev_script_runner_get_type_once (void);
static void* umockdev_socket_server_run (UMockdevSocketServer* self);
static gpointer _umockdev_socket_server_run_gthread_func (gpointer self);
static void _vala_array_add20 (GSocket** * array,
                        gint* length,
                        gint* size,
                        GSocket* value);
static void umockdev_socket_server_finalize (UMockdevSocketServer * obj);
static GType umockdev_socket_server_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

void
umockdev_checked_mkdir (const gchar* path,
                        gint mode)
{
#line 26 "../src/umockdev.vala"
	g_return_if_fail (path != NULL);
#line 28 "../src/umockdev.vala"
	if (g_mkdir (path, mode) < 0) {
#line 29 "../src/umockdev.vala"
		g_error ("umockdev.vala:29: cannot create directory %s: %m", path);
#line 505 "umockdev.c"
	}
}

void
umockdev_checked_mkdir_with_parents (const gchar* path,
                                     gint mode)
{
#line 32 "../src/umockdev.vala"
	g_return_if_fail (path != NULL);
#line 34 "../src/umockdev.vala"
	if (g_mkdir_with_parents (path, mode) < 0) {
#line 35 "../src/umockdev.vala"
		g_error ("umockdev.vala:35: cannot create directory with parents %s: %m", path);
#line 519 "umockdev.c"
	}
}

/**
 * UMockdevTestbed:
 *
 * The #UMockdevTestbed class builds a temporary sandbox for mock devices.
 * You can add a number of devices including arbitrary sysfs attributes and
 * udev properties, and then run your software in that test bed that is
 * independent of the actual hardware it is running on.  With this you can
 * simulate particular hardware in virtual environments up to some degree,
 * without needing any particular privileges or disturbing the whole system.
 *
 * You can either add devices by specifying individual device paths,
 * properties, and attributes, or use the umockdev-record tool to create a human
 * readable/editable record of a real device (and all its parents) and load
 * that into the testbed with umockdev_testbed_add_from_string().
 *
 * Instantiating a #UMockdevTestbed object creates a temporary directory with
 * an empty sysfs tree and sets the $UMOCKDEV_DIR environment variable so that
 * programs subsequently started under umockdev-wrapper will use the test bed
 * instead of the system's real sysfs.
 */
static gpointer
_g_main_loop_ref0 (gpointer self)
{
#line 70 "../src/umockdev.vala"
	return self ? g_main_loop_ref (self) : NULL;
#line 548 "umockdev.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 70 "../src/umockdev.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 70 "../src/umockdev.vala"
	return _data1_;
#line 558 "umockdev.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 70 "../src/umockdev.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 70 "../src/umockdev.vala"
		_g_main_loop_unref0 (_data1_->loop);
#line 70 "../src/umockdev.vala"
		g_slice_free (Block1Data, _data1_);
#line 572 "umockdev.c"
	}
}

static gpointer
_g_main_context_ref0 (gpointer self)
{
#line 74 "../src/umockdev.vala"
	return self ? g_main_context_ref (self) : NULL;
#line 581 "umockdev.c"
}

static void
__lambda4_ (Block1Data* _data1_)
{
	GMainContext* ctx = NULL;
	GMainContext* _tmp0_;
	GMainContext* _tmp1_;
#line 74 "../src/umockdev.vala"
	_tmp0_ = g_main_loop_get_context (_data1_->loop);
#line 74 "../src/umockdev.vala"
	_tmp1_ = _g_main_context_ref0 (_tmp0_);
#line 74 "../src/umockdev.vala"
	ctx = _tmp1_;
#line 76 "../src/umockdev.vala"
	g_main_context_push_thread_default (ctx);
#line 77 "../src/umockdev.vala"
	g_main_loop_run (_data1_->loop);
#line 78 "../src/umockdev.vala"
	g_main_context_pop_thread_default (ctx);
#line 73 "../src/umockdev.vala"
	_g_main_context_unref0 (ctx);
#line 604 "umockdev.c"
}

static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
#line 73 "../src/umockdev.vala"
	__lambda4_ (self);
#line 613 "umockdev.c"
	result = NULL;
#line 73 "../src/umockdev.vala"
	block1_data_unref (self);
#line 73 "../src/umockdev.vala"
	return result;
#line 619 "umockdev.c"
}

GThread*
umockdev_create_worker_thread (GMainLoop* loop)
{
	Block1Data* _data1_;
	GMainLoop* _tmp0_;
	GThread* _tmp1_;
	GThread* result;
#line 70 "../src/umockdev.vala"
	g_return_val_if_fail (loop != NULL, NULL);
#line 70 "../src/umockdev.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 70 "../src/umockdev.vala"
	_data1_->_ref_count_ = 1;
#line 70 "../src/umockdev.vala"
	_tmp0_ = _g_main_loop_ref0 (loop);
#line 70 "../src/umockdev.vala"
	_g_main_loop_unref0 (_data1_->loop);
#line 70 "../src/umockdev.vala"
	_data1_->loop = _tmp0_;
#line 73 "../src/umockdev.vala"
	_tmp1_ = g_thread_new ("umockdev-testbed-worker", ___lambda4__gthread_func, block1_data_ref (_data1_));
#line 73 "../src/umockdev.vala"
	result = _tmp1_;
#line 73 "../src/umockdev.vala"
	block1_data_unref (_data1_);
#line 73 "../src/umockdev.vala"
	_data1_ = NULL;
#line 73 "../src/umockdev.vala"
	return result;
#line 651 "umockdev.c"
}

static inline gpointer
umockdev_testbed_get_instance_private (UMockdevTestbed* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevTestbed_private_offset);
}

static void
_umockdev_testbed___lambda5_ (UMockdevTestbed* self,
                              const gchar* key,
                              UMockdevIoctlBase* val)
{
#line 132 "../src/umockdev.vala"
	g_return_if_fail (key != NULL);
#line 132 "../src/umockdev.vala"
	g_return_if_fail (val != NULL);
#line 133 "../src/umockdev.vala"
	umockdev_ioctl_base_unregister_path (val, key);
#line 671 "umockdev.c"
}

static void
__umockdev_testbed___lambda5__gh_func (gconstpointer key,
                                       gconstpointer value,
                                       gpointer self)
{
#line 132 "../src/umockdev.vala"
	_umockdev_testbed___lambda5_ ((UMockdevTestbed*) self, (const gchar*) key, (UMockdevIoctlBase*) value);
#line 681 "umockdev.c"
}

/**
     * umockdev_testbed_new:
     *
     * Create a new #UMockdevTestbed object. This is initially empty, call
     * methods like #umockdev_testbed_add_device or
     * #umockdev_testbed_add_from_string to fill it.
     *
     * Returns: The newly created #UMockdevTestbed object.
     */
static void
_g_free0_ (gpointer var)
{
#line 108 "../src/umockdev.vala"
	var = (g_free (var), NULL);
#line 698 "umockdev.c"
}

static void
_umockdev_script_runner_unref0_ (gpointer var)
{
#line 109 "../src/umockdev.vala"
	(var == NULL) ? NULL : (var = (umockdev_script_runner_unref (var), NULL));
#line 706 "umockdev.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 110 "../src/umockdev.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 714 "umockdev.c"
}

UMockdevTestbed*
umockdev_testbed_construct (GType object_type)
{
	UMockdevTestbed * self = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* bus_path = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* class_path = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	GHashFunc _tmp11_;
	GEqualFunc _tmp12_;
	GHashTable* _tmp13_;
	GHashFunc _tmp14_;
	GEqualFunc _tmp15_;
	GHashTable* _tmp16_;
	GHashFunc _tmp17_;
	GEqualFunc _tmp18_;
	GHashTable* _tmp19_;
	GMainContext* _tmp20_;
	GMainContext* _tmp21_;
	GMainLoop* _tmp22_;
	GMainLoop* _tmp23_;
	GThread* _tmp24_;
	UMockdevIoctlBase* handler = NULL;
	UMockdevIoctlBase* _tmp25_;
	gchar* sockpath = NULL;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	GMainContext* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 92 "../src/umockdev.vala"
	self = (UMockdevTestbed*) g_object_new (object_type, NULL);
#line 755 "umockdev.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 95 "../src/umockdev.vala"
		_tmp1_ = g_dir_make_tmp ("umockdev.XXXXXX", &_inner_error0_);
#line 95 "../src/umockdev.vala"
		_tmp0_ = _tmp1_;
#line 95 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 768 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 95 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 95 "../src/umockdev.vala"
			return NULL;
#line 777 "umockdev.c"
		}
#line 95 "../src/umockdev.vala"
		_tmp2_ = _tmp0_;
#line 95 "../src/umockdev.vala"
		_tmp0_ = NULL;
#line 95 "../src/umockdev.vala"
		_g_free0 (self->priv->root_dir);
#line 95 "../src/umockdev.vala"
		self->priv->root_dir = _tmp2_;
#line 94 "../src/umockdev.vala"
		_g_free0 (_tmp0_);
#line 789 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
#line 94 "../src/umockdev.vala"
		e = _inner_error0_;
#line 94 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 97 "../src/umockdev.vala"
		_tmp3_ = e->message;
#line 97 "../src/umockdev.vala"
		g_error ("umockdev.vala:97: Cannot create temporary directory: %s", _tmp3_);
#line 94 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 806 "umockdev.c"
	}
	__finally0:
#line 94 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 94 "../src/umockdev.vala"
		return NULL;
#line 817 "umockdev.c"
	}
#line 99 "../src/umockdev.vala"
	_tmp4_ = self->priv->root_dir;
#line 99 "../src/umockdev.vala"
	_tmp5_ = g_build_filename (_tmp4_, "sys", NULL);
#line 99 "../src/umockdev.vala"
	_g_free0 (self->priv->sys_dir);
#line 99 "../src/umockdev.vala"
	self->priv->sys_dir = _tmp5_;
#line 100 "../src/umockdev.vala"
	_tmp6_ = self->priv->sys_dir;
#line 100 "../src/umockdev.vala"
	umockdev_checked_mkdir (_tmp6_, 0755);
#line 103 "../src/umockdev.vala"
	_tmp7_ = self->priv->sys_dir;
#line 103 "../src/umockdev.vala"
	_tmp8_ = g_build_filename (_tmp7_, "bus", NULL);
#line 103 "../src/umockdev.vala"
	bus_path = _tmp8_;
#line 104 "../src/umockdev.vala"
	umockdev_checked_mkdir (bus_path, 0755);
#line 105 "../src/umockdev.vala"
	_tmp9_ = self->priv->sys_dir;
#line 105 "../src/umockdev.vala"
	_tmp10_ = g_build_filename (_tmp9_, "class", NULL);
#line 105 "../src/umockdev.vala"
	class_path = _tmp10_;
#line 106 "../src/umockdev.vala"
	umockdev_checked_mkdir (class_path, 0755);
#line 108 "../src/umockdev.vala"
	_tmp11_ = g_str_hash;
#line 108 "../src/umockdev.vala"
	_tmp12_ = g_str_equal;
#line 108 "../src/umockdev.vala"
	_tmp13_ = g_hash_table_new_full (_tmp11_, _tmp12_, _g_free0_, NULL);
#line 108 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->dev_fd);
#line 108 "../src/umockdev.vala"
	self->priv->dev_fd = _tmp13_;
#line 109 "../src/umockdev.vala"
	_tmp14_ = g_str_hash;
#line 109 "../src/umockdev.vala"
	_tmp15_ = g_str_equal;
#line 109 "../src/umockdev.vala"
	_tmp16_ = g_hash_table_new_full (_tmp14_, _tmp15_, _g_free0_, _umockdev_script_runner_unref0_);
#line 109 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->dev_script_runner);
#line 109 "../src/umockdev.vala"
	self->priv->dev_script_runner = _tmp16_;
#line 110 "../src/umockdev.vala"
	_tmp17_ = g_str_hash;
#line 110 "../src/umockdev.vala"
	_tmp18_ = g_str_equal;
#line 110 "../src/umockdev.vala"
	_tmp19_ = g_hash_table_new_full (_tmp17_, _tmp18_, _g_free0_, _g_object_unref0_);
#line 110 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->custom_handlers);
#line 110 "../src/umockdev.vala"
	self->priv->custom_handlers = _tmp19_;
#line 112 "../src/umockdev.vala"
	_tmp20_ = g_main_context_new ();
#line 112 "../src/umockdev.vala"
	_g_main_context_unref0 (self->priv->worker_ctx);
#line 112 "../src/umockdev.vala"
	self->priv->worker_ctx = _tmp20_;
#line 113 "../src/umockdev.vala"
	_tmp21_ = self->priv->worker_ctx;
#line 113 "../src/umockdev.vala"
	_tmp22_ = g_main_loop_new (_tmp21_, FALSE);
#line 113 "../src/umockdev.vala"
	_g_main_loop_unref0 (self->priv->worker_loop);
#line 113 "../src/umockdev.vala"
	self->priv->worker_loop = _tmp22_;
#line 114 "../src/umockdev.vala"
	_tmp23_ = self->priv->worker_loop;
#line 114 "../src/umockdev.vala"
	_tmp24_ = umockdev_create_worker_thread (_tmp23_);
#line 114 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->worker_thread);
#line 114 "../src/umockdev.vala"
	self->priv->worker_thread = _tmp24_;
#line 117 "../src/umockdev.vala"
	_tmp25_ = umockdev_ioctl_base_new ();
#line 117 "../src/umockdev.vala"
	handler = _tmp25_;
#line 118 "../src/umockdev.vala"
	_tmp26_ = self->priv->root_dir;
#line 118 "../src/umockdev.vala"
	_tmp27_ = g_build_filename (_tmp26_, "ioctl", "_default", NULL);
#line 118 "../src/umockdev.vala"
	sockpath = _tmp27_;
#line 119 "../src/umockdev.vala"
	_tmp28_ = self->priv->worker_ctx;
#line 119 "../src/umockdev.vala"
	umockdev_ioctl_base_register_path (handler, _tmp28_, "_default", sockpath);
#line 121 "../src/umockdev.vala"
	_tmp29_ = self->priv->root_dir;
#line 121 "../src/umockdev.vala"
	umockdev_utils_checked_setenv ("UMOCKDEV_DIR", _tmp29_);
#line 122 "../src/umockdev.vala"
	_tmp30_ = self->priv->root_dir;
#line 122 "../src/umockdev.vala"
	g_debug ("umockdev.vala:122: Created udev test bed %s", _tmp30_);
#line 92 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 92 "../src/umockdev.vala"
	_g_object_unref0 (handler);
#line 92 "../src/umockdev.vala"
	_g_free0 (class_path);
#line 92 "../src/umockdev.vala"
	_g_free0 (bus_path);
#line 92 "../src/umockdev.vala"
	return self;
#line 931 "umockdev.c"
}

UMockdevTestbed*
umockdev_testbed_new (void)
{
#line 92 "../src/umockdev.vala"
	return umockdev_testbed_construct (UMOCKDEV_TYPE_TESTBED);
#line 939 "umockdev.c"
}

/**
     * umockdev_testbed_get_root_dir:
     * @self: A #UMockdevTestbed.
     *
     * Get the root directory for the testbed. This is mostly useful for
     * setting up the "dev/" or "proc/" testbed directories in this root
     * directory. For getting the mocked "sys/" dir, use
     * #umockdev_testbed_get_sys_dir.
     *
     * Returns: The testbed's root directory.
     */
gchar*
umockdev_testbed_get_root_dir (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 167 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 169 "../src/umockdev.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 169 "../src/umockdev.vala"
	result = _tmp1_;
#line 169 "../src/umockdev.vala"
	return result;
#line 969 "umockdev.c"
}

/**
     * umockdev_testbed_get_sys_dir:
     * @self: A #UMockdevTestbed.
     *
     * Get the sysfs directory for the testbed.
     *
     * Returns: The testbed's sysfs directory.
     */
gchar*
umockdev_testbed_get_sys_dir (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 180 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 182 "../src/umockdev.vala"
	_tmp0_ = self->priv->sys_dir;
#line 182 "../src/umockdev.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 182 "../src/umockdev.vala"
	result = _tmp1_;
#line 182 "../src/umockdev.vala"
	return result;
#line 996 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name
     * @value: Attribute string value
     *
     * Set a text sysfs attribute for a device.
     */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1563 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1564 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1564 "glib-2.0.vapi"
	res_length1 = -1;
#line 1564 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1565 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1565 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1565 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1566 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1566 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1566 "glib-2.0.vapi"
	if (result_length1) {
#line 1566 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1042 "umockdev.c"
	}
#line 1566 "glib-2.0.vapi"
	result = _tmp2_;
#line 1566 "glib-2.0.vapi"
	return result;
#line 1048 "umockdev.c"
}

void
umockdev_testbed_set_attribute (UMockdevTestbed* self,
                                const gchar* devpath,
                                const gchar* name,
                                const gchar* value)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 194 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 194 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 194 "../src/umockdev.vala"
	g_return_if_fail (value != NULL);
#line 196 "../src/umockdev.vala"
	_tmp0_ = string_get_data (value, &_tmp1_);
#line 196 "../src/umockdev.vala"
	_tmp0__length1 = _tmp1_;
#line 196 "../src/umockdev.vala"
	_tmp2_ = _tmp0_;
#line 196 "../src/umockdev.vala"
	_tmp2__length1 = _tmp0__length1;
#line 196 "../src/umockdev.vala"
	umockdev_testbed_set_attribute_binary (self, devpath, name, _tmp2_, (gint) _tmp2__length1);
#line 1080 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute_binary:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name (may contain leading directories like
     *        "queue/rotational")
     * @value: Attribute binary value
     * @value_length1: Length of @value in bytes.
     *
     * Set a binary sysfs attribute for a device.
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 1110 "umockdev.c"
}

void
umockdev_testbed_set_attribute_binary (UMockdevTestbed* self,
                                       const gchar* devpath,
                                       const gchar* name,
                                       guint8* value,
                                       gint value_length1)
{
	gchar* attr_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 210 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 210 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 212 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 212 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, name, NULL);
#line 212 "../src/umockdev.vala"
	attr_path = _tmp1_;
#line 213 "../src/umockdev.vala"
	if (string_contains (name, "/")) {
#line 1138 "umockdev.c"
		gchar* d = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
#line 214 "../src/umockdev.vala"
		_tmp2_ = attr_path;
#line 214 "../src/umockdev.vala"
		_tmp3_ = g_path_get_dirname (_tmp2_);
#line 214 "../src/umockdev.vala"
		d = _tmp3_;
#line 215 "../src/umockdev.vala"
		_tmp4_ = d;
#line 215 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp4_, 0755);
#line 213 "../src/umockdev.vala"
		_g_free0 (d);
#line 1155 "umockdev.c"
	}
	{
		const gchar* _tmp5_;
#line 219 "../src/umockdev.vala"
		_tmp5_ = attr_path;
#line 219 "../src/umockdev.vala"
		g_file_set_contents (_tmp5_, (const char*) value, (gsize) value_length1, &_inner_error0_);
#line 219 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1167 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 219 "../src/umockdev.vala"
			_g_free0 (attr_path);
#line 219 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 219 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 219 "../src/umockdev.vala"
			return;
#line 1178 "umockdev.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_;
#line 218 "../src/umockdev.vala"
		e = _inner_error0_;
#line 218 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 221 "../src/umockdev.vala"
		_tmp6_ = e->message;
#line 221 "../src/umockdev.vala"
		g_error ("umockdev.vala:221: Cannot write attribute file: %s", _tmp6_);
#line 218 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 1196 "umockdev.c"
	}
	__finally0:
#line 218 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "../src/umockdev.vala"
		_g_free0 (attr_path);
#line 218 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 218 "../src/umockdev.vala"
		return;
#line 1209 "umockdev.c"
	}
#line 210 "../src/umockdev.vala"
	_g_free0 (attr_path);
#line 1213 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute_int:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name (may contain leading directories like
     *        "queue/rotational")
     * @value: Attribute integer value
     *
     * Set an integer sysfs attribute for a device.
     */
void
umockdev_testbed_set_attribute_int (UMockdevTestbed* self,
                                    const gchar* devpath,
                                    const gchar* name,
                                    gint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 235 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 235 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 237 "../src/umockdev.vala"
	_tmp0_ = g_strdup_printf ("%i", value);
#line 237 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 237 "../src/umockdev.vala"
	umockdev_testbed_set_attribute (self, devpath, name, _tmp1_);
#line 237 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 1248 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute_hex:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name
     * @value: Attribute integer value
     *
     * Set an integer sysfs attribute for a device. Set an integer udev
     * property for a device. @value is interpreted as a hexadecimal number.
     * For example, for value==31 this sets the attribute contents to "1f".
     */
void
umockdev_testbed_set_attribute_hex (UMockdevTestbed* self,
                                    const gchar* devpath,
                                    const gchar* name,
                                    guint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 251 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 251 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 253 "../src/umockdev.vala"
	_tmp0_ = g_strdup_printf ("%x", value);
#line 253 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 253 "../src/umockdev.vala"
	umockdev_testbed_set_attribute (self, devpath, name, _tmp1_);
#line 253 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 1284 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute_link:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name
     * @value: Attribute link target value
     *
     * Set a symlink sysfs attribute for a device; this is primarily important
     * for setting "driver" links.
     */
void
umockdev_testbed_set_attribute_link (UMockdevTestbed* self,
                                     const gchar* devpath,
                                     const gchar* name,
                                     const gchar* value)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* dir = NULL;
	gchar* _tmp2_;
#line 266 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 266 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 266 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 266 "../src/umockdev.vala"
	g_return_if_fail (value != NULL);
#line 268 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 268 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, name, NULL);
#line 268 "../src/umockdev.vala"
	path = _tmp1_;
#line 269 "../src/umockdev.vala"
	_tmp2_ = g_path_get_dirname (path);
#line 269 "../src/umockdev.vala"
	dir = _tmp2_;
#line 270 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (dir, 0755);
#line 271 "../src/umockdev.vala"
	if (symlink (value, path) < 0) {
#line 272 "../src/umockdev.vala"
		g_error ("umockdev.vala:272: Cannot create symlink %s: %m", path);
#line 1332 "umockdev.c"
	}
#line 266 "../src/umockdev.vala"
	_g_free0 (dir);
#line 266 "../src/umockdev.vala"
	_g_free0 (path);
#line 1338 "umockdev.c"
}

static gchar*
umockdev_testbed_get_attribute (UMockdevTestbed* self,
                                const gchar* devpath,
                                const gchar* name)
{
	gchar* read = NULL;
	gchar* attr_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 276 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 276 "../src/umockdev.vala"
	g_return_val_if_fail (devpath != NULL, NULL);
#line 276 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 278 "../src/umockdev.vala"
	read = NULL;
#line 279 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 279 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, name, NULL);
#line 279 "../src/umockdev.vala"
	attr_path = _tmp1_;
#line 1366 "umockdev.c"
	{
		gchar* _tmp2_ = NULL;
#line 282 "../src/umockdev.vala"
		g_file_get_contents (attr_path, &_tmp2_, NULL, &_inner_error0_);
#line 282 "../src/umockdev.vala"
		_g_free0 (read);
#line 282 "../src/umockdev.vala"
		read = _tmp2_;
#line 282 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1379 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 282 "../src/umockdev.vala"
			_g_free0 (attr_path);
#line 282 "../src/umockdev.vala"
			_g_free0 (read);
#line 282 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 282 "../src/umockdev.vala"
			return NULL;
#line 1392 "umockdev.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
#line 281 "../src/umockdev.vala"
		e = _inner_error0_;
#line 281 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 284 "../src/umockdev.vala"
		_tmp3_ = e->message;
#line 284 "../src/umockdev.vala"
		g_error ("umockdev.vala:284: Cannot read attribute file: %s", _tmp3_);
#line 281 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 1410 "umockdev.c"
	}
	__finally0:
#line 281 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 281 "../src/umockdev.vala"
		_g_free0 (attr_path);
#line 281 "../src/umockdev.vala"
		_g_free0 (read);
#line 281 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 281 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 281 "../src/umockdev.vala"
		return NULL;
#line 1425 "umockdev.c"
	}
#line 286 "../src/umockdev.vala"
	result = read;
#line 286 "../src/umockdev.vala"
	_g_free0 (attr_path);
#line 286 "../src/umockdev.vala"
	return result;
#line 1433 "umockdev.c"
}

/**
     * umockdev_testbed_get_property:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Property name
     *
     * Get a string udev property for a device. Note that this is mostly for
     * testing umockdev itself; for real application testing, use
     * libudev/gudev.
     *
     * Returns: property value, or %NULL if it does not exist
     */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 1468 "umockdev.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 1477 "umockdev.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1496 "umockdev.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1500 "umockdev.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1506 "umockdev.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1516 "umockdev.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1524 "umockdev.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1528 "umockdev.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 1534 "umockdev.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 1544 "umockdev.c"
}

gchar*
umockdev_testbed_get_property (UMockdevTestbed* self,
                               const gchar* devpath,
                               const gchar* name)
{
	gchar* uevent_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* ret = NULL;
	GFile* f = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	gchar* prefix = NULL;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 301 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 301 "../src/umockdev.vala"
	g_return_val_if_fail (devpath != NULL, NULL);
#line 301 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 303 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 303 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, "uevent", NULL);
#line 303 "../src/umockdev.vala"
	uevent_path = _tmp1_;
#line 304 "../src/umockdev.vala"
	ret = NULL;
#line 306 "../src/umockdev.vala"
	_tmp2_ = uevent_path;
#line 306 "../src/umockdev.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 306 "../src/umockdev.vala"
	f = _tmp3_;
#line 307 "../src/umockdev.vala"
	_tmp4_ = g_strconcat (name, "=", NULL);
#line 307 "../src/umockdev.vala"
	prefix = _tmp4_;
#line 1587 "umockdev.c"
	{
		GFileInputStream* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFileInputStream* _tmp7_;
		GDataInputStream* inp = NULL;
		GDataInputStream* _tmp8_;
		gchar* line = NULL;
		gsize len = 0UL;
		GDataInputStream* _tmp22_;
#line 309 "../src/umockdev.vala"
		_tmp6_ = f;
#line 309 "../src/umockdev.vala"
		_tmp7_ = g_file_read (_tmp6_, NULL, &_inner_error0_);
#line 309 "../src/umockdev.vala"
		_tmp5_ = _tmp7_;
#line 309 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1605 "umockdev.c"
			goto __catch0_g_error;
		}
#line 309 "../src/umockdev.vala"
		_tmp8_ = g_data_input_stream_new ((GInputStream*) _tmp5_);
#line 309 "../src/umockdev.vala"
		inp = _tmp8_;
#line 312 "../src/umockdev.vala"
		while (TRUE) {
#line 1614 "umockdev.c"
			gchar* _tmp9_ = NULL;
			GDataInputStream* _tmp10_;
			gsize _tmp11_ = 0UL;
			gchar* _tmp12_;
			gchar* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
#line 312 "../src/umockdev.vala"
			_tmp10_ = inp;
#line 312 "../src/umockdev.vala"
			_tmp12_ = g_data_input_stream_read_line (_tmp10_, &_tmp11_, NULL, &_inner_error0_);
#line 312 "../src/umockdev.vala"
			len = _tmp11_;
#line 312 "../src/umockdev.vala"
			_tmp9_ = _tmp12_;
#line 312 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 312 "../src/umockdev.vala"
				_g_free0 (line);
#line 312 "../src/umockdev.vala"
				_g_object_unref0 (inp);
#line 312 "../src/umockdev.vala"
				_g_object_unref0 (_tmp5_);
#line 1639 "umockdev.c"
				goto __catch0_g_error;
			}
#line 312 "../src/umockdev.vala"
			_tmp13_ = _tmp9_;
#line 312 "../src/umockdev.vala"
			_tmp9_ = NULL;
#line 312 "../src/umockdev.vala"
			_g_free0 (line);
#line 312 "../src/umockdev.vala"
			line = _tmp13_;
#line 312 "../src/umockdev.vala"
			_tmp14_ = line;
#line 312 "../src/umockdev.vala"
			if (!(_tmp14_ != NULL)) {
#line 312 "../src/umockdev.vala"
				_g_free0 (_tmp9_);
#line 312 "../src/umockdev.vala"
				break;
#line 1658 "umockdev.c"
			}
#line 313 "../src/umockdev.vala"
			_tmp15_ = line;
#line 313 "../src/umockdev.vala"
			_tmp16_ = prefix;
#line 313 "../src/umockdev.vala"
			if (g_str_has_prefix (_tmp15_, _tmp16_)) {
#line 1666 "umockdev.c"
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gchar* _tmp21_;
#line 314 "../src/umockdev.vala"
				_tmp17_ = line;
#line 314 "../src/umockdev.vala"
				_tmp18_ = prefix;
#line 314 "../src/umockdev.vala"
				_tmp19_ = strlen (_tmp18_);
#line 314 "../src/umockdev.vala"
				_tmp20_ = _tmp19_;
#line 314 "../src/umockdev.vala"
				_tmp21_ = string_substring (_tmp17_, (glong) _tmp20_, (glong) -1);
#line 314 "../src/umockdev.vala"
				_g_free0 (ret);
#line 314 "../src/umockdev.vala"
				ret = _tmp21_;
#line 315 "../src/umockdev.vala"
				_g_free0 (_tmp9_);
#line 315 "../src/umockdev.vala"
				break;
#line 1690 "umockdev.c"
			}
#line 312 "../src/umockdev.vala"
			_g_free0 (_tmp9_);
#line 1694 "umockdev.c"
		}
#line 318 "../src/umockdev.vala"
		_tmp22_ = inp;
#line 318 "../src/umockdev.vala"
		g_input_stream_close ((GInputStream*) _tmp22_, NULL, &_inner_error0_);
#line 318 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "../src/umockdev.vala"
			_g_free0 (line);
#line 318 "../src/umockdev.vala"
			_g_object_unref0 (inp);
#line 318 "../src/umockdev.vala"
			_g_object_unref0 (_tmp5_);
#line 1708 "umockdev.c"
			goto __catch0_g_error;
		}
#line 308 "../src/umockdev.vala"
		_g_free0 (line);
#line 308 "../src/umockdev.vala"
		_g_object_unref0 (inp);
#line 308 "../src/umockdev.vala"
		_g_object_unref0 (_tmp5_);
#line 1717 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp23_;
#line 308 "../src/umockdev.vala"
		e = _inner_error0_;
#line 308 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 320 "../src/umockdev.vala"
		_tmp23_ = e->message;
#line 320 "../src/umockdev.vala"
		g_error ("umockdev.vala:320: Cannot read uevent file: %s", _tmp23_);
#line 308 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 1734 "umockdev.c"
	}
	__finally0:
#line 308 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "../src/umockdev.vala"
		_g_free0 (prefix);
#line 308 "../src/umockdev.vala"
		_g_object_unref0 (f);
#line 308 "../src/umockdev.vala"
		_g_free0 (ret);
#line 308 "../src/umockdev.vala"
		_g_free0 (uevent_path);
#line 308 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 308 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 308 "../src/umockdev.vala"
		return NULL;
#line 1753 "umockdev.c"
	}
#line 323 "../src/umockdev.vala"
	result = ret;
#line 323 "../src/umockdev.vala"
	_g_free0 (prefix);
#line 323 "../src/umockdev.vala"
	_g_object_unref0 (f);
#line 323 "../src/umockdev.vala"
	_g_free0 (uevent_path);
#line 323 "../src/umockdev.vala"
	return result;
#line 1765 "umockdev.c"
}

/**
     * umockdev_testbed_set_property:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Property name
     * @value: Property string value
     *
     * Set a string udev property for a device.
     */
void
umockdev_testbed_set_property (UMockdevTestbed* self,
                               const gchar* devpath,
                               const gchar* name,
                               const gchar* value)
{
	gchar* uevent_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* props = NULL;
	gchar* _tmp2_;
	gchar* real_value = NULL;
	gboolean _tmp3_ = FALSE;
	GFile* f = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	gboolean existing = FALSE;
	gchar* prefix = NULL;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 335 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 335 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 335 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 335 "../src/umockdev.vala"
	g_return_if_fail (value != NULL);
#line 337 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 337 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, "uevent", NULL);
#line 337 "../src/umockdev.vala"
	uevent_path = _tmp1_;
#line 338 "../src/umockdev.vala"
	_tmp2_ = g_strdup ("");
#line 338 "../src/umockdev.vala"
	props = _tmp2_;
#line 342 "../src/umockdev.vala"
	if (g_strcmp0 (name, "DEVNAME") == 0) {
#line 342 "../src/umockdev.vala"
		_tmp3_ = g_str_has_prefix (value, "/dev/");
#line 1819 "umockdev.c"
	} else {
#line 342 "../src/umockdev.vala"
		_tmp3_ = FALSE;
#line 1823 "umockdev.c"
	}
#line 342 "../src/umockdev.vala"
	if (_tmp3_) {
#line 1827 "umockdev.c"
		gchar* _tmp4_;
#line 343 "../src/umockdev.vala"
		_tmp4_ = string_substring (value, (glong) 5, (glong) -1);
#line 343 "../src/umockdev.vala"
		_g_free0 (real_value);
#line 343 "../src/umockdev.vala"
		real_value = _tmp4_;
#line 1835 "umockdev.c"
	} else {
		gchar* _tmp5_;
#line 345 "../src/umockdev.vala"
		_tmp5_ = g_strdup (value);
#line 345 "../src/umockdev.vala"
		_g_free0 (real_value);
#line 345 "../src/umockdev.vala"
		real_value = _tmp5_;
#line 1844 "umockdev.c"
	}
#line 349 "../src/umockdev.vala"
	_tmp6_ = uevent_path;
#line 349 "../src/umockdev.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 349 "../src/umockdev.vala"
	f = _tmp7_;
#line 350 "../src/umockdev.vala"
	existing = FALSE;
#line 351 "../src/umockdev.vala"
	_tmp8_ = g_strconcat (name, "=", NULL);
#line 351 "../src/umockdev.vala"
	prefix = _tmp8_;
#line 1858 "umockdev.c"
	{
		GFileInputStream* _tmp9_ = NULL;
		GFile* _tmp10_;
		GFileInputStream* _tmp11_;
		GDataInputStream* inp = NULL;
		GDataInputStream* _tmp12_;
		gchar* line = NULL;
		gsize len = 0UL;
		GDataInputStream* _tmp34_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		guint8* _tmp45_;
		gint _tmp45__length1;
		gint _tmp46_ = 0;
		guint8* _tmp47_;
		gint _tmp47__length1;
#line 353 "../src/umockdev.vala"
		_tmp10_ = f;
#line 353 "../src/umockdev.vala"
		_tmp11_ = g_file_read (_tmp10_, NULL, &_inner_error0_);
#line 353 "../src/umockdev.vala"
		_tmp9_ = _tmp11_;
#line 353 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1883 "umockdev.c"
			goto __catch0_g_error;
		}
#line 353 "../src/umockdev.vala"
		_tmp12_ = g_data_input_stream_new ((GInputStream*) _tmp9_);
#line 353 "../src/umockdev.vala"
		inp = _tmp12_;
#line 356 "../src/umockdev.vala"
		while (TRUE) {
#line 1892 "umockdev.c"
			gchar* _tmp13_ = NULL;
			GDataInputStream* _tmp14_;
			gsize _tmp15_ = 0UL;
			gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
#line 356 "../src/umockdev.vala"
			_tmp14_ = inp;
#line 356 "../src/umockdev.vala"
			_tmp16_ = g_data_input_stream_read_line (_tmp14_, &_tmp15_, NULL, &_inner_error0_);
#line 356 "../src/umockdev.vala"
			len = _tmp15_;
#line 356 "../src/umockdev.vala"
			_tmp13_ = _tmp16_;
#line 356 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "../src/umockdev.vala"
				_g_free0 (line);
#line 356 "../src/umockdev.vala"
				_g_object_unref0 (inp);
#line 356 "../src/umockdev.vala"
				_g_object_unref0 (_tmp9_);
#line 1917 "umockdev.c"
				goto __catch0_g_error;
			}
#line 356 "../src/umockdev.vala"
			_tmp17_ = _tmp13_;
#line 356 "../src/umockdev.vala"
			_tmp13_ = NULL;
#line 356 "../src/umockdev.vala"
			_g_free0 (line);
#line 356 "../src/umockdev.vala"
			line = _tmp17_;
#line 356 "../src/umockdev.vala"
			_tmp18_ = line;
#line 356 "../src/umockdev.vala"
			if (!(_tmp18_ != NULL)) {
#line 356 "../src/umockdev.vala"
				_g_free0 (_tmp13_);
#line 356 "../src/umockdev.vala"
				break;
#line 1936 "umockdev.c"
			}
#line 357 "../src/umockdev.vala"
			_tmp19_ = line;
#line 357 "../src/umockdev.vala"
			_tmp20_ = prefix;
#line 357 "../src/umockdev.vala"
			if (g_str_has_prefix (_tmp19_, _tmp20_)) {
#line 1944 "umockdev.c"
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 358 "../src/umockdev.vala"
				existing = TRUE;
#line 359 "../src/umockdev.vala"
				_tmp21_ = props;
#line 359 "../src/umockdev.vala"
				_tmp22_ = prefix;
#line 359 "../src/umockdev.vala"
				_tmp23_ = real_value;
#line 359 "../src/umockdev.vala"
				_tmp24_ = g_strconcat (_tmp22_, _tmp23_, NULL);
#line 359 "../src/umockdev.vala"
				_tmp25_ = _tmp24_;
#line 359 "../src/umockdev.vala"
				_tmp26_ = g_strconcat (_tmp25_, "\n", NULL);
#line 359 "../src/umockdev.vala"
				_tmp27_ = _tmp26_;
#line 359 "../src/umockdev.vala"
				_tmp28_ = g_strconcat (_tmp21_, _tmp27_, NULL);
#line 359 "../src/umockdev.vala"
				_g_free0 (props);
#line 359 "../src/umockdev.vala"
				props = _tmp28_;
#line 359 "../src/umockdev.vala"
				_g_free0 (_tmp27_);
#line 359 "../src/umockdev.vala"
				_g_free0 (_tmp25_);
#line 1979 "umockdev.c"
			} else {
				const gchar* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
#line 361 "../src/umockdev.vala"
				_tmp29_ = props;
#line 361 "../src/umockdev.vala"
				_tmp30_ = line;
#line 361 "../src/umockdev.vala"
				_tmp31_ = g_strconcat (_tmp30_, "\n", NULL);
#line 361 "../src/umockdev.vala"
				_tmp32_ = _tmp31_;
#line 361 "../src/umockdev.vala"
				_tmp33_ = g_strconcat (_tmp29_, _tmp32_, NULL);
#line 361 "../src/umockdev.vala"
				_g_free0 (props);
#line 361 "../src/umockdev.vala"
				props = _tmp33_;
#line 361 "../src/umockdev.vala"
				_g_free0 (_tmp32_);
#line 2002 "umockdev.c"
			}
#line 356 "../src/umockdev.vala"
			_g_free0 (_tmp13_);
#line 2006 "umockdev.c"
		}
#line 364 "../src/umockdev.vala"
		_tmp34_ = inp;
#line 364 "../src/umockdev.vala"
		g_input_stream_close ((GInputStream*) _tmp34_, NULL, &_inner_error0_);
#line 364 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 364 "../src/umockdev.vala"
			_g_free0 (line);
#line 364 "../src/umockdev.vala"
			_g_object_unref0 (inp);
#line 364 "../src/umockdev.vala"
			_g_object_unref0 (_tmp9_);
#line 2020 "umockdev.c"
			goto __catch0_g_error;
		}
#line 367 "../src/umockdev.vala"
		if (!existing) {
#line 2025 "umockdev.c"
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
#line 368 "../src/umockdev.vala"
			_tmp35_ = props;
#line 368 "../src/umockdev.vala"
			_tmp36_ = prefix;
#line 368 "../src/umockdev.vala"
			_tmp37_ = real_value;
#line 368 "../src/umockdev.vala"
			_tmp38_ = g_strconcat (_tmp36_, _tmp37_, NULL);
#line 368 "../src/umockdev.vala"
			_tmp39_ = _tmp38_;
#line 368 "../src/umockdev.vala"
			_tmp40_ = g_strconcat (_tmp39_, "\n", NULL);
#line 368 "../src/umockdev.vala"
			_tmp41_ = _tmp40_;
#line 368 "../src/umockdev.vala"
			_tmp42_ = g_strconcat (_tmp35_, _tmp41_, NULL);
#line 368 "../src/umockdev.vala"
			_g_free0 (props);
#line 368 "../src/umockdev.vala"
			props = _tmp42_;
#line 368 "../src/umockdev.vala"
			_g_free0 (_tmp41_);
#line 368 "../src/umockdev.vala"
			_g_free0 (_tmp39_);
#line 2058 "umockdev.c"
		}
#line 371 "../src/umockdev.vala"
		_tmp43_ = uevent_path;
#line 371 "../src/umockdev.vala"
		_tmp44_ = props;
#line 371 "../src/umockdev.vala"
		_tmp45_ = string_get_data (_tmp44_, &_tmp46_);
#line 371 "../src/umockdev.vala"
		_tmp45__length1 = _tmp46_;
#line 371 "../src/umockdev.vala"
		_tmp47_ = _tmp45_;
#line 371 "../src/umockdev.vala"
		_tmp47__length1 = _tmp45__length1;
#line 371 "../src/umockdev.vala"
		g_file_set_contents (_tmp43_, (const char*) _tmp47_, (gsize) _tmp47__length1, &_inner_error0_);
#line 371 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 371 "../src/umockdev.vala"
			_g_free0 (line);
#line 371 "../src/umockdev.vala"
			_g_object_unref0 (inp);
#line 371 "../src/umockdev.vala"
			_g_object_unref0 (_tmp9_);
#line 2082 "umockdev.c"
			goto __catch0_g_error;
		}
#line 352 "../src/umockdev.vala"
		_g_free0 (line);
#line 352 "../src/umockdev.vala"
		_g_object_unref0 (inp);
#line 352 "../src/umockdev.vala"
		_g_object_unref0 (_tmp9_);
#line 2091 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp48_;
#line 352 "../src/umockdev.vala"
		e = _inner_error0_;
#line 352 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 373 "../src/umockdev.vala"
		_tmp48_ = e->message;
#line 373 "../src/umockdev.vala"
		g_error ("umockdev.vala:373: Cannot update uevent file: %s", _tmp48_);
#line 352 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 2108 "umockdev.c"
	}
	__finally0:
#line 352 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 352 "../src/umockdev.vala"
		_g_free0 (prefix);
#line 352 "../src/umockdev.vala"
		_g_object_unref0 (f);
#line 352 "../src/umockdev.vala"
		_g_free0 (real_value);
#line 352 "../src/umockdev.vala"
		_g_free0 (props);
#line 352 "../src/umockdev.vala"
		_g_free0 (uevent_path);
#line 352 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 352 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 352 "../src/umockdev.vala"
		return;
#line 2129 "umockdev.c"
	}
#line 335 "../src/umockdev.vala"
	_g_free0 (prefix);
#line 335 "../src/umockdev.vala"
	_g_object_unref0 (f);
#line 335 "../src/umockdev.vala"
	_g_free0 (real_value);
#line 335 "../src/umockdev.vala"
	_g_free0 (props);
#line 335 "../src/umockdev.vala"
	_g_free0 (uevent_path);
#line 2141 "umockdev.c"
}

/**
     * umockdev_testbed_set_property_int:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Property name
     * @value: Property integer value
     *
     * Set an integer udev property for a device.
     */
void
umockdev_testbed_set_property_int (UMockdevTestbed* self,
                                   const gchar* devpath,
                                   const gchar* name,
                                   gint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 386 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 386 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 388 "../src/umockdev.vala"
	_tmp0_ = g_strdup_printf ("%i", value);
#line 388 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 388 "../src/umockdev.vala"
	umockdev_testbed_set_property (self, devpath, name, _tmp1_);
#line 388 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 2175 "umockdev.c"
}

/**
     * umockdev_testbed_set_property_hex:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Property name
     * @value: Property integer value
     *
     * Set an integer udev property for a device. @value is interpreted as a
     * hexadecimal number. For example, for value==31 this sets the property's
     * value to "1f".
     */
void
umockdev_testbed_set_property_hex (UMockdevTestbed* self,
                                   const gchar* devpath,
                                   const gchar* name,
                                   guint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 402 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 402 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 402 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 404 "../src/umockdev.vala"
	_tmp0_ = g_strdup_printf ("%x", value);
#line 404 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 404 "../src/umockdev.vala"
	umockdev_testbed_set_property (self, devpath, name, _tmp1_);
#line 404 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 2211 "umockdev.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2235 "umockdev.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 2243 "umockdev.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 2249 "umockdev.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 2271 "umockdev.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2293 "umockdev.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2297 "umockdev.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2303 "umockdev.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2307 "umockdev.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2311 "umockdev.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 2319 "umockdev.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2347 "umockdev.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 2356 "umockdev.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2370 "umockdev.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 2379 "umockdev.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 2393 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2402 "umockdev.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 2411 "umockdev.c"
}

static gchar*
umockdev_testbed_add_devicev_no_uevent (UMockdevTestbed* self,
                                        const gchar* subsystem,
                                        const gchar* name,
                                        const gchar* parent,
                                        gchar** attributes,
                                        gchar** properties)
{
	gchar* dev_path = NULL;
	gchar* dev_node = NULL;
	gchar* dev_dir = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gchar* dev_path_no_sys = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* props = NULL;
	gchar* _tmp64_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	gchar* result;
#line 407 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 407 "../src/umockdev.vala"
	g_return_val_if_fail (subsystem != NULL, NULL);
#line 407 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 412 "../src/umockdev.vala"
	dev_node = NULL;
#line 414 "../src/umockdev.vala"
	if (parent != NULL) {
#line 2450 "umockdev.c"
		gchar* _tmp0_;
#line 415 "../src/umockdev.vala"
		if (!g_str_has_prefix (parent, "/sys/")) {
#line 416 "../src/umockdev.vala"
			g_critical ("umockdev.vala:416: add_devicev(): parent device %s does not start with" \
" /sys/", parent);
#line 417 "../src/umockdev.vala"
			result = NULL;
#line 417 "../src/umockdev.vala"
			_g_free0 (dev_node);
#line 417 "../src/umockdev.vala"
			_g_free0 (dev_path);
#line 417 "../src/umockdev.vala"
			return result;
#line 2464 "umockdev.c"
		}
#line 419 "../src/umockdev.vala"
		if (!g_file_test (parent, G_FILE_TEST_IS_DIR)) {
#line 420 "../src/umockdev.vala"
			g_critical ("umockdev.vala:420: add_devicev(): parent device %s does not exist", parent);
#line 421 "../src/umockdev.vala"
			result = NULL;
#line 421 "../src/umockdev.vala"
			_g_free0 (dev_node);
#line 421 "../src/umockdev.vala"
			_g_free0 (dev_path);
#line 421 "../src/umockdev.vala"
			return result;
#line 2478 "umockdev.c"
		}
#line 423 "../src/umockdev.vala"
		_tmp0_ = g_build_filename (parent, name, NULL);
#line 423 "../src/umockdev.vala"
		_g_free0 (dev_path);
#line 423 "../src/umockdev.vala"
		dev_path = _tmp0_;
#line 2486 "umockdev.c"
	} else {
		gchar* _tmp1_;
#line 425 "../src/umockdev.vala"
		_tmp1_ = g_build_filename ("/sys/devices", name, NULL);
#line 425 "../src/umockdev.vala"
		_g_free0 (dev_path);
#line 425 "../src/umockdev.vala"
		dev_path = _tmp1_;
#line 2495 "umockdev.c"
	}
#line 426 "../src/umockdev.vala"
	_tmp2_ = self->priv->root_dir;
#line 426 "../src/umockdev.vala"
	_tmp3_ = dev_path;
#line 426 "../src/umockdev.vala"
	_tmp4_ = g_build_filename (_tmp2_, _tmp3_, NULL);
#line 426 "../src/umockdev.vala"
	dev_dir = _tmp4_;
#line 429 "../src/umockdev.vala"
	_tmp6_ = dev_dir;
#line 429 "../src/umockdev.vala"
	if (g_file_test (_tmp6_, G_FILE_TEST_EXISTS)) {
#line 2509 "umockdev.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 430 "../src/umockdev.vala"
		_tmp7_ = dev_dir;
#line 430 "../src/umockdev.vala"
		_tmp8_ = g_build_filename (_tmp7_, "uevent", NULL);
#line 430 "../src/umockdev.vala"
		_tmp9_ = _tmp8_;
#line 430 "../src/umockdev.vala"
		_tmp5_ = g_file_test (_tmp9_, G_FILE_TEST_EXISTS);
#line 430 "../src/umockdev.vala"
		_g_free0 (_tmp9_);
#line 2523 "umockdev.c"
	} else {
#line 429 "../src/umockdev.vala"
		_tmp5_ = FALSE;
#line 2527 "umockdev.c"
	}
#line 429 "../src/umockdev.vala"
	if (_tmp5_) {
#line 2531 "umockdev.c"
		const gchar* _tmp10_;
#line 431 "../src/umockdev.vala"
		_tmp10_ = dev_dir;
#line 431 "../src/umockdev.vala"
		g_error ("umockdev.vala:431: device %s already exists", _tmp10_);
#line 2537 "umockdev.c"
	}
#line 433 "../src/umockdev.vala"
	_tmp11_ = dev_path;
#line 433 "../src/umockdev.vala"
	_tmp12_ = dev_path;
#line 433 "../src/umockdev.vala"
	_tmp13_ = string_substring (_tmp11_, (glong) string_index_of (_tmp12_, "/devices/", 0), (glong) -1);
#line 433 "../src/umockdev.vala"
	dev_path_no_sys = _tmp13_;
#line 436 "../src/umockdev.vala"
	_tmp14_ = dev_dir;
#line 436 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp14_, 0755);
#line 437 "../src/umockdev.vala"
	if (!umockdev_testbed_subsystem_is_bus (subsystem)) {
#line 2553 "umockdev.c"
		gchar* class_dir = NULL;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 439 "../src/umockdev.vala"
		_tmp15_ = self->priv->sys_dir;
#line 439 "../src/umockdev.vala"
		_tmp16_ = g_build_filename (_tmp15_, "class", subsystem, NULL);
#line 439 "../src/umockdev.vala"
		class_dir = _tmp16_;
#line 440 "../src/umockdev.vala"
		_tmp17_ = class_dir;
#line 440 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp17_, 0755);
#line 443 "../src/umockdev.vala"
		_tmp18_ = dev_path;
#line 443 "../src/umockdev.vala"
		_tmp19_ = umockdev_make_dotdots (_tmp18_);
#line 443 "../src/umockdev.vala"
		_tmp20_ = _tmp19_;
#line 443 "../src/umockdev.vala"
		_tmp21_ = g_build_filename (_tmp20_, "class", subsystem, NULL);
#line 443 "../src/umockdev.vala"
		_tmp22_ = _tmp21_;
#line 443 "../src/umockdev.vala"
		_tmp23_ = dev_dir;
#line 443 "../src/umockdev.vala"
		_tmp24_ = g_build_filename (_tmp23_, "subsystem", NULL);
#line 443 "../src/umockdev.vala"
		_tmp25_ = _tmp24_;
#line 443 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp22_, _tmp25_) == 0, "FileUtils.symlink(Path.build_filename(make_dotdots(dev_path), \"class\", subsystem),                                      Path.build_filename(dev_dir, \"subsystem\")) == 0");
#line 443 "../src/umockdev.vala"
		_g_free0 (_tmp25_);
#line 443 "../src/umockdev.vala"
		_g_free0 (_tmp22_);
#line 443 "../src/umockdev.vala"
		_g_free0 (_tmp20_);
#line 449 "../src/umockdev.vala"
		_tmp26_ = dev_path_no_sys;
#line 449 "../src/umockdev.vala"
		_tmp27_ = g_build_filename ("..", "..", _tmp26_, NULL);
#line 449 "../src/umockdev.vala"
		_tmp28_ = _tmp27_;
#line 449 "../src/umockdev.vala"
		_tmp29_ = class_dir;
#line 449 "../src/umockdev.vala"
		_tmp30_ = g_path_get_basename (name);
#line 449 "../src/umockdev.vala"
		_tmp31_ = _tmp30_;
#line 449 "../src/umockdev.vala"
		_tmp32_ = g_build_filename (_tmp29_, _tmp31_, NULL);
#line 449 "../src/umockdev.vala"
		_tmp33_ = _tmp32_;
#line 449 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp28_, _tmp33_) == 0, "FileUtils.symlink(Path.build_filename(\"..\", \"..\", dev_path_no_sys),                                      Path.build_filename(class_dir, Path.get_basename(name))) == 0");
#line 449 "../src/umockdev.vala"
		_g_free0 (_tmp33_);
#line 449 "../src/umockdev.vala"
		_g_free0 (_tmp31_);
#line 449 "../src/umockdev.vala"
		_g_free0 (_tmp28_);
#line 437 "../src/umockdev.vala"
		_g_free0 (class_dir);
#line 2634 "umockdev.c"
	} else {
		gchar* bus_dir = NULL;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 453 "../src/umockdev.vala"
		_tmp34_ = self->priv->sys_dir;
#line 453 "../src/umockdev.vala"
		_tmp35_ = g_build_filename (_tmp34_, "bus", subsystem, "devices", NULL);
#line 453 "../src/umockdev.vala"
		bus_dir = _tmp35_;
#line 454 "../src/umockdev.vala"
		_tmp36_ = bus_dir;
#line 454 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp36_, 0755);
#line 455 "../src/umockdev.vala"
		_tmp37_ = dev_path_no_sys;
#line 455 "../src/umockdev.vala"
		_tmp38_ = g_build_filename ("..", "..", "..", _tmp37_, NULL);
#line 455 "../src/umockdev.vala"
		_tmp39_ = _tmp38_;
#line 455 "../src/umockdev.vala"
		_tmp40_ = bus_dir;
#line 455 "../src/umockdev.vala"
		_tmp41_ = g_path_get_basename (name);
#line 455 "../src/umockdev.vala"
		_tmp42_ = _tmp41_;
#line 455 "../src/umockdev.vala"
		_tmp43_ = g_build_filename (_tmp40_, _tmp42_, NULL);
#line 455 "../src/umockdev.vala"
		_tmp44_ = _tmp43_;
#line 455 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp39_, _tmp44_) == 0, "FileUtils.symlink(Path.build_filename(\"..\", \"..\", \"..\", dev_path_no_sys),                                      Path.build_filename(bus_dir, Path.get_basename(name))) == 0");
#line 455 "../src/umockdev.vala"
		_g_free0 (_tmp44_);
#line 455 "../src/umockdev.vala"
		_g_free0 (_tmp42_);
#line 455 "../src/umockdev.vala"
		_g_free0 (_tmp39_);
#line 459 "../src/umockdev.vala"
		_tmp45_ = dev_path;
#line 459 "../src/umockdev.vala"
		_tmp46_ = umockdev_make_dotdots (_tmp45_);
#line 459 "../src/umockdev.vala"
		_tmp47_ = _tmp46_;
#line 459 "../src/umockdev.vala"
		_tmp48_ = g_build_filename (_tmp47_, "bus", subsystem, NULL);
#line 459 "../src/umockdev.vala"
		_tmp49_ = _tmp48_;
#line 459 "../src/umockdev.vala"
		_tmp50_ = dev_dir;
#line 459 "../src/umockdev.vala"
		_tmp51_ = g_build_filename (_tmp50_, "subsystem", NULL);
#line 459 "../src/umockdev.vala"
		_tmp52_ = _tmp51_;
#line 459 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp49_, _tmp52_) == 0, "FileUtils.symlink(Path.build_filename(make_dotdots(dev_path), \"bus\", subsystem),                                      Path.build_filename(dev_dir, \"subsystem\")) == 0");
#line 459 "../src/umockdev.vala"
		_g_free0 (_tmp52_);
#line 459 "../src/umockdev.vala"
		_g_free0 (_tmp49_);
#line 459 "../src/umockdev.vala"
		_g_free0 (_tmp47_);
#line 437 "../src/umockdev.vala"
		_g_free0 (bus_dir);
#line 2716 "umockdev.c"
	}
#line 464 "../src/umockdev.vala"
	if (g_strcmp0 (subsystem, "block") == 0) {
#line 2720 "umockdev.c"
		gchar* block_dir = NULL;
		const gchar* _tmp53_;
		gchar* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
#line 465 "../src/umockdev.vala"
		_tmp53_ = self->priv->sys_dir;
#line 465 "../src/umockdev.vala"
		_tmp54_ = g_build_filename (_tmp53_, "block", NULL);
#line 465 "../src/umockdev.vala"
		block_dir = _tmp54_;
#line 466 "../src/umockdev.vala"
		_tmp55_ = block_dir;
#line 466 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp55_, 0755);
#line 467 "../src/umockdev.vala"
		_tmp56_ = dev_path_no_sys;
#line 467 "../src/umockdev.vala"
		_tmp57_ = g_build_filename ("..", _tmp56_, NULL);
#line 467 "../src/umockdev.vala"
		_tmp58_ = _tmp57_;
#line 467 "../src/umockdev.vala"
		_tmp59_ = block_dir;
#line 467 "../src/umockdev.vala"
		_tmp60_ = g_path_get_basename (name);
#line 467 "../src/umockdev.vala"
		_tmp61_ = _tmp60_;
#line 467 "../src/umockdev.vala"
		_tmp62_ = g_build_filename (_tmp59_, _tmp61_, NULL);
#line 467 "../src/umockdev.vala"
		_tmp63_ = _tmp62_;
#line 467 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp58_, _tmp63_) == 0, "FileUtils.symlink(Path.build_filename(\"..\", dev_path_no_sys),                                      Path.build_filename(block_dir, Path.get_basename(name))) == 0");
#line 467 "../src/umockdev.vala"
		_g_free0 (_tmp63_);
#line 467 "../src/umockdev.vala"
		_g_free0 (_tmp61_);
#line 467 "../src/umockdev.vala"
		_g_free0 (_tmp58_);
#line 464 "../src/umockdev.vala"
		_g_free0 (block_dir);
#line 2769 "umockdev.c"
	}
#line 472 "../src/umockdev.vala"
	_tmp64_ = g_strdup ("");
#line 472 "../src/umockdev.vala"
	props = _tmp64_;
#line 2775 "umockdev.c"
	{
		gint i = 0;
#line 473 "../src/umockdev.vala"
		i = 0;
#line 2780 "umockdev.c"
		{
			gboolean _tmp65_ = FALSE;
#line 473 "../src/umockdev.vala"
			_tmp65_ = TRUE;
#line 473 "../src/umockdev.vala"
			while (TRUE) {
#line 2787 "umockdev.c"
				gboolean _tmp66_ = FALSE;
				const gchar* _tmp67_;
#line 473 "../src/umockdev.vala"
				if (!_tmp65_) {
#line 473 "../src/umockdev.vala"
					i += 2;
#line 2794 "umockdev.c"
				}
#line 473 "../src/umockdev.vala"
				_tmp65_ = FALSE;
#line 473 "../src/umockdev.vala"
				if (!(i < (_vala_array_length (properties) - 1))) {
#line 473 "../src/umockdev.vala"
					break;
#line 2802 "umockdev.c"
				}
#line 475 "../src/umockdev.vala"
				_tmp67_ = properties[i];
#line 475 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp67_, "DEVNAME") == 0) {
#line 2808 "umockdev.c"
					const gchar* _tmp68_;
#line 475 "../src/umockdev.vala"
					_tmp68_ = properties[i + 1];
#line 475 "../src/umockdev.vala"
					_tmp66_ = g_str_has_prefix (_tmp68_, "/dev/");
#line 2814 "umockdev.c"
				} else {
#line 475 "../src/umockdev.vala"
					_tmp66_ = FALSE;
#line 2818 "umockdev.c"
				}
#line 475 "../src/umockdev.vala"
				if (_tmp66_) {
#line 2822 "umockdev.c"
					const gchar* _tmp69_;
					gchar* _tmp70_;
					const gchar* _tmp71_;
					const gchar* _tmp72_;
					gchar* _tmp73_;
					gchar* _tmp74_;
					gchar* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
#line 476 "../src/umockdev.vala"
					_tmp69_ = properties[i + 1];
#line 476 "../src/umockdev.vala"
					_tmp70_ = string_substring (_tmp69_, (glong) 5, (glong) -1);
#line 476 "../src/umockdev.vala"
					_g_free0 (dev_node);
#line 476 "../src/umockdev.vala"
					dev_node = _tmp70_;
#line 477 "../src/umockdev.vala"
					_tmp71_ = props;
#line 477 "../src/umockdev.vala"
					_tmp72_ = dev_node;
#line 477 "../src/umockdev.vala"
					_tmp73_ = g_strconcat ("DEVNAME=", _tmp72_, NULL);
#line 477 "../src/umockdev.vala"
					_tmp74_ = _tmp73_;
#line 477 "../src/umockdev.vala"
					_tmp75_ = g_strconcat (_tmp74_, "\n", NULL);
#line 477 "../src/umockdev.vala"
					_tmp76_ = _tmp75_;
#line 477 "../src/umockdev.vala"
					_tmp77_ = g_strconcat (_tmp71_, _tmp76_, NULL);
#line 477 "../src/umockdev.vala"
					_g_free0 (props);
#line 477 "../src/umockdev.vala"
					props = _tmp77_;
#line 477 "../src/umockdev.vala"
					_g_free0 (_tmp76_);
#line 477 "../src/umockdev.vala"
					_g_free0 (_tmp74_);
#line 2862 "umockdev.c"
				} else {
					const gchar* _tmp78_;
					const gchar* _tmp79_;
					gchar* _tmp80_;
					gchar* _tmp81_;
					const gchar* _tmp82_;
					gchar* _tmp83_;
					gchar* _tmp84_;
					gchar* _tmp85_;
					gchar* _tmp86_;
					gchar* _tmp87_;
#line 479 "../src/umockdev.vala"
					_tmp78_ = props;
#line 479 "../src/umockdev.vala"
					_tmp79_ = properties[i];
#line 479 "../src/umockdev.vala"
					_tmp80_ = g_strconcat (_tmp79_, "=", NULL);
#line 479 "../src/umockdev.vala"
					_tmp81_ = _tmp80_;
#line 479 "../src/umockdev.vala"
					_tmp82_ = properties[i + 1];
#line 479 "../src/umockdev.vala"
					_tmp83_ = g_strconcat (_tmp81_, _tmp82_, NULL);
#line 479 "../src/umockdev.vala"
					_tmp84_ = _tmp83_;
#line 479 "../src/umockdev.vala"
					_tmp85_ = g_strconcat (_tmp84_, "\n", NULL);
#line 479 "../src/umockdev.vala"
					_tmp86_ = _tmp85_;
#line 479 "../src/umockdev.vala"
					_tmp87_ = g_strconcat (_tmp78_, _tmp86_, NULL);
#line 479 "../src/umockdev.vala"
					_g_free0 (props);
#line 479 "../src/umockdev.vala"
					props = _tmp87_;
#line 479 "../src/umockdev.vala"
					_g_free0 (_tmp86_);
#line 479 "../src/umockdev.vala"
					_g_free0 (_tmp84_);
#line 479 "../src/umockdev.vala"
					_g_free0 (_tmp81_);
#line 2904 "umockdev.c"
				}
			}
		}
	}
#line 481 "../src/umockdev.vala"
	if ((_vala_array_length (properties) % 2) != 0) {
#line 2911 "umockdev.c"
		const gchar* _tmp88_;
#line 482 "../src/umockdev.vala"
		_tmp88_ = properties[_vala_array_length (properties) - 1];
#line 482 "../src/umockdev.vala"
		g_warning ("umockdev.vala:482: add_devicev: Ignoring property key '%s' without val" \
"ue", _tmp88_);
#line 2917 "umockdev.c"
	}
#line 483 "../src/umockdev.vala"
	_tmp89_ = dev_path;
#line 483 "../src/umockdev.vala"
	_tmp90_ = props;
#line 483 "../src/umockdev.vala"
	umockdev_testbed_set_attribute (self, _tmp89_, "uevent", _tmp90_);
#line 2925 "umockdev.c"
	{
		gint i = 0;
#line 486 "../src/umockdev.vala"
		i = 0;
#line 2930 "umockdev.c"
		{
			gboolean _tmp91_ = FALSE;
#line 486 "../src/umockdev.vala"
			_tmp91_ = TRUE;
#line 486 "../src/umockdev.vala"
			while (TRUE) {
#line 2937 "umockdev.c"
				const gchar* _tmp92_;
				const gchar* _tmp93_;
				const gchar* _tmp94_;
				gboolean _tmp95_ = FALSE;
				const gchar* _tmp96_;
#line 486 "../src/umockdev.vala"
				if (!_tmp91_) {
#line 486 "../src/umockdev.vala"
					i += 2;
#line 2947 "umockdev.c"
				}
#line 486 "../src/umockdev.vala"
				_tmp91_ = FALSE;
#line 486 "../src/umockdev.vala"
				if (!(i < (_vala_array_length (attributes) - 1))) {
#line 486 "../src/umockdev.vala"
					break;
#line 2955 "umockdev.c"
				}
#line 487 "../src/umockdev.vala"
				_tmp92_ = dev_path;
#line 487 "../src/umockdev.vala"
				_tmp93_ = attributes[i];
#line 487 "../src/umockdev.vala"
				_tmp94_ = attributes[i + 1];
#line 487 "../src/umockdev.vala"
				umockdev_testbed_set_attribute (self, _tmp92_, _tmp93_, _tmp94_);
#line 488 "../src/umockdev.vala"
				_tmp96_ = attributes[i];
#line 488 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp96_, "dev") == 0) {
#line 2969 "umockdev.c"
					const gchar* _tmp97_;
#line 488 "../src/umockdev.vala"
					_tmp97_ = dev_node;
#line 488 "../src/umockdev.vala"
					_tmp95_ = _tmp97_ != NULL;
#line 2975 "umockdev.c"
				} else {
#line 488 "../src/umockdev.vala"
					_tmp95_ = FALSE;
#line 2979 "umockdev.c"
				}
#line 488 "../src/umockdev.vala"
				if (_tmp95_) {
#line 2983 "umockdev.c"
					gchar* val = NULL;
					const gchar* _tmp98_;
					gchar* _tmp99_;
					gchar* infodir = NULL;
					const gchar* _tmp100_;
					gchar* _tmp101_;
					const gchar* _tmp102_;
					const gchar* _tmp103_;
					const gchar* _tmp104_;
					const gchar* _tmp105_;
					gchar* _tmp106_;
					gchar* _tmp107_;
					gchar* _tmp108_;
					gchar* _tmp109_;
					const gchar* _tmp110_ = NULL;
					const gchar* _tmp111_;
					gchar* sysdev_dir = NULL;
					const gchar* _tmp112_;
					gchar* _tmp113_;
					const gchar* _tmp114_;
					gchar* dest = NULL;
					const gchar* _tmp115_;
					const gchar* _tmp116_;
					gchar* _tmp117_;
					const gchar* _tmp118_;
#line 489 "../src/umockdev.vala"
					_tmp98_ = attributes[i + 1];
#line 489 "../src/umockdev.vala"
					_tmp99_ = string_strip (_tmp98_);
#line 489 "../src/umockdev.vala"
					val = _tmp99_;
#line 491 "../src/umockdev.vala"
					_tmp100_ = self->priv->root_dir;
#line 491 "../src/umockdev.vala"
					_tmp101_ = g_build_filename (_tmp100_, "dev", ".node", NULL);
#line 491 "../src/umockdev.vala"
					infodir = _tmp101_;
#line 492 "../src/umockdev.vala"
					_tmp102_ = infodir;
#line 492 "../src/umockdev.vala"
					umockdev_checked_mkdir_with_parents (_tmp102_, 0755);
#line 493 "../src/umockdev.vala"
					_tmp103_ = val;
#line 493 "../src/umockdev.vala"
					_tmp104_ = infodir;
#line 493 "../src/umockdev.vala"
					_tmp105_ = dev_node;
#line 493 "../src/umockdev.vala"
					_tmp106_ = string_replace (_tmp105_, "/", "_");
#line 493 "../src/umockdev.vala"
					_tmp107_ = _tmp106_;
#line 493 "../src/umockdev.vala"
					_tmp108_ = g_build_filename (_tmp104_, _tmp107_, NULL);
#line 493 "../src/umockdev.vala"
					_tmp109_ = _tmp108_;
#line 493 "../src/umockdev.vala"
					_vala_assert (symlink (_tmp103_, _tmp109_) == 0, "FileUtils.symlink(val, Path.build_filename(infodir, dev_node.replace(\"/\", \"_\"))) == 0");
#line 493 "../src/umockdev.vala"
					_g_free0 (_tmp109_);
#line 493 "../src/umockdev.vala"
					_g_free0 (_tmp107_);
#line 497 "../src/umockdev.vala"
					_tmp111_ = dev_path;
#line 497 "../src/umockdev.vala"
					if (string_contains (_tmp111_, "/block/")) {
#line 497 "../src/umockdev.vala"
						_tmp110_ = "block";
#line 3051 "umockdev.c"
					} else {
#line 497 "../src/umockdev.vala"
						_tmp110_ = "char";
#line 3055 "umockdev.c"
					}
#line 496 "../src/umockdev.vala"
					_tmp112_ = self->priv->sys_dir;
#line 496 "../src/umockdev.vala"
					_tmp113_ = g_build_filename (_tmp112_, "dev", _tmp110_, NULL);
#line 496 "../src/umockdev.vala"
					sysdev_dir = _tmp113_;
#line 498 "../src/umockdev.vala"
					_tmp114_ = sysdev_dir;
#line 498 "../src/umockdev.vala"
					umockdev_checked_mkdir_with_parents (_tmp114_, 0755);
#line 499 "../src/umockdev.vala"
					_tmp115_ = sysdev_dir;
#line 499 "../src/umockdev.vala"
					_tmp116_ = val;
#line 499 "../src/umockdev.vala"
					_tmp117_ = g_build_filename (_tmp115_, _tmp116_, NULL);
#line 499 "../src/umockdev.vala"
					dest = _tmp117_;
#line 500 "../src/umockdev.vala"
					_tmp118_ = dest;
#line 500 "../src/umockdev.vala"
					if (!g_file_test (_tmp118_, G_FILE_TEST_EXISTS)) {
#line 3079 "umockdev.c"
						const gchar* _tmp119_;
						gchar* _tmp120_;
						gchar* _tmp121_;
						gchar* _tmp122_;
						gchar* _tmp123_;
						const gchar* _tmp124_;
						gboolean _tmp125_;
#line 501 "../src/umockdev.vala"
						_tmp119_ = dev_path;
#line 501 "../src/umockdev.vala"
						_tmp120_ = string_substring (_tmp119_, (glong) 5, (glong) -1);
#line 501 "../src/umockdev.vala"
						_tmp121_ = _tmp120_;
#line 501 "../src/umockdev.vala"
						_tmp122_ = g_strconcat ("../../", _tmp121_, NULL);
#line 501 "../src/umockdev.vala"
						_tmp123_ = _tmp122_;
#line 501 "../src/umockdev.vala"
						_tmp124_ = dest;
#line 501 "../src/umockdev.vala"
						_tmp125_ = symlink (_tmp123_, _tmp124_) < 0;
#line 501 "../src/umockdev.vala"
						_g_free0 (_tmp123_);
#line 501 "../src/umockdev.vala"
						_g_free0 (_tmp121_);
#line 501 "../src/umockdev.vala"
						if (_tmp125_) {
#line 3107 "umockdev.c"
							const gchar* _tmp126_;
							const gchar* _tmp127_;
							gchar* _tmp128_;
							gchar* _tmp129_;
#line 502 "../src/umockdev.vala"
							_tmp126_ = dest;
#line 502 "../src/umockdev.vala"
							_tmp127_ = dev_path;
#line 502 "../src/umockdev.vala"
							_tmp128_ = string_substring (_tmp127_, (glong) 5, (glong) -1);
#line 502 "../src/umockdev.vala"
							_tmp129_ = _tmp128_;
#line 502 "../src/umockdev.vala"
							g_error ("umockdev.vala:502: add_device %s: failed to symlink %s to %s: %m", name, _tmp126_, _tmp129_);
#line 502 "../src/umockdev.vala"
							_g_free0 (_tmp129_);
#line 3124 "umockdev.c"
						}
					}
#line 488 "../src/umockdev.vala"
					_g_free0 (dest);
#line 488 "../src/umockdev.vala"
					_g_free0 (sysdev_dir);
#line 488 "../src/umockdev.vala"
					_g_free0 (infodir);
#line 488 "../src/umockdev.vala"
					_g_free0 (val);
#line 3135 "umockdev.c"
				}
			}
		}
	}
#line 507 "../src/umockdev.vala"
	if ((_vala_array_length (attributes) % 2) != 0) {
#line 3142 "umockdev.c"
		const gchar* _tmp130_;
#line 508 "../src/umockdev.vala"
		_tmp130_ = attributes[_vala_array_length (attributes) - 1];
#line 508 "../src/umockdev.vala"
		g_warning ("umockdev.vala:508: add_devicev: Ignoring attribute key '%s' without va" \
"lue", _tmp130_);
#line 3148 "umockdev.c"
	}
#line 510 "../src/umockdev.vala"
	result = dev_path;
#line 510 "../src/umockdev.vala"
	_g_free0 (props);
#line 510 "../src/umockdev.vala"
	_g_free0 (dev_path_no_sys);
#line 510 "../src/umockdev.vala"
	_g_free0 (dev_dir);
#line 510 "../src/umockdev.vala"
	_g_free0 (dev_node);
#line 510 "../src/umockdev.vala"
	return result;
#line 3162 "umockdev.c"
}

/**
     * umockdev_testbed_add_devicev:
     * @self: A #UMockdevTestbed.
     * @subsystem: The subsystem name, e. g. "usb"
     * @name: The device name; arbitrary, but needs to be unique within the testbed
     * @parent: (allow-none): device path of the parent device. Use %NULL for a
     *          top-level device.
     * @attributes: (array zero-terminated=1):
     *              A list of device sysfs attributes, alternating names and
     *              values, terminated with %NULL:
     *              { "key1", "value1", "key2", "value2", ..., NULL }
     * @properties: (array zero-terminated=1):
     *              A list of device udev properties; same format as @attributes
     *
     * This method is mostly meant for language bindings (where it is named
     * umockdev_testbed_add_device()). For C programs it is usually more convenient to
     * use umockdev_testbed_add_device().
     *
     * Add a new device to the testbed. A Linux kernel device always has a
     * subsystem (such as "usb" or "pci"), and a device name. The test bed only
     * builds a very simple sysfs structure without nested namespaces, so it
     * requires device names to be unique. Some gudev client programs might make
     * assumptions about the name (e. g. a SCSI disk block device should be called
     * sdaN). A device also has an arbitrary number of sysfs attributes and udev
     * properties; usually you should specify them upon creation, but it is also
     * possible to change them later on with umockdev_testbed_set_attribute() and
     * umockdev_testbed_set_property().
     *
     * This will synthesize an "add" uevent.
     *
     * Returns: The sysfs path for the newly created device. Free with g_free().
     *
     * Rename to: umockdev_testbed_add_device
     */
gchar*
umockdev_testbed_add_devicev (UMockdevTestbed* self,
                              const gchar* subsystem,
                              const gchar* name,
                              const gchar* parent,
                              gchar** attributes,
                              gchar** properties)
{
	gchar* dev_path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* result;
#line 547 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 547 "../src/umockdev.vala"
	g_return_val_if_fail (subsystem != NULL, NULL);
#line 547 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 551 "../src/umockdev.vala"
	_tmp0_ = umockdev_testbed_add_devicev_no_uevent (self, subsystem, name, parent, attributes, properties);
#line 551 "../src/umockdev.vala"
	dev_path = _tmp0_;
#line 553 "../src/umockdev.vala"
	_tmp2_ = dev_path;
#line 553 "../src/umockdev.vala"
	if (_tmp2_ != NULL) {
#line 553 "../src/umockdev.vala"
		_tmp1_ = umockdev_in_mock_environment ();
#line 3228 "umockdev.c"
	} else {
#line 553 "../src/umockdev.vala"
		_tmp1_ = FALSE;
#line 3232 "umockdev.c"
	}
#line 553 "../src/umockdev.vala"
	if (_tmp1_) {
#line 3236 "umockdev.c"
		const gchar* _tmp3_;
#line 554 "../src/umockdev.vala"
		_tmp3_ = dev_path;
#line 554 "../src/umockdev.vala"
		umockdev_testbed_uevent (self, _tmp3_, "add");
#line 3242 "umockdev.c"
	}
#line 556 "../src/umockdev.vala"
	result = dev_path;
#line 556 "../src/umockdev.vala"
	return result;
#line 3248 "umockdev.c"
}

/**
     * umockdev_testbed_add_device: (skip)
     * @self: A #UMockdevTestbed.
     * @subsystem: The subsystem name, e. g. "usb"
     * @name: The device name; arbitrary, but needs to be unique within the testbed
     * @parent: (allow-none): device path of the parent device. Use %NULL for a
     *          top-level device.
     * @...: Arbitrarily many pairs of sysfs attributes (alternating names and
     *       values), terminated by %NULL, followed by arbitrarily many pairs of udev
     *       properties, terminated by another %NULL.
     *
     * Add a new device to the testbed. A Linux kernel device always has a
     * subsystem (such as "usb" or "pci"), and a device name. The test bed only
     * builds a very simple sysfs structure without nested namespaces, so it
     * requires device names to be unique. Some gudev client programs might make
     * assumptions about the name (e. g. a SCSI disk block device should be called
     * sdaN). A device also has an arbitrary number of sysfs attributes and udev
     * properties; usually you should specify them upon creation, but it is also
     * possible to change them later on with umockdev_testbed_set_attribute() and
     * umockdev_testbed_set_property().
     *
     * This will synthesize an "add" uevent.
     *
     * Example:
     *   |[
     *   umockdev_testbed_add_device (testbed, "usb", "dev1", NULL,
     *                              "idVendor", "0815", "idProduct", "AFFE", NULL,
     *                              "ID_MODEL", "KoolGadget", NULL);
     *   ]|
     *
     * Returns: The sysfs path for the newly created device. Free with g_free().
     */
static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 609 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 609 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 609 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3295 "umockdev.c"
	}
#line 609 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 609 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 3301 "umockdev.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 611 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 611 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 611 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3316 "umockdev.c"
	}
#line 611 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 611 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 3322 "umockdev.c"
}

gchar*
umockdev_testbed_add_device (UMockdevTestbed* self,
                             const gchar* subsystem,
                             const gchar* name,
                             const gchar* parent,
                             ...)
{
	gchar** attributes = NULL;
	gchar** _tmp0_;
	gint attributes_length1;
	gint _attributes_size_;
	gchar** properties = NULL;
	gchar** _tmp1_;
	gint properties_length1;
	gint _properties_size_;
	gint arg_set = 0;
	va_list l = {0};
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* result;
#line 591 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 591 "../src/umockdev.vala"
	g_return_val_if_fail (subsystem != NULL, NULL);
#line 591 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 593 "../src/umockdev.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 593 "../src/umockdev.vala"
	attributes = _tmp0_;
#line 593 "../src/umockdev.vala"
	attributes_length1 = 0;
#line 593 "../src/umockdev.vala"
	_attributes_size_ = attributes_length1;
#line 594 "../src/umockdev.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 594 "../src/umockdev.vala"
	properties = _tmp1_;
#line 594 "../src/umockdev.vala"
	properties_length1 = 0;
#line 594 "../src/umockdev.vala"
	_properties_size_ = properties_length1;
#line 595 "../src/umockdev.vala"
	arg_set = 0;
#line 599 "../src/umockdev.vala"
	va_start (l, parent);
#line 600 "../src/umockdev.vala"
	while (TRUE) {
#line 3376 "umockdev.c"
		gchar* arg = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
#line 601 "../src/umockdev.vala"
		_tmp2_ = va_arg (l, gchar*);
#line 601 "../src/umockdev.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 601 "../src/umockdev.vala"
		arg = _tmp3_;
#line 602 "../src/umockdev.vala"
		_tmp4_ = arg;
#line 602 "../src/umockdev.vala"
		if (_tmp4_ == NULL) {
#line 3391 "umockdev.c"
			gint _tmp5_;
#line 603 "../src/umockdev.vala"
			arg_set = arg_set + 1;
#line 603 "../src/umockdev.vala"
			_tmp5_ = arg_set;
#line 603 "../src/umockdev.vala"
			if (_tmp5_ > 1) {
#line 604 "../src/umockdev.vala"
				_g_free0 (arg);
#line 604 "../src/umockdev.vala"
				break;
#line 3403 "umockdev.c"
			} else {
#line 606 "../src/umockdev.vala"
				_g_free0 (arg);
#line 606 "../src/umockdev.vala"
				continue;
#line 3409 "umockdev.c"
			}
		}
#line 608 "../src/umockdev.vala"
		if (arg_set == 0) {
#line 3414 "umockdev.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 609 "../src/umockdev.vala"
			_tmp6_ = arg;
#line 609 "../src/umockdev.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 609 "../src/umockdev.vala"
			_vala_array_add1 (&attributes, &attributes_length1, &_attributes_size_, _tmp7_);
#line 3423 "umockdev.c"
		} else {
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 611 "../src/umockdev.vala"
			_tmp8_ = arg;
#line 611 "../src/umockdev.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 611 "../src/umockdev.vala"
			_vala_array_add2 (&properties, &properties_length1, &_properties_size_, _tmp9_);
#line 3433 "umockdev.c"
		}
#line 600 "../src/umockdev.vala"
		_g_free0 (arg);
#line 3437 "umockdev.c"
	}
#line 614 "../src/umockdev.vala"
	_tmp10_ = attributes;
#line 614 "../src/umockdev.vala"
	_tmp10__length1 = attributes_length1;
#line 614 "../src/umockdev.vala"
	_tmp11_ = properties;
#line 614 "../src/umockdev.vala"
	_tmp11__length1 = properties_length1;
#line 614 "../src/umockdev.vala"
	_tmp12_ = umockdev_testbed_add_devicev (self, subsystem, name, parent, _tmp10_, _tmp11_);
#line 614 "../src/umockdev.vala"
	result = _tmp12_;
#line 614 "../src/umockdev.vala"
	va_end (l);
#line 614 "../src/umockdev.vala"
	properties = (_vala_array_free (properties, properties_length1, (GDestroyNotify) g_free), NULL);
#line 614 "../src/umockdev.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 614 "../src/umockdev.vala"
	return result;
#line 3459 "umockdev.c"
}

/**
     * umockdev_testbed_remove_device:
     * @self: A #UMockdevTestbed.
     * @syspath: Sysfs path of device
     *
     * Remove a device from the testbed. This removes the sysfs directory, the
     * /sys/class/ link, the device node, and all other information related to
     * it. Note that this will also remove all child devices (i. e.
     * subdirectories of @syspath).
     */
void
umockdev_testbed_remove_device (UMockdevTestbed* self,
                                const gchar* syspath)
{
	gchar* real_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* devname = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* subsystem = NULL;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp63_;
	GError* _inner_error0_ = NULL;
#line 627 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/umockdev.vala"
	g_return_if_fail (syspath != NULL);
#line 629 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 629 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, syspath, NULL);
#line 629 "../src/umockdev.vala"
	real_path = _tmp1_;
#line 630 "../src/umockdev.vala"
	_tmp2_ = g_path_get_basename (syspath);
#line 630 "../src/umockdev.vala"
	devname = _tmp2_;
#line 632 "../src/umockdev.vala"
	_tmp3_ = real_path;
#line 632 "../src/umockdev.vala"
	if (!g_file_test (_tmp3_, G_FILE_TEST_IS_DIR)) {
#line 633 "../src/umockdev.vala"
		g_critical ("umockdev.vala:633: umockdev_testbed_remove_device(): device %s does no" \
"t exist", syspath);
#line 634 "../src/umockdev.vala"
		_g_free0 (devname);
#line 634 "../src/umockdev.vala"
		_g_free0 (real_path);
#line 634 "../src/umockdev.vala"
		return;
#line 3521 "umockdev.c"
	}
	{
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 641 "../src/umockdev.vala"
		_tmp5_ = real_path;
#line 641 "../src/umockdev.vala"
		_tmp6_ = g_build_filename (_tmp5_, "subsystem", NULL);
#line 641 "../src/umockdev.vala"
		_tmp7_ = _tmp6_;
#line 641 "../src/umockdev.vala"
		_tmp8_ = g_file_read_link (_tmp7_, &_inner_error0_);
#line 641 "../src/umockdev.vala"
		_tmp9_ = _tmp8_;
#line 641 "../src/umockdev.vala"
		_g_free0 (_tmp7_);
#line 641 "../src/umockdev.vala"
		_tmp4_ = _tmp9_;
#line 641 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 641 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3549 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 641 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 641 "../src/umockdev.vala"
			_g_free0 (devname);
#line 641 "../src/umockdev.vala"
			_g_free0 (real_path);
#line 641 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 641 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 641 "../src/umockdev.vala"
			return;
#line 3564 "umockdev.c"
		}
#line 640 "../src/umockdev.vala"
		_tmp10_ = g_path_get_basename (_tmp4_);
#line 640 "../src/umockdev.vala"
		_g_free0 (subsystem);
#line 640 "../src/umockdev.vala"
		subsystem = _tmp10_;
#line 639 "../src/umockdev.vala"
		_g_free0 (_tmp4_);
#line 3574 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 639 "../src/umockdev.vala"
		e = _inner_error0_;
#line 639 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 643 "../src/umockdev.vala"
		_tmp11_ = e;
#line 643 "../src/umockdev.vala"
		_tmp12_ = _tmp11_->message;
#line 643 "../src/umockdev.vala"
		g_critical ("umockdev.vala:643: umockdev_testbed_remove_device(): cannot determine " \
"subsystem of %s: %s", syspath, _tmp12_);
#line 645 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 645 "../src/umockdev.vala"
		_g_free0 (subsystem);
#line 645 "../src/umockdev.vala"
		_g_free0 (devname);
#line 645 "../src/umockdev.vala"
		_g_free0 (real_path);
#line 645 "../src/umockdev.vala"
		return;
#line 3602 "umockdev.c"
	}
	__finally0:
#line 639 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 639 "../src/umockdev.vala"
		_g_free0 (subsystem);
#line 639 "../src/umockdev.vala"
		_g_free0 (devname);
#line 639 "../src/umockdev.vala"
		_g_free0 (real_path);
#line 639 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 639 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 639 "../src/umockdev.vala"
		return;
#line 3619 "umockdev.c"
	}
	{
		gchar* dev_maj_min = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* dev_node = NULL;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
#line 651 "../src/umockdev.vala"
		_tmp13_ = real_path;
#line 651 "../src/umockdev.vala"
		_tmp14_ = g_build_filename (_tmp13_, "dev", NULL);
#line 651 "../src/umockdev.vala"
		_tmp15_ = _tmp14_;
#line 651 "../src/umockdev.vala"
		g_file_get_contents (_tmp15_, &_tmp16_, NULL, &_inner_error0_);
#line 651 "../src/umockdev.vala"
		_g_free0 (dev_maj_min);
#line 651 "../src/umockdev.vala"
		dev_maj_min = _tmp16_;
#line 651 "../src/umockdev.vala"
		_g_free0 (_tmp15_);
#line 651 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 651 "../src/umockdev.vala"
			_g_free0 (dev_maj_min);
#line 651 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3656 "umockdev.c"
				goto __catch1_g_file_error;
			}
#line 651 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 651 "../src/umockdev.vala"
			_g_free0 (devname);
#line 651 "../src/umockdev.vala"
			_g_free0 (real_path);
#line 651 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 651 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 651 "../src/umockdev.vala"
			return;
#line 3671 "umockdev.c"
		}
#line 653 "../src/umockdev.vala"
		if (string_contains (syspath, "/block/")) {
#line 653 "../src/umockdev.vala"
			_tmp17_ = "block";
#line 3677 "umockdev.c"
		} else {
#line 653 "../src/umockdev.vala"
			_tmp17_ = "char";
#line 3681 "umockdev.c"
		}
#line 652 "../src/umockdev.vala"
		_tmp18_ = self->priv->sys_dir;
#line 652 "../src/umockdev.vala"
		_tmp19_ = dev_maj_min;
#line 652 "../src/umockdev.vala"
		_tmp20_ = g_build_filename (_tmp18_, "dev", _tmp17_, _tmp19_, NULL);
#line 652 "../src/umockdev.vala"
		_tmp21_ = _tmp20_;
#line 652 "../src/umockdev.vala"
		g_unlink (_tmp21_);
#line 652 "../src/umockdev.vala"
		_g_free0 (_tmp21_);
#line 655 "../src/umockdev.vala"
		_tmp22_ = real_path;
#line 655 "../src/umockdev.vala"
		_tmp23_ = umockdev_find_devnode (_tmp22_);
#line 655 "../src/umockdev.vala"
		dev_node = _tmp23_;
#line 656 "../src/umockdev.vala"
		_tmp24_ = dev_node;
#line 656 "../src/umockdev.vala"
		if (_tmp24_ != NULL) {
#line 3705 "umockdev.c"
			gchar* real_node = NULL;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 657 "../src/umockdev.vala"
			_tmp25_ = self->priv->root_dir;
#line 657 "../src/umockdev.vala"
			_tmp26_ = dev_node;
#line 657 "../src/umockdev.vala"
			_tmp27_ = g_build_filename (_tmp25_, _tmp26_, NULL);
#line 657 "../src/umockdev.vala"
			real_node = _tmp27_;
#line 658 "../src/umockdev.vala"
			_tmp28_ = real_node;
#line 658 "../src/umockdev.vala"
			g_unlink (_tmp28_);
#line 659 "../src/umockdev.vala"
			_tmp29_ = real_node;
#line 659 "../src/umockdev.vala"
			_tmp30_ = g_path_get_dirname (_tmp29_);
#line 659 "../src/umockdev.vala"
			_tmp31_ = _tmp30_;
#line 659 "../src/umockdev.vala"
			g_rmdir (_tmp31_);
#line 659 "../src/umockdev.vala"
			_g_free0 (_tmp31_);
#line 660 "../src/umockdev.vala"
			_tmp32_ = self->priv->root_dir;
#line 660 "../src/umockdev.vala"
			_tmp33_ = dev_node;
#line 660 "../src/umockdev.vala"
			_tmp34_ = string_substring (_tmp33_, (glong) 5, (glong) -1);
#line 660 "../src/umockdev.vala"
			_tmp35_ = _tmp34_;
#line 660 "../src/umockdev.vala"
			_tmp36_ = string_replace (_tmp35_, "/", "_");
#line 660 "../src/umockdev.vala"
			_tmp37_ = _tmp36_;
#line 660 "../src/umockdev.vala"
			_tmp38_ = g_build_filename (_tmp32_, "dev", ".node", _tmp37_, NULL);
#line 660 "../src/umockdev.vala"
			_tmp39_ = _tmp38_;
#line 660 "../src/umockdev.vala"
			g_unlink (_tmp39_);
#line 660 "../src/umockdev.vala"
			_g_free0 (_tmp39_);
#line 660 "../src/umockdev.vala"
			_g_free0 (_tmp37_);
#line 660 "../src/umockdev.vala"
			_g_free0 (_tmp35_);
#line 656 "../src/umockdev.vala"
			_g_free0 (real_node);
#line 3770 "umockdev.c"
		}
#line 649 "../src/umockdev.vala"
		_g_free0 (dev_node);
#line 649 "../src/umockdev.vala"
		_g_free0 (dev_maj_min);
#line 3776 "umockdev.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
#line 649 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 3783 "umockdev.c"
	}
	__finally1:
#line 649 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 649 "../src/umockdev.vala"
		_g_free0 (subsystem);
#line 649 "../src/umockdev.vala"
		_g_free0 (devname);
#line 649 "../src/umockdev.vala"
		_g_free0 (real_path);
#line 649 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 649 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 649 "../src/umockdev.vala"
		return;
#line 3800 "umockdev.c"
	}
#line 665 "../src/umockdev.vala"
	_tmp40_ = self->priv->sys_dir;
#line 665 "../src/umockdev.vala"
	_tmp41_ = subsystem;
#line 665 "../src/umockdev.vala"
	_tmp42_ = devname;
#line 665 "../src/umockdev.vala"
	_tmp43_ = g_build_filename (_tmp40_, "class", _tmp41_, _tmp42_, NULL);
#line 665 "../src/umockdev.vala"
	_tmp44_ = _tmp43_;
#line 665 "../src/umockdev.vala"
	g_unlink (_tmp44_);
#line 665 "../src/umockdev.vala"
	_g_free0 (_tmp44_);
#line 666 "../src/umockdev.vala"
	_tmp45_ = self->priv->sys_dir;
#line 666 "../src/umockdev.vala"
	_tmp46_ = subsystem;
#line 666 "../src/umockdev.vala"
	_tmp47_ = g_build_filename (_tmp45_, "class", _tmp46_, NULL);
#line 666 "../src/umockdev.vala"
	_tmp48_ = _tmp47_;
#line 666 "../src/umockdev.vala"
	g_rmdir (_tmp48_);
#line 666 "../src/umockdev.vala"
	_g_free0 (_tmp48_);
#line 668 "../src/umockdev.vala"
	_tmp49_ = subsystem;
#line 668 "../src/umockdev.vala"
	if (umockdev_testbed_subsystem_is_bus (_tmp49_)) {
#line 3832 "umockdev.c"
		const gchar* _tmp50_;
		const gchar* _tmp51_;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		const gchar* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
#line 669 "../src/umockdev.vala"
		_tmp50_ = self->priv->sys_dir;
#line 669 "../src/umockdev.vala"
		_tmp51_ = subsystem;
#line 669 "../src/umockdev.vala"
		_tmp52_ = devname;
#line 669 "../src/umockdev.vala"
		_tmp53_ = g_build_filename (_tmp50_, "bus", _tmp51_, "devices", _tmp52_, NULL);
#line 669 "../src/umockdev.vala"
		_tmp54_ = _tmp53_;
#line 669 "../src/umockdev.vala"
		g_unlink (_tmp54_);
#line 669 "../src/umockdev.vala"
		_g_free0 (_tmp54_);
#line 670 "../src/umockdev.vala"
		_tmp55_ = self->priv->sys_dir;
#line 670 "../src/umockdev.vala"
		_tmp56_ = subsystem;
#line 670 "../src/umockdev.vala"
		_tmp57_ = g_build_filename (_tmp55_, "bus", _tmp56_, "devices", NULL);
#line 670 "../src/umockdev.vala"
		_tmp58_ = _tmp57_;
#line 670 "../src/umockdev.vala"
		g_rmdir (_tmp58_);
#line 670 "../src/umockdev.vala"
		_g_free0 (_tmp58_);
#line 671 "../src/umockdev.vala"
		_tmp59_ = self->priv->sys_dir;
#line 671 "../src/umockdev.vala"
		_tmp60_ = subsystem;
#line 671 "../src/umockdev.vala"
		_tmp61_ = g_build_filename (_tmp59_, "bus", _tmp60_, NULL);
#line 671 "../src/umockdev.vala"
		_tmp62_ = _tmp61_;
#line 671 "../src/umockdev.vala"
		g_rmdir (_tmp62_);
#line 671 "../src/umockdev.vala"
		_g_free0 (_tmp62_);
#line 3884 "umockdev.c"
	}
#line 674 "../src/umockdev.vala"
	_tmp63_ = real_path;
#line 674 "../src/umockdev.vala"
	umockdev_utils_remove_dir (_tmp63_, TRUE);
#line 627 "../src/umockdev.vala"
	_g_free0 (subsystem);
#line 627 "../src/umockdev.vala"
	_g_free0 (devname);
#line 627 "../src/umockdev.vala"
	_g_free0 (real_path);
#line 3896 "umockdev.c"
}

/**
     * umockdev_testbed_add_from_string:
     * @self: A #UMockdevTestbed.
     * @data: Description of the device(s) as generated with umockdev-record
     * @error: return location for a GError, or %NULL
     *
     * Add a set of devices to the testbed from a textual description. This reads
     * the format generated by the umockdev-record tool.
     *
     * Each paragraph defines one device. A line starts with a type tag (like 'E'),
     * followed by a colon, followed by either a value or a "key=value" assignment,
     * depending on the type tag. A device description must start with a 'P:' line.
     * Available type tags are:
     * <itemizedlist>
     *   <listitem><type>P:</type> <emphasis>path</emphasis>: device path in sysfs, starting with
     *             <filename>/devices/</filename>; must occur exactly once at the
     *             start of device definition</listitem>
     *   <listitem><type>E:</type> <emphasis>key=value</emphasis>: udev property
     *             </listitem>
     *   <listitem><type>A:</type> <emphasis>key=value</emphasis>: ASCII sysfs
     *             attribute, with backslash-style escaping of \ (\\) and newlines
     *             (\n)</listitem>
     *   <listitem><type>H:</type> <emphasis>key=value</emphasis>: binary sysfs
     *             attribute, with the value being written as continuous hex string
     *             (e. g. 0081FE0A..)</listitem>
     *   <listitem><type>N:</type> <emphasis>devname</emphasis>[=<emphasis>contents</emphasis>]:
     *             device node name (without the <filename>/dev/</filename>
     *             prefix); if <emphasis>contents</emphasis> is given (encoded in a
     *             continuous hex string), it creates a
     *             <filename>/dev/devname</filename> in the mock environment with
     *             the given contents, otherwise the created dev file will be a
     *             pty; see #umockdev_testbed_get_dev_fd for details.</listitem>
     *   <listitem><type>S:</type> <emphasis>linkname</emphasis>: device node
     *             symlink (without the <filename>/dev/</filename> prefix); ignored right
     *             now.</listitem>
     * </itemizedlist>
     *
     * Returns: %TRUE on success, %FALSE if the data is invalid and an error
     *          occurred.
     */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 3953 "umockdev.c"
}

gboolean
umockdev_testbed_add_from_string (UMockdevTestbed* self,
                                  const gchar* data,
                                  GError** error)
{
	gchar* cur_data = NULL;
	gchar* _tmp18_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 717 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 717 "../src/umockdev.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 3969 "umockdev.c"
	{
		GRegex* _tmp0_;
		GRegex* _tmp5_;
		GRegex* _tmp10_;
#line 721 "../src/umockdev.vala"
		_tmp0_ = self->priv->re_record_val;
#line 721 "../src/umockdev.vala"
		if (_tmp0_ == NULL) {
#line 3978 "umockdev.c"
			GRegex* _tmp1_ = NULL;
			GRegex* _tmp2_;
			GRegex* _tmp4_;
#line 722 "../src/umockdev.vala"
			_tmp2_ = g_regex_new ("^([PS]): (.*)(?>\n|$)", 0, 0, &_inner_error0_);
#line 722 "../src/umockdev.vala"
			_tmp1_ = _tmp2_;
#line 722 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3988 "umockdev.c"
				gboolean _tmp3_ = FALSE;
#line 722 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3992 "umockdev.c"
					goto __catch0_g_regex_error;
				}
#line 722 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 722 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 722 "../src/umockdev.vala"
				return _tmp3_;
#line 4001 "umockdev.c"
			}
#line 722 "../src/umockdev.vala"
			_tmp4_ = _tmp1_;
#line 722 "../src/umockdev.vala"
			_tmp1_ = NULL;
#line 722 "../src/umockdev.vala"
			_g_regex_unref0 (self->priv->re_record_val);
#line 722 "../src/umockdev.vala"
			self->priv->re_record_val = _tmp4_;
#line 721 "../src/umockdev.vala"
			_g_regex_unref0 (_tmp1_);
#line 4013 "umockdev.c"
		}
#line 723 "../src/umockdev.vala"
		_tmp5_ = self->priv->re_record_keyval;
#line 723 "../src/umockdev.vala"
		if (_tmp5_ == NULL) {
#line 4019 "umockdev.c"
			GRegex* _tmp6_ = NULL;
			GRegex* _tmp7_;
			GRegex* _tmp9_;
#line 724 "../src/umockdev.vala"
			_tmp7_ = g_regex_new ("^([EAHL]): ([^=\n]+)=(.*)(?>\n|$)", 0, 0, &_inner_error0_);
#line 724 "../src/umockdev.vala"
			_tmp6_ = _tmp7_;
#line 724 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4029 "umockdev.c"
				gboolean _tmp8_ = FALSE;
#line 724 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4033 "umockdev.c"
					goto __catch0_g_regex_error;
				}
#line 724 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 724 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 724 "../src/umockdev.vala"
				return _tmp8_;
#line 4042 "umockdev.c"
			}
#line 724 "../src/umockdev.vala"
			_tmp9_ = _tmp6_;
#line 724 "../src/umockdev.vala"
			_tmp6_ = NULL;
#line 724 "../src/umockdev.vala"
			_g_regex_unref0 (self->priv->re_record_keyval);
#line 724 "../src/umockdev.vala"
			self->priv->re_record_keyval = _tmp9_;
#line 723 "../src/umockdev.vala"
			_g_regex_unref0 (_tmp6_);
#line 4054 "umockdev.c"
		}
#line 725 "../src/umockdev.vala"
		_tmp10_ = self->priv->re_record_optval;
#line 725 "../src/umockdev.vala"
		if (_tmp10_ == NULL) {
#line 4060 "umockdev.c"
			GRegex* _tmp11_ = NULL;
			GRegex* _tmp12_;
			GRegex* _tmp14_;
#line 726 "../src/umockdev.vala"
			_tmp12_ = g_regex_new ("^([N]): ([^=\n]+)(?>=([0-9A-F]+))?(?>\n|$)", 0, 0, &_inner_error0_);
#line 726 "../src/umockdev.vala"
			_tmp11_ = _tmp12_;
#line 726 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4070 "umockdev.c"
				gboolean _tmp13_ = FALSE;
#line 726 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4074 "umockdev.c"
					goto __catch0_g_regex_error;
				}
#line 726 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 726 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 726 "../src/umockdev.vala"
				return _tmp13_;
#line 4083 "umockdev.c"
			}
#line 726 "../src/umockdev.vala"
			_tmp14_ = _tmp11_;
#line 726 "../src/umockdev.vala"
			_tmp11_ = NULL;
#line 726 "../src/umockdev.vala"
			_g_regex_unref0 (self->priv->re_record_optval);
#line 726 "../src/umockdev.vala"
			self->priv->re_record_optval = _tmp14_;
#line 725 "../src/umockdev.vala"
			_g_regex_unref0 (_tmp11_);
#line 4095 "umockdev.c"
		}
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		const gchar* _tmp15_;
#line 720 "../src/umockdev.vala"
		e = _inner_error0_;
#line 720 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 728 "../src/umockdev.vala"
		_tmp15_ = e->message;
#line 728 "../src/umockdev.vala"
		g_error ("umockdev.vala:728: Internal error, cannot create regex: %s", _tmp15_);
#line 720 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 4113 "umockdev.c"
	}
	__finally0:
#line 720 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 720 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 4120 "umockdev.c"
			gboolean _tmp16_ = FALSE;
#line 720 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 720 "../src/umockdev.vala"
			return _tmp16_;
#line 4126 "umockdev.c"
		} else {
			gboolean _tmp17_ = FALSE;
#line 720 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 720 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 720 "../src/umockdev.vala"
			return _tmp17_;
#line 4135 "umockdev.c"
		}
	}
#line 731 "../src/umockdev.vala"
	_tmp18_ = g_strdup (data);
#line 731 "../src/umockdev.vala"
	cur_data = _tmp18_;
#line 732 "../src/umockdev.vala"
	while (TRUE) {
#line 4144 "umockdev.c"
		const gchar* _tmp19_;
		gchar* _tmp20_ = NULL;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp25_;
#line 732 "../src/umockdev.vala"
		_tmp19_ = cur_data;
#line 732 "../src/umockdev.vala"
		if (!(string_get (_tmp19_, (glong) 0) != '\0')) {
#line 732 "../src/umockdev.vala"
			break;
#line 4156 "umockdev.c"
		}
#line 733 "../src/umockdev.vala"
		_tmp21_ = cur_data;
#line 733 "../src/umockdev.vala"
		_tmp22_ = umockdev_testbed_add_dev_from_string (self, _tmp21_, &_inner_error0_);
#line 733 "../src/umockdev.vala"
		_tmp20_ = _tmp22_;
#line 733 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 733 "../src/umockdev.vala"
			if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 4168 "umockdev.c"
				gboolean _tmp23_ = FALSE;
#line 733 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 733 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 733 "../src/umockdev.vala"
				return _tmp23_;
#line 4176 "umockdev.c"
			} else {
				gboolean _tmp24_ = FALSE;
#line 733 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 733 "../src/umockdev.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 733 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 733 "../src/umockdev.vala"
				return _tmp24_;
#line 4187 "umockdev.c"
			}
		}
#line 733 "../src/umockdev.vala"
		_tmp25_ = _tmp20_;
#line 733 "../src/umockdev.vala"
		_tmp20_ = NULL;
#line 733 "../src/umockdev.vala"
		_g_free0 (cur_data);
#line 733 "../src/umockdev.vala"
		cur_data = _tmp25_;
#line 732 "../src/umockdev.vala"
		_g_free0 (_tmp20_);
#line 4200 "umockdev.c"
	}
#line 735 "../src/umockdev.vala"
	result = TRUE;
#line 735 "../src/umockdev.vala"
	_g_free0 (cur_data);
#line 735 "../src/umockdev.vala"
	return result;
#line 4208 "umockdev.c"
}

/**
     * umockdev_testbed_add_from_file:
     * @self: A #UMockdevTestbed.
     * @path: Path to file with description of the device(s) as generated with umockdev-record
     * @error: return location for a GError, or %NULL
     *
     * Add a set of devices to the testbed from a textual description. This
     * reads a file with the format generated by the umockdev-record tool, and
     * is mostly a convenience wrapper around
     * @umockdev_testbed_add_from_string.
     *
     * Returns: %TRUE on success, %FALSE if the @path cannot be read or thhe
     *          data is invalid and an error occurred.
     */
gboolean
umockdev_testbed_add_from_file (UMockdevTestbed* self,
                                const gchar* path,
                                GError** error)
{
	gchar* contents = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 752 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 752 "../src/umockdev.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 756 "../src/umockdev.vala"
	g_file_get_contents (path, &_tmp0_, NULL, &_inner_error0_);
#line 756 "../src/umockdev.vala"
	_g_free0 (contents);
#line 756 "../src/umockdev.vala"
	contents = _tmp0_;
#line 756 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 756 "../src/umockdev.vala"
		if ((_inner_error0_->domain == UMOCKDEV_ERROR) || (_inner_error0_->domain == G_FILE_ERROR)) {
#line 4250 "umockdev.c"
			gboolean _tmp1_ = FALSE;
#line 756 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 756 "../src/umockdev.vala"
			_g_free0 (contents);
#line 756 "../src/umockdev.vala"
			return _tmp1_;
#line 4258 "umockdev.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 756 "../src/umockdev.vala"
			_g_free0 (contents);
#line 756 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 756 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 756 "../src/umockdev.vala"
			return _tmp2_;
#line 4269 "umockdev.c"
		}
	}
#line 757 "../src/umockdev.vala"
	_tmp4_ = contents;
#line 757 "../src/umockdev.vala"
	_tmp3_ = umockdev_testbed_add_from_string (self, _tmp4_, &_inner_error0_);
#line 757 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 757 "../src/umockdev.vala"
		if ((_inner_error0_->domain == UMOCKDEV_ERROR) || (_inner_error0_->domain == G_FILE_ERROR)) {
#line 4280 "umockdev.c"
			gboolean _tmp5_ = FALSE;
#line 757 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 757 "../src/umockdev.vala"
			_g_free0 (contents);
#line 757 "../src/umockdev.vala"
			return _tmp5_;
#line 4288 "umockdev.c"
		} else {
			gboolean _tmp6_ = FALSE;
#line 757 "../src/umockdev.vala"
			_g_free0 (contents);
#line 757 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 757 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 757 "../src/umockdev.vala"
			return _tmp6_;
#line 4299 "umockdev.c"
		}
	}
#line 757 "../src/umockdev.vala"
	result = _tmp3_;
#line 757 "../src/umockdev.vala"
	_g_free0 (contents);
#line 757 "../src/umockdev.vala"
	return result;
#line 4308 "umockdev.c"
}

/**
     * umockdev_testbed_uevent:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @action: "add", "remove", or "change"
     *
     * Generate an uevent for a device.
     */
void
umockdev_testbed_uevent (UMockdevTestbed* self,
                         const gchar* devpath,
                         const gchar* action)
{
	uevent_sender* _tmp0_;
	gchar* uevent_path = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* properties = NULL;
	gchar* _tmp6_;
	uevent_sender* _tmp10_;
	const gchar* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 768 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 768 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 768 "../src/umockdev.vala"
	g_return_if_fail (action != NULL);
#line 770 "../src/umockdev.vala"
	_tmp0_ = self->priv->ev_sender;
#line 770 "../src/umockdev.vala"
	if (_tmp0_ == NULL) {
#line 4343 "umockdev.c"
		const gchar* _tmp1_;
		uevent_sender* _tmp2_;
		uevent_sender* _tmp3_;
#line 771 "../src/umockdev.vala"
		g_debug ("umockdev.vala:771: umockdev_testbed_uevent: lazily initializing uevent" \
"_sender");
#line 772 "../src/umockdev.vala"
		_tmp1_ = self->priv->root_dir;
#line 772 "../src/umockdev.vala"
		_tmp2_ = uevent_sender_open (_tmp1_);
#line 772 "../src/umockdev.vala"
		_uevent_sender_close0 (self->priv->ev_sender);
#line 772 "../src/umockdev.vala"
		self->priv->ev_sender = _tmp2_;
#line 773 "../src/umockdev.vala"
		_tmp3_ = self->priv->ev_sender;
#line 773 "../src/umockdev.vala"
		_vala_assert (_tmp3_ != NULL, "this.ev_sender != null");
#line 4361 "umockdev.c"
	}
#line 775 "../src/umockdev.vala"
	g_debug ("umockdev.vala:775: umockdev_testbed_uevent: sending uevent %s for devi" \
"ce %s", action, devpath);
#line 777 "../src/umockdev.vala"
	_tmp4_ = self->priv->root_dir;
#line 777 "../src/umockdev.vala"
	_tmp5_ = g_build_filename (_tmp4_, devpath, "uevent", NULL);
#line 777 "../src/umockdev.vala"
	uevent_path = _tmp5_;
#line 778 "../src/umockdev.vala"
	_tmp6_ = g_strdup ("");
#line 778 "../src/umockdev.vala"
	properties = _tmp6_;
#line 4375 "umockdev.c"
	{
		gchar* _tmp7_ = NULL;
#line 780 "../src/umockdev.vala"
		g_file_get_contents (uevent_path, &_tmp7_, NULL, &_inner_error0_);
#line 780 "../src/umockdev.vala"
		_g_free0 (properties);
#line 780 "../src/umockdev.vala"
		properties = _tmp7_;
#line 780 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 780 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 4388 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 780 "../src/umockdev.vala"
			_g_free0 (properties);
#line 780 "../src/umockdev.vala"
			_g_free0 (uevent_path);
#line 780 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 780 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 780 "../src/umockdev.vala"
			return;
#line 4401 "umockdev.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 779 "../src/umockdev.vala"
		e = _inner_error0_;
#line 779 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 782 "../src/umockdev.vala"
		_tmp8_ = e;
#line 782 "../src/umockdev.vala"
		_tmp9_ = _tmp8_->message;
#line 782 "../src/umockdev.vala"
		g_debug ("umockdev.vala:782: uevent: devpath %s has no uevent file: %s", devpath, _tmp9_);
#line 779 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 4422 "umockdev.c"
	}
	__finally0:
#line 779 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 779 "../src/umockdev.vala"
		_g_free0 (properties);
#line 779 "../src/umockdev.vala"
		_g_free0 (uevent_path);
#line 779 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 779 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 779 "../src/umockdev.vala"
		return;
#line 4437 "umockdev.c"
	}
#line 784 "../src/umockdev.vala"
	_tmp10_ = self->priv->ev_sender;
#line 784 "../src/umockdev.vala"
	_tmp11_ = properties;
#line 784 "../src/umockdev.vala"
	uevent_sender_send (_tmp10_, devpath, action, _tmp11_);
#line 768 "../src/umockdev.vala"
	_g_free0 (properties);
#line 768 "../src/umockdev.vala"
	_g_free0 (uevent_path);
#line 4449 "umockdev.c"
}

/**
     * umockdev_testbed_attach_ioctl:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) to attach to.
     * @handler: a #UMockdevIoctlBase instance to handle requests
     * @error: return location for a GError, or %NULL
     *
     * Attach an #UMockdevIoctlBase object to handle ioctl, read and write
     * syscalls on the given device file. This allows emulating arbitrary
     * ioctl's and read/write calls for which umockdev does not have builtin
     * support.
     *
     * Returns: %TRUE on success, %FALSE on error.
     * Since: 0.16
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 809 "../src/umockdev.vala"
	return self ? g_object_ref (self) : NULL;
#line 4472 "umockdev.c"
}

gboolean
umockdev_testbed_attach_ioctl (UMockdevTestbed* self,
                               const gchar* dev,
                               UMockdevIoctlBase* handler,
                               GError** error)
{
	GHashTable* _tmp0_;
	gchar* sockpath = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GMainContext* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	UMockdevIoctlBase* _tmp6_;
	gboolean result;
#line 802 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 802 "../src/umockdev.vala"
	g_return_val_if_fail (dev != NULL, FALSE);
#line 802 "../src/umockdev.vala"
	g_return_val_if_fail (handler != NULL, FALSE);
#line 804 "../src/umockdev.vala"
	_tmp0_ = self->priv->custom_handlers;
#line 804 "../src/umockdev.vala"
	_vala_assert (!g_hash_table_contains (_tmp0_, dev), "!this.custom_handlers.contains (dev)");
#line 806 "../src/umockdev.vala"
	_tmp1_ = self->priv->root_dir;
#line 806 "../src/umockdev.vala"
	_tmp2_ = g_build_filename (_tmp1_, "ioctl", dev, NULL);
#line 806 "../src/umockdev.vala"
	sockpath = _tmp2_;
#line 807 "../src/umockdev.vala"
	_tmp3_ = self->priv->worker_ctx;
#line 807 "../src/umockdev.vala"
	umockdev_ioctl_base_register_path (handler, _tmp3_, dev, sockpath);
#line 809 "../src/umockdev.vala"
	_tmp4_ = self->priv->custom_handlers;
#line 809 "../src/umockdev.vala"
	_tmp5_ = g_strdup (dev);
#line 809 "../src/umockdev.vala"
	_tmp6_ = _g_object_ref0 (handler);
#line 809 "../src/umockdev.vala"
	g_hash_table_insert (_tmp4_, _tmp5_, _tmp6_);
#line 811 "../src/umockdev.vala"
	result = TRUE;
#line 811 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 811 "../src/umockdev.vala"
	return result;
#line 4524 "umockdev.c"
}

/**
     * umockdev_testbed_detach_ioctl:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) to detach.
     * @error: return location for a GError, or %NULL
     *
     * Detach a custom #UMockdevIoctlBase object from an device node again. See
     * umockdev_testbed_attach_ioctl(). It is an error to call this function
     * if the path is not currently attached.
     *
     * Returns: %TRUE on success, %FALSE on error.
     * Since: 0.16
     */
gboolean
umockdev_testbed_detach_ioctl (UMockdevTestbed* self,
                               const gchar* dev,
                               GError** error)
{
	UMockdevIoctlBase* handler = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	UMockdevIoctlBase* _tmp2_;
	UMockdevIoctlBase* _tmp3_;
	UMockdevIoctlBase* _tmp6_;
	GHashTable* _tmp7_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 827 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 827 "../src/umockdev.vala"
	g_return_val_if_fail (dev != NULL, FALSE);
#line 829 "../src/umockdev.vala"
	_tmp0_ = self->priv->custom_handlers;
#line 829 "../src/umockdev.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, dev);
#line 829 "../src/umockdev.vala"
	_tmp2_ = _g_object_ref0 ((UMockdevIoctlBase*) _tmp1_);
#line 829 "../src/umockdev.vala"
	handler = _tmp2_;
#line 831 "../src/umockdev.vala"
	_tmp3_ = handler;
#line 831 "../src/umockdev.vala"
	if (_tmp3_ == NULL) {
#line 4570 "umockdev.c"
		GError* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 832 "../src/umockdev.vala"
		_tmp4_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_FOUND, "No handler for device was registered.");
#line 832 "../src/umockdev.vala"
		_inner_error0_ = _tmp4_;
#line 832 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 832 "../src/umockdev.vala"
		_g_object_unref0 (handler);
#line 832 "../src/umockdev.vala"
		return _tmp5_;
#line 4583 "umockdev.c"
	}
#line 834 "../src/umockdev.vala"
	_tmp6_ = handler;
#line 834 "../src/umockdev.vala"
	umockdev_ioctl_base_unregister_path (_tmp6_, dev);
#line 835 "../src/umockdev.vala"
	_tmp7_ = self->priv->custom_handlers;
#line 835 "../src/umockdev.vala"
	g_hash_table_remove (_tmp7_, dev);
#line 837 "../src/umockdev.vala"
	result = TRUE;
#line 837 "../src/umockdev.vala"
	_g_object_unref0 (handler);
#line 837 "../src/umockdev.vala"
	return result;
#line 4599 "umockdev.c"
}

/**
     * umockdev_testbed_load_ioctl:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) for which to load the ioctl record.
     *       %NULL is valid; in this case the ioctl record is associated with
     *       the device node it was recorded from.
     * @recordfile: Path of the ioctl record file.
     * @error: return location for a GError, or %NULL
     *
     * Load an ioctl record file for a particular device into the testbed.
     * ioctl records can be created with umockdev-record --ioctl.
     * They can optionally be xz compressed to save space (but then are
     * required to have an .xz file name suffix).
     *
     * Returns: %TRUE on success, %FALSE if the data is invalid and an error
     *          occurred.
     */
static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
#line 876 "../src/umockdev.vala"
	if (length > 0) {
#line 876 "../src/umockdev.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 4627 "umockdev.c"
	}
#line 876 "../src/umockdev.vala"
	return NULL;
#line 4631 "umockdev.c"
}

gboolean
umockdev_testbed_load_ioctl (UMockdevTestbed* self,
                             const gchar* dev,
                             const gchar* recordfile,
                             GError** error)
{
	gchar* format = NULL;
	gchar* _tmp0_;
	GDataInputStream* recording = NULL;
	gchar* owned_dev = NULL;
	gchar* _tmp1_;
	gchar* line = NULL;
	GDataInputStream* _tmp27_;
	gchar* _tmp28_;
	GMatchInfo* header_matcher = NULL;
	gboolean _tmp38_ = FALSE;
	const gchar* _tmp39_;
	GDataInputStream* _tmp52_;
	gchar* dest = NULL;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* contents = NULL;
	GDataInputStream* _tmp63_;
	gchar* _tmp64_;
	const gchar* _tmp66_;
	gboolean _tmp68_ = FALSE;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	UMockdevIoctlBase* handler = NULL;
	const gchar* _tmp72_;
	gchar* sockpath = NULL;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	gchar* _tmp79_;
	UMockdevIoctlBase* _tmp80_;
	GMainContext* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 857 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 857 "../src/umockdev.vala"
	g_return_val_if_fail (recordfile != NULL, FALSE);
#line 859 "../src/umockdev.vala"
	_tmp0_ = g_strdup ("");
#line 859 "../src/umockdev.vala"
	format = _tmp0_;
#line 863 "../src/umockdev.vala"
	_tmp1_ = g_strdup (dev);
#line 863 "../src/umockdev.vala"
	owned_dev = _tmp1_;
#line 865 "../src/umockdev.vala"
	if (g_str_has_suffix (recordfile, ".xz")) {
#line 4695 "umockdev.c"
		{
			gchar* contents = NULL;
			gint exit = 0;
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_;
			gint _tmp6__length1;
			gchar* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			const gchar* _tmp10_;
			guint8* _tmp11_;
			gint _tmp11__length1;
			gint _tmp12_ = 0;
			guint8* _tmp13_;
			gint _tmp13__length1;
			guint8* _tmp14_;
			gint _tmp14__length1;
			GMemoryInputStream* _tmp15_;
			GMemoryInputStream* _tmp16_;
			GDataInputStream* _tmp17_;
#line 869 "../src/umockdev.vala"
			_tmp2_ = g_strdup ("xz");
#line 869 "../src/umockdev.vala"
			_tmp3_ = g_strdup ("-cd");
#line 869 "../src/umockdev.vala"
			_tmp4_ = g_strdup (recordfile);
#line 869 "../src/umockdev.vala"
			_tmp5_ = g_new0 (gchar*, 3 + 1);
#line 869 "../src/umockdev.vala"
			_tmp5_[0] = _tmp2_;
#line 869 "../src/umockdev.vala"
			_tmp5_[1] = _tmp3_;
#line 869 "../src/umockdev.vala"
			_tmp5_[2] = _tmp4_;
#line 869 "../src/umockdev.vala"
			_tmp6_ = _tmp5_;
#line 869 "../src/umockdev.vala"
			_tmp6__length1 = 3;
#line 869 "../src/umockdev.vala"
			g_spawn_sync (NULL, _tmp6_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp7_, NULL, &_tmp8_, &_inner_error0_);
#line 869 "../src/umockdev.vala"
			_g_free0 (contents);
#line 869 "../src/umockdev.vala"
			contents = _tmp7_;
#line 869 "../src/umockdev.vala"
			exit = _tmp8_;
#line 869 "../src/umockdev.vala"
			_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 869 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4748 "umockdev.c"
				gboolean _tmp9_ = FALSE;
#line 869 "../src/umockdev.vala"
				_g_free0 (contents);
#line 869 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 4754 "umockdev.c"
					goto __catch0_g_spawn_error;
				}
#line 869 "../src/umockdev.vala"
				_g_free0 (owned_dev);
#line 869 "../src/umockdev.vala"
				_g_object_unref0 (recording);
#line 869 "../src/umockdev.vala"
				_g_free0 (format);
#line 869 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 869 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 869 "../src/umockdev.vala"
				return _tmp9_;
#line 4769 "umockdev.c"
			}
#line 875 "../src/umockdev.vala"
			_vala_assert (exit == 0, "exit == 0");
#line 876 "../src/umockdev.vala"
			_tmp10_ = contents;
#line 876 "../src/umockdev.vala"
			_tmp11_ = string_get_data (_tmp10_, &_tmp12_);
#line 876 "../src/umockdev.vala"
			_tmp11__length1 = _tmp12_;
#line 876 "../src/umockdev.vala"
			_tmp13_ = _tmp11_;
#line 876 "../src/umockdev.vala"
			_tmp13__length1 = _tmp11__length1;
#line 876 "../src/umockdev.vala"
			_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup1 (_tmp13_, _tmp13__length1) : _tmp13_;
#line 876 "../src/umockdev.vala"
			_tmp14__length1 = _tmp13__length1;
#line 876 "../src/umockdev.vala"
			_tmp15_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp14_, _tmp14__length1, NULL);
#line 876 "../src/umockdev.vala"
			_tmp16_ = _tmp15_;
#line 876 "../src/umockdev.vala"
			_tmp17_ = g_data_input_stream_new ((GInputStream*) _tmp16_);
#line 876 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 876 "../src/umockdev.vala"
			recording = _tmp17_;
#line 876 "../src/umockdev.vala"
			_g_object_unref0 (_tmp16_);
#line 866 "../src/umockdev.vala"
			_g_free0 (contents);
#line 4801 "umockdev.c"
		}
		goto __finally0;
		__catch0_g_spawn_error:
		{
			GError* e = NULL;
			const gchar* _tmp18_;
#line 866 "../src/umockdev.vala"
			e = _inner_error0_;
#line 866 "../src/umockdev.vala"
			_inner_error0_ = NULL;
#line 878 "../src/umockdev.vala"
			_tmp18_ = e->message;
#line 878 "../src/umockdev.vala"
			g_error ("umockdev.vala:878: Cannot call xz to decompress %s: %s", recordfile, _tmp18_);
#line 866 "../src/umockdev.vala"
			_g_error_free0 (e);
#line 4818 "umockdev.c"
		}
		__finally0:
#line 866 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4823 "umockdev.c"
			gboolean _tmp19_ = FALSE;
#line 866 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 866 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 866 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 866 "../src/umockdev.vala"
			_g_free0 (format);
#line 866 "../src/umockdev.vala"
			return _tmp19_;
#line 4835 "umockdev.c"
		}
	} else {
		GFileInputStream* _tmp20_ = NULL;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFileInputStream* _tmp23_;
		GFileInputStream* _tmp24_;
		GDataInputStream* _tmp26_;
#line 881 "../src/umockdev.vala"
		_tmp21_ = g_file_new_for_path (recordfile);
#line 881 "../src/umockdev.vala"
		_tmp22_ = _tmp21_;
#line 881 "../src/umockdev.vala"
		_tmp23_ = g_file_read (_tmp22_, NULL, &_inner_error0_);
#line 881 "../src/umockdev.vala"
		_tmp24_ = _tmp23_;
#line 881 "../src/umockdev.vala"
		_g_object_unref0 (_tmp22_);
#line 881 "../src/umockdev.vala"
		_tmp20_ = _tmp24_;
#line 881 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4858 "umockdev.c"
			gboolean _tmp25_ = FALSE;
#line 881 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 881 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 881 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 881 "../src/umockdev.vala"
			_g_free0 (format);
#line 881 "../src/umockdev.vala"
			return _tmp25_;
#line 4870 "umockdev.c"
		}
#line 881 "../src/umockdev.vala"
		_tmp26_ = g_data_input_stream_new ((GInputStream*) _tmp20_);
#line 881 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 881 "../src/umockdev.vala"
		recording = _tmp26_;
#line 865 "../src/umockdev.vala"
		_g_object_unref0 (_tmp20_);
#line 4880 "umockdev.c"
	}
#line 886 "../src/umockdev.vala"
	_tmp27_ = recording;
#line 886 "../src/umockdev.vala"
	_tmp28_ = g_data_input_stream_read_line (_tmp27_, NULL, NULL, &_inner_error0_);
#line 886 "../src/umockdev.vala"
	line = _tmp28_;
#line 886 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4890 "umockdev.c"
		gboolean _tmp29_ = FALSE;
#line 886 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 886 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 886 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 886 "../src/umockdev.vala"
		_g_free0 (format);
#line 886 "../src/umockdev.vala"
		return _tmp29_;
#line 4902 "umockdev.c"
	}
#line 887 "../src/umockdev.vala"
	while (TRUE) {
#line 4906 "umockdev.c"
		gboolean _tmp30_ = FALSE;
		const gchar* _tmp31_;
		gchar* _tmp33_ = NULL;
		GDataInputStream* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp37_;
#line 887 "../src/umockdev.vala"
		_tmp31_ = line;
#line 887 "../src/umockdev.vala"
		if (_tmp31_ != NULL) {
#line 4917 "umockdev.c"
			const gchar* _tmp32_;
#line 887 "../src/umockdev.vala"
			_tmp32_ = line;
#line 887 "../src/umockdev.vala"
			_tmp30_ = g_str_has_prefix (_tmp32_, "#");
#line 4923 "umockdev.c"
		} else {
#line 887 "../src/umockdev.vala"
			_tmp30_ = FALSE;
#line 4927 "umockdev.c"
		}
#line 887 "../src/umockdev.vala"
		if (!_tmp30_) {
#line 887 "../src/umockdev.vala"
			break;
#line 4933 "umockdev.c"
		}
#line 888 "../src/umockdev.vala"
		_tmp34_ = recording;
#line 888 "../src/umockdev.vala"
		_tmp35_ = g_data_input_stream_read_line (_tmp34_, NULL, NULL, &_inner_error0_);
#line 888 "../src/umockdev.vala"
		_tmp33_ = _tmp35_;
#line 888 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4943 "umockdev.c"
			gboolean _tmp36_ = FALSE;
#line 888 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 888 "../src/umockdev.vala"
			_g_free0 (line);
#line 888 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 888 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 888 "../src/umockdev.vala"
			_g_free0 (format);
#line 888 "../src/umockdev.vala"
			return _tmp36_;
#line 4957 "umockdev.c"
		}
#line 888 "../src/umockdev.vala"
		_tmp37_ = _tmp33_;
#line 888 "../src/umockdev.vala"
		_tmp33_ = NULL;
#line 888 "../src/umockdev.vala"
		_g_free0 (line);
#line 888 "../src/umockdev.vala"
		line = _tmp37_;
#line 887 "../src/umockdev.vala"
		_g_free0 (_tmp33_);
#line 4969 "umockdev.c"
	}
#line 891 "../src/umockdev.vala"
	header_matcher = NULL;
#line 892 "../src/umockdev.vala"
	_tmp39_ = line;
#line 892 "../src/umockdev.vala"
	if (_tmp39_ != NULL) {
#line 4977 "umockdev.c"
		GRegex* _tmp40_ = NULL;
		GRegex* _tmp41_;
		const gchar* _tmp43_;
		GMatchInfo* _tmp44_ = NULL;
		gboolean _tmp45_;
#line 892 "../src/umockdev.vala"
		_tmp41_ = g_regex_new ("^@DEV (.*?)( \\((?P<format>[^)]*)\\))?(\n|$)", 0, 0, &_inner_error0_);
#line 892 "../src/umockdev.vala"
		_tmp40_ = _tmp41_;
#line 892 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4989 "umockdev.c"
			gboolean _tmp42_ = FALSE;
#line 892 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 892 "../src/umockdev.vala"
			_g_match_info_unref0 (header_matcher);
#line 892 "../src/umockdev.vala"
			_g_free0 (line);
#line 892 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 892 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 892 "../src/umockdev.vala"
			_g_free0 (format);
#line 892 "../src/umockdev.vala"
			return _tmp42_;
#line 5005 "umockdev.c"
		}
#line 892 "../src/umockdev.vala"
		_tmp43_ = line;
#line 892 "../src/umockdev.vala"
		_tmp45_ = g_regex_match (_tmp40_, _tmp43_, 0, &_tmp44_);
#line 892 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 892 "../src/umockdev.vala"
		header_matcher = _tmp44_;
#line 892 "../src/umockdev.vala"
		_tmp38_ = _tmp45_;
#line 892 "../src/umockdev.vala"
		_g_regex_unref0 (_tmp40_);
#line 5019 "umockdev.c"
	} else {
#line 892 "../src/umockdev.vala"
		_tmp38_ = FALSE;
#line 5023 "umockdev.c"
	}
#line 892 "../src/umockdev.vala"
	if (_tmp38_) {
#line 5027 "umockdev.c"
		const gchar* _tmp46_;
		GMatchInfo* _tmp49_;
		gchar* _tmp50_;
#line 893 "../src/umockdev.vala"
		_tmp46_ = owned_dev;
#line 893 "../src/umockdev.vala"
		if (_tmp46_ == NULL) {
#line 5035 "umockdev.c"
			GMatchInfo* _tmp47_;
			gchar* _tmp48_;
#line 894 "../src/umockdev.vala"
			_tmp47_ = header_matcher;
#line 894 "../src/umockdev.vala"
			_tmp48_ = g_match_info_fetch (_tmp47_, 1);
#line 894 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 894 "../src/umockdev.vala"
			owned_dev = _tmp48_;
#line 5046 "umockdev.c"
		}
#line 896 "../src/umockdev.vala"
		_tmp49_ = header_matcher;
#line 896 "../src/umockdev.vala"
		_tmp50_ = g_match_info_fetch_named (_tmp49_, "format");
#line 896 "../src/umockdev.vala"
		_g_free0 (format);
#line 896 "../src/umockdev.vala"
		format = _tmp50_;
#line 5056 "umockdev.c"
	} else {
		const gchar* _tmp51_;
#line 897 "../src/umockdev.vala"
		_tmp51_ = owned_dev;
#line 897 "../src/umockdev.vala"
		if (_tmp51_ == NULL) {
#line 898 "../src/umockdev.vala"
			g_error ("umockdev.vala:898: null passed for device node, but recording %s has n" \
"o @DEV header", recordfile);
#line 5065 "umockdev.c"
		}
	}
#line 901 "../src/umockdev.vala"
	_tmp52_ = recording;
#line 901 "../src/umockdev.vala"
	g_seekable_seek ((GSeekable*) _tmp52_, (gint64) 0, G_SEEK_SET, NULL, &_inner_error0_);
#line 901 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5074 "umockdev.c"
		gboolean _tmp53_ = FALSE;
#line 901 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 901 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 901 "../src/umockdev.vala"
		_g_free0 (line);
#line 901 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 901 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 901 "../src/umockdev.vala"
		_g_free0 (format);
#line 901 "../src/umockdev.vala"
		return _tmp53_;
#line 5090 "umockdev.c"
	}
#line 903 "../src/umockdev.vala"
	_tmp54_ = self->priv->root_dir;
#line 903 "../src/umockdev.vala"
	_tmp55_ = owned_dev;
#line 903 "../src/umockdev.vala"
	_tmp56_ = g_strconcat (_tmp55_, ".tree", NULL);
#line 903 "../src/umockdev.vala"
	_tmp57_ = _tmp56_;
#line 903 "../src/umockdev.vala"
	_tmp58_ = g_build_filename (_tmp54_, "ioctl", _tmp57_, NULL);
#line 903 "../src/umockdev.vala"
	_tmp59_ = _tmp58_;
#line 903 "../src/umockdev.vala"
	_g_free0 (_tmp57_);
#line 903 "../src/umockdev.vala"
	dest = _tmp59_;
#line 904 "../src/umockdev.vala"
	_tmp60_ = dest;
#line 904 "../src/umockdev.vala"
	_tmp61_ = g_path_get_dirname (_tmp60_);
#line 904 "../src/umockdev.vala"
	_tmp62_ = _tmp61_;
#line 904 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp62_, 0755);
#line 904 "../src/umockdev.vala"
	_g_free0 (_tmp62_);
#line 906 "../src/umockdev.vala"
	_tmp63_ = recording;
#line 906 "../src/umockdev.vala"
	_tmp64_ = g_data_input_stream_read_upto (_tmp63_, "", (gssize) 0, NULL, NULL, &_inner_error0_);
#line 906 "../src/umockdev.vala"
	contents = _tmp64_;
#line 906 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5126 "umockdev.c"
		gboolean _tmp65_ = FALSE;
#line 906 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 906 "../src/umockdev.vala"
		_g_free0 (dest);
#line 906 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 906 "../src/umockdev.vala"
		_g_free0 (line);
#line 906 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 906 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 906 "../src/umockdev.vala"
		_g_free0 (format);
#line 906 "../src/umockdev.vala"
		return _tmp65_;
#line 5144 "umockdev.c"
	}
#line 907 "../src/umockdev.vala"
	_tmp66_ = contents;
#line 907 "../src/umockdev.vala"
	if (_tmp66_ == NULL) {
#line 5150 "umockdev.c"
		gchar* _tmp67_;
#line 908 "../src/umockdev.vala"
		_tmp67_ = g_strdup ("");
#line 908 "../src/umockdev.vala"
		_g_free0 (contents);
#line 908 "../src/umockdev.vala"
		contents = _tmp67_;
#line 5158 "umockdev.c"
	}
#line 909 "../src/umockdev.vala"
	_tmp69_ = dest;
#line 909 "../src/umockdev.vala"
	_tmp70_ = contents;
#line 909 "../src/umockdev.vala"
	_tmp68_ = g_file_set_contents (_tmp69_, _tmp70_, (gssize) -1, &_inner_error0_);
#line 909 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5168 "umockdev.c"
		gboolean _tmp71_ = FALSE;
#line 909 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 909 "../src/umockdev.vala"
		_g_free0 (contents);
#line 909 "../src/umockdev.vala"
		_g_free0 (dest);
#line 909 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 909 "../src/umockdev.vala"
		_g_free0 (line);
#line 909 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 909 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 909 "../src/umockdev.vala"
		_g_free0 (format);
#line 909 "../src/umockdev.vala"
		return _tmp71_;
#line 5188 "umockdev.c"
	}
#line 909 "../src/umockdev.vala"
	if (!_tmp68_) {
#line 910 "../src/umockdev.vala"
		result = FALSE;
#line 910 "../src/umockdev.vala"
		_g_free0 (contents);
#line 910 "../src/umockdev.vala"
		_g_free0 (dest);
#line 910 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 910 "../src/umockdev.vala"
		_g_free0 (line);
#line 910 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 910 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 910 "../src/umockdev.vala"
		_g_free0 (format);
#line 910 "../src/umockdev.vala"
		return result;
#line 5210 "umockdev.c"
	}
#line 913 "../src/umockdev.vala"
	_tmp72_ = format;
#line 913 "../src/umockdev.vala"
	if (g_strcmp0 (_tmp72_, "SPI") == 0) {
#line 5216 "umockdev.c"
		const gchar* _tmp73_;
		UMockdevIoctlSpiHandler* _tmp74_;
#line 914 "../src/umockdev.vala"
		_tmp73_ = dest;
#line 914 "../src/umockdev.vala"
		_tmp74_ = umockdev_ioctl_spi_handler_new (_tmp73_);
#line 914 "../src/umockdev.vala"
		_g_object_unref0 (handler);
#line 914 "../src/umockdev.vala"
		handler = (UMockdevIoctlBase*) _tmp74_;
#line 5227 "umockdev.c"
	} else {
		const gchar* _tmp75_;
		UMockdevIoctlTreeHandler* _tmp76_;
#line 916 "../src/umockdev.vala"
		_tmp75_ = dest;
#line 916 "../src/umockdev.vala"
		_tmp76_ = umockdev_ioctl_tree_handler_new (_tmp75_);
#line 916 "../src/umockdev.vala"
		_g_object_unref0 (handler);
#line 916 "../src/umockdev.vala"
		handler = (UMockdevIoctlBase*) _tmp76_;
#line 5239 "umockdev.c"
	}
#line 918 "../src/umockdev.vala"
	_tmp77_ = self->priv->root_dir;
#line 918 "../src/umockdev.vala"
	_tmp78_ = owned_dev;
#line 918 "../src/umockdev.vala"
	_tmp79_ = g_build_filename (_tmp77_, "ioctl", _tmp78_, NULL);
#line 918 "../src/umockdev.vala"
	sockpath = _tmp79_;
#line 919 "../src/umockdev.vala"
	_tmp80_ = handler;
#line 919 "../src/umockdev.vala"
	_tmp81_ = self->priv->worker_ctx;
#line 919 "../src/umockdev.vala"
	_tmp82_ = owned_dev;
#line 919 "../src/umockdev.vala"
	_tmp83_ = sockpath;
#line 919 "../src/umockdev.vala"
	umockdev_ioctl_base_register_path (_tmp80_, _tmp81_, _tmp82_, _tmp83_);
#line 921 "../src/umockdev.vala"
	result = TRUE;
#line 921 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 921 "../src/umockdev.vala"
	_g_object_unref0 (handler);
#line 921 "../src/umockdev.vala"
	_g_free0 (contents);
#line 921 "../src/umockdev.vala"
	_g_free0 (dest);
#line 921 "../src/umockdev.vala"
	_g_match_info_unref0 (header_matcher);
#line 921 "../src/umockdev.vala"
	_g_free0 (line);
#line 921 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 921 "../src/umockdev.vala"
	_g_object_unref0 (recording);
#line 921 "../src/umockdev.vala"
	_g_free0 (format);
#line 921 "../src/umockdev.vala"
	return result;
#line 5281 "umockdev.c"
}

/**
     * umockdev_testbed_load_pcap:
     * @self: A #UMockdevTestbed.
     * @sysfs: sysfs path for device (/sys/...)
     * @recordfile: Path of the pcap or pcapng file.
     * @error: return location for a GError, or %NULL
     *
     * Load a USB pcap/pcapng recording created using e.g. wireshark.
     * The device must have been added previously as the device path in /dev
     * as well as the bus and device numbers need to be extraced from the udev
     * information.
     *
     * Returns: %TRUE on success, %FALSE if the recording could not be loaded
     * Since: 0.16
     */
gboolean
umockdev_testbed_load_pcap (UMockdevTestbed* self,
                            const gchar* sysfs,
                            const gchar* recordfile,
                            GError** error)
{
	gchar* owned_dev = NULL;
	gchar* sockpath = NULL;
	gint busnum = 0;
	gint devnum = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	UMockdevIoctlUsbPcapHandler* handler = NULL;
	UMockdevIoctlUsbPcapHandler* _tmp13_;
	GMainContext* _tmp14_;
	gboolean result;
#line 939 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 939 "../src/umockdev.vala"
	g_return_val_if_fail (sysfs != NULL, FALSE);
#line 939 "../src/umockdev.vala"
	g_return_val_if_fail (recordfile != NULL, FALSE);
#line 946 "../src/umockdev.vala"
	_tmp0_ = umockdev_testbed_get_attribute (self, sysfs, "busnum");
#line 946 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 946 "../src/umockdev.vala"
	busnum = atoi (_tmp1_);
#line 946 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 947 "../src/umockdev.vala"
	_tmp2_ = umockdev_testbed_get_attribute (self, sysfs, "devnum");
#line 947 "../src/umockdev.vala"
	_tmp3_ = _tmp2_;
#line 947 "../src/umockdev.vala"
	devnum = atoi (_tmp3_);
#line 947 "../src/umockdev.vala"
	_g_free0 (_tmp3_);
#line 949 "../src/umockdev.vala"
	_tmp4_ = g_strdup_printf ("%03d", busnum);
#line 949 "../src/umockdev.vala"
	_tmp5_ = _tmp4_;
#line 949 "../src/umockdev.vala"
	_tmp6_ = g_strdup_printf ("%03d", devnum);
#line 949 "../src/umockdev.vala"
	_tmp7_ = _tmp6_;
#line 949 "../src/umockdev.vala"
	_tmp8_ = g_build_filename ("/dev", "bus", "usb", _tmp5_, _tmp7_, NULL);
#line 949 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 949 "../src/umockdev.vala"
	owned_dev = _tmp8_;
#line 949 "../src/umockdev.vala"
	_g_free0 (_tmp7_);
#line 949 "../src/umockdev.vala"
	_g_free0 (_tmp5_);
#line 952 "../src/umockdev.vala"
	_tmp9_ = self->priv->root_dir;
#line 952 "../src/umockdev.vala"
	_tmp10_ = g_build_filename (_tmp9_, "ioctl", owned_dev, NULL);
#line 952 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 952 "../src/umockdev.vala"
	sockpath = _tmp10_;
#line 954 "../src/umockdev.vala"
	_tmp11_ = g_path_get_dirname (sockpath);
#line 954 "../src/umockdev.vala"
	_tmp12_ = _tmp11_;
#line 954 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp12_, 0755);
#line 954 "../src/umockdev.vala"
	_g_free0 (_tmp12_);
#line 956 "../src/umockdev.vala"
	_tmp13_ = umockdev_ioctl_usb_pcap_handler_new (recordfile, busnum, devnum);
#line 956 "../src/umockdev.vala"
	handler = _tmp13_;
#line 957 "../src/umockdev.vala"
	_tmp14_ = self->priv->worker_ctx;
#line 957 "../src/umockdev.vala"
	umockdev_ioctl_base_register_path ((UMockdevIoctlBase*) handler, _tmp14_, owned_dev, sockpath);
#line 959 "../src/umockdev.vala"
	result = TRUE;
#line 959 "../src/umockdev.vala"
	_g_object_unref0 (handler);
#line 959 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 959 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 959 "../src/umockdev.vala"
	return result;
#line 5400 "umockdev.c"
}

/**
     * umockdev_testbed_load_script:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) for which to load the script record.
     *       %NULL is valid; in this case the script is associated with
     *       the device node it was recorded from.
     * @recordfile: Path of the script record file.
     * @error: return location for a GError, or %NULL
     *
     * Load a script record file for a particular device into the testbed.
     * script records can be created with umockdev-record --script.
     *
     * Returns: %TRUE on success, %FALSE if @recordfile is invalid and an error
     *          occurred.
     */
gboolean
umockdev_testbed_load_script (UMockdevTestbed* self,
                              const gchar* dev,
                              const gchar* recordfile,
                              GError** error)
{
	gchar* owned_dev = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GHashTable* _tmp29_;
	const gchar* _tmp30_;
	gint fd = 0;
	const gchar* _tmp31_;
	UMockdevScriptRunner* _tmp38_ = NULL;
	const gchar* _tmp39_;
	UMockdevScriptRunner* _tmp40_;
	GHashTable* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	UMockdevScriptRunner* _tmp45_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 977 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 977 "../src/umockdev.vala"
	g_return_val_if_fail (recordfile != NULL, FALSE);
#line 980 "../src/umockdev.vala"
	_tmp0_ = g_strdup (dev);
#line 980 "../src/umockdev.vala"
	owned_dev = _tmp0_;
#line 981 "../src/umockdev.vala"
	_tmp1_ = owned_dev;
#line 981 "../src/umockdev.vala"
	if (_tmp1_ == NULL) {
#line 5452 "umockdev.c"
		GFileInputStream* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFileInputStream* _tmp5_;
		GFileInputStream* _tmp6_;
		GDataInputStream* recording = NULL;
		GDataInputStream* _tmp8_;
		gchar* line = NULL;
		GDataInputStream* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp20_;
		GMatchInfo* header_matcher = NULL;
		GRegex* _tmp21_ = NULL;
		GRegex* _tmp22_;
		const gchar* _tmp24_;
		GMatchInfo* _tmp25_ = NULL;
		gboolean _tmp26_;
		GMatchInfo* _tmp27_;
		gchar* _tmp28_;
#line 982 "../src/umockdev.vala"
		_tmp3_ = g_file_new_for_path (recordfile);
#line 982 "../src/umockdev.vala"
		_tmp4_ = _tmp3_;
#line 982 "../src/umockdev.vala"
		_tmp5_ = g_file_read (_tmp4_, NULL, &_inner_error0_);
#line 982 "../src/umockdev.vala"
		_tmp6_ = _tmp5_;
#line 982 "../src/umockdev.vala"
		_g_object_unref0 (_tmp4_);
#line 982 "../src/umockdev.vala"
		_tmp2_ = _tmp6_;
#line 982 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5486 "umockdev.c"
			gboolean _tmp7_ = FALSE;
#line 982 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 982 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 982 "../src/umockdev.vala"
			return _tmp7_;
#line 5494 "umockdev.c"
		}
#line 982 "../src/umockdev.vala"
		_tmp8_ = g_data_input_stream_new ((GInputStream*) _tmp2_);
#line 982 "../src/umockdev.vala"
		recording = _tmp8_;
#line 985 "../src/umockdev.vala"
		_tmp9_ = recording;
#line 985 "../src/umockdev.vala"
		_tmp10_ = g_data_input_stream_read_line (_tmp9_, NULL, NULL, &_inner_error0_);
#line 985 "../src/umockdev.vala"
		line = _tmp10_;
#line 985 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5508 "umockdev.c"
			gboolean _tmp11_ = FALSE;
#line 985 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 985 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 985 "../src/umockdev.vala"
			_g_object_unref0 (_tmp2_);
#line 985 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 985 "../src/umockdev.vala"
			return _tmp11_;
#line 5520 "umockdev.c"
		}
#line 986 "../src/umockdev.vala"
		while (TRUE) {
#line 5524 "umockdev.c"
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
			gchar* _tmp15_ = NULL;
			GDataInputStream* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp19_;
#line 986 "../src/umockdev.vala"
			_tmp13_ = line;
#line 986 "../src/umockdev.vala"
			if (_tmp13_ != NULL) {
#line 5535 "umockdev.c"
				const gchar* _tmp14_;
#line 986 "../src/umockdev.vala"
				_tmp14_ = line;
#line 986 "../src/umockdev.vala"
				_tmp12_ = g_str_has_prefix (_tmp14_, "#");
#line 5541 "umockdev.c"
			} else {
#line 986 "../src/umockdev.vala"
				_tmp12_ = FALSE;
#line 5545 "umockdev.c"
			}
#line 986 "../src/umockdev.vala"
			if (!_tmp12_) {
#line 986 "../src/umockdev.vala"
				break;
#line 5551 "umockdev.c"
			}
#line 987 "../src/umockdev.vala"
			_tmp16_ = recording;
#line 987 "../src/umockdev.vala"
			_tmp17_ = g_data_input_stream_read_line (_tmp16_, NULL, NULL, &_inner_error0_);
#line 987 "../src/umockdev.vala"
			_tmp15_ = _tmp17_;
#line 987 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5561 "umockdev.c"
				gboolean _tmp18_ = FALSE;
#line 987 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 987 "../src/umockdev.vala"
				_g_free0 (line);
#line 987 "../src/umockdev.vala"
				_g_object_unref0 (recording);
#line 987 "../src/umockdev.vala"
				_g_object_unref0 (_tmp2_);
#line 987 "../src/umockdev.vala"
				_g_free0 (owned_dev);
#line 987 "../src/umockdev.vala"
				return _tmp18_;
#line 5575 "umockdev.c"
			}
#line 987 "../src/umockdev.vala"
			_tmp19_ = _tmp15_;
#line 987 "../src/umockdev.vala"
			_tmp15_ = NULL;
#line 987 "../src/umockdev.vala"
			_g_free0 (line);
#line 987 "../src/umockdev.vala"
			line = _tmp19_;
#line 986 "../src/umockdev.vala"
			_g_free0 (_tmp15_);
#line 5587 "umockdev.c"
		}
#line 990 "../src/umockdev.vala"
		_tmp20_ = line;
#line 990 "../src/umockdev.vala"
		if (_tmp20_ == NULL) {
#line 991 "../src/umockdev.vala"
			g_error ("umockdev.vala:991: script recording %s has no non-comment content", recordfile);
#line 5595 "umockdev.c"
		}
#line 994 "../src/umockdev.vala"
		_tmp22_ = g_regex_new ("^d 0 (.*)(\n|$)", 0, 0, &_inner_error0_);
#line 994 "../src/umockdev.vala"
		_tmp21_ = _tmp22_;
#line 994 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5603 "umockdev.c"
			gboolean _tmp23_ = FALSE;
#line 994 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 994 "../src/umockdev.vala"
			_g_match_info_unref0 (header_matcher);
#line 994 "../src/umockdev.vala"
			_g_free0 (line);
#line 994 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 994 "../src/umockdev.vala"
			_g_object_unref0 (_tmp2_);
#line 994 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 994 "../src/umockdev.vala"
			return _tmp23_;
#line 5619 "umockdev.c"
		}
#line 994 "../src/umockdev.vala"
		_tmp24_ = line;
#line 994 "../src/umockdev.vala"
		_tmp26_ = g_regex_match (_tmp21_, _tmp24_, 0, &_tmp25_);
#line 994 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 994 "../src/umockdev.vala"
		header_matcher = _tmp25_;
#line 994 "../src/umockdev.vala"
		if (!_tmp26_) {
#line 995 "../src/umockdev.vala"
			g_error ("umockdev.vala:995: null passed for device node, but recording %s has n" \
"o d 0 header", recordfile);
#line 5633 "umockdev.c"
		}
#line 996 "../src/umockdev.vala"
		_tmp27_ = header_matcher;
#line 996 "../src/umockdev.vala"
		_tmp28_ = g_match_info_fetch (_tmp27_, 1);
#line 996 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 996 "../src/umockdev.vala"
		owned_dev = _tmp28_;
#line 981 "../src/umockdev.vala"
		_g_regex_unref0 (_tmp21_);
#line 981 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 981 "../src/umockdev.vala"
		_g_free0 (line);
#line 981 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 981 "../src/umockdev.vala"
		_g_object_unref0 (_tmp2_);
#line 5653 "umockdev.c"
	}
#line 999 "../src/umockdev.vala"
	_tmp29_ = self->priv->dev_script_runner;
#line 999 "../src/umockdev.vala"
	_tmp30_ = owned_dev;
#line 999 "../src/umockdev.vala"
	_vala_assert (!g_hash_table_contains (_tmp29_, _tmp30_), "!this.dev_script_runner.contains (owned_dev)");
#line 1001 "../src/umockdev.vala"
	_tmp31_ = owned_dev;
#line 1001 "../src/umockdev.vala"
	fd = umockdev_testbed_get_dev_fd (self, _tmp31_);
#line 1002 "../src/umockdev.vala"
	if (fd < 0) {
#line 5667 "umockdev.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		GError* _tmp35_;
		GError* _tmp36_;
		gboolean _tmp37_ = FALSE;
#line 1003 "../src/umockdev.vala"
		_tmp32_ = owned_dev;
#line 1003 "../src/umockdev.vala"
		_tmp33_ = g_strconcat (_tmp32_, " is not a device suitable for scripts", NULL);
#line 1003 "../src/umockdev.vala"
		_tmp34_ = _tmp33_;
#line 1003 "../src/umockdev.vala"
		_tmp35_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_INVAL, _tmp34_);
#line 1003 "../src/umockdev.vala"
		_tmp36_ = _tmp35_;
#line 1003 "../src/umockdev.vala"
		_g_free0 (_tmp34_);
#line 1003 "../src/umockdev.vala"
		_inner_error0_ = _tmp36_;
#line 1003 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1003 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1003 "../src/umockdev.vala"
		return _tmp37_;
#line 5694 "umockdev.c"
	}
#line 1005 "../src/umockdev.vala"
	_tmp39_ = owned_dev;
#line 1005 "../src/umockdev.vala"
	_tmp40_ = umockdev_script_runner_new (_tmp39_, recordfile, fd, &_inner_error0_);
#line 1005 "../src/umockdev.vala"
	_tmp38_ = _tmp40_;
#line 1005 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5704 "umockdev.c"
		gboolean _tmp41_ = FALSE;
#line 1005 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1005 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1005 "../src/umockdev.vala"
		return _tmp41_;
#line 5712 "umockdev.c"
	}
#line 1005 "../src/umockdev.vala"
	_tmp42_ = self->priv->dev_script_runner;
#line 1005 "../src/umockdev.vala"
	_tmp43_ = owned_dev;
#line 1005 "../src/umockdev.vala"
	_tmp44_ = g_strdup (_tmp43_);
#line 1005 "../src/umockdev.vala"
	_tmp45_ = _tmp38_;
#line 1005 "../src/umockdev.vala"
	_tmp38_ = NULL;
#line 1005 "../src/umockdev.vala"
	g_hash_table_insert (_tmp42_, _tmp44_, _tmp45_);
#line 1006 "../src/umockdev.vala"
	result = TRUE;
#line 1006 "../src/umockdev.vala"
	_umockdev_script_runner_unref0 (_tmp38_);
#line 1006 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 1006 "../src/umockdev.vala"
	return result;
#line 5734 "umockdev.c"
}

/**
     * umockdev_testbed_load_socket_script:
     * @self: A #UMockdevTestbed.
     * @path: Unix socket path
     * @type: Unix socket type (#SOCK_STREAM, #SOCK_DGRAM)
     * @recordfile: Path of the script record file.
     * @error: return location for a GError, or %NULL
     *
     * Add an Unix socket to the testbed that is backed by a recorded script.
     * Clients can connect to the socket using @path (i. e. without the testbed
     * prefix).
     *
     * Returns: %TRUE on success, %FALSE if the @path or @type are
     *          invalid and an error occurred.
     */
gboolean
umockdev_testbed_load_socket_script (UMockdevTestbed* self,
                                     const gchar* path,
                                     gint type,
                                     const gchar* recordfile,
                                     GError** error)
{
	gint fd = 0;
	gchar* real_path = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	UMockdevSocketServer* _tmp11_;
	UMockdevSocketServer* _tmp13_;
	const gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1024 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1024 "../src/umockdev.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1024 "../src/umockdev.vala"
	g_return_val_if_fail (recordfile != NULL, FALSE);
#line 1026 "../src/umockdev.vala"
	fd = socket (AF_UNIX, type, 0);
#line 1027 "../src/umockdev.vala"
	if (fd < 0) {
#line 5781 "umockdev.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
#line 1028 "../src/umockdev.vala"
		_tmp0_ = g_strdup_printf ("Cannot create socket type %i: %m", type);
#line 1028 "../src/umockdev.vala"
		_tmp1_ = _tmp0_;
#line 1028 "../src/umockdev.vala"
		_tmp2_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_INVAL, _tmp1_);
#line 1028 "../src/umockdev.vala"
		_tmp3_ = _tmp2_;
#line 1028 "../src/umockdev.vala"
		_g_free0 (_tmp1_);
#line 1028 "../src/umockdev.vala"
		_inner_error0_ = _tmp3_;
#line 1028 "../src/umockdev.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 5800 "umockdev.c"
			gboolean _tmp4_ = FALSE;
#line 1028 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1028 "../src/umockdev.vala"
			return _tmp4_;
#line 5806 "umockdev.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 1028 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1028 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1028 "../src/umockdev.vala"
			return _tmp5_;
#line 5815 "umockdev.c"
		}
	}
#line 1030 "../src/umockdev.vala"
	_tmp6_ = self->priv->root_dir;
#line 1030 "../src/umockdev.vala"
	_tmp7_ = g_build_filename (_tmp6_, path, NULL);
#line 1030 "../src/umockdev.vala"
	real_path = _tmp7_;
#line 1031 "../src/umockdev.vala"
	_tmp8_ = real_path;
#line 1031 "../src/umockdev.vala"
	_tmp9_ = g_path_get_dirname (_tmp8_);
#line 1031 "../src/umockdev.vala"
	_tmp10_ = _tmp9_;
#line 1031 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp10_, 0755);
#line 1031 "../src/umockdev.vala"
	_g_free0 (_tmp10_);
#line 1034 "../src/umockdev.vala"
	_tmp11_ = self->priv->socket_server;
#line 1034 "../src/umockdev.vala"
	if (_tmp11_ == NULL) {
#line 5838 "umockdev.c"
		UMockdevSocketServer* _tmp12_;
#line 1035 "../src/umockdev.vala"
		_tmp12_ = umockdev_socket_server_new ();
#line 1035 "../src/umockdev.vala"
		_umockdev_socket_server_unref0 (self->priv->socket_server);
#line 1035 "../src/umockdev.vala"
		self->priv->socket_server = _tmp12_;
#line 5846 "umockdev.c"
	}
#line 1037 "../src/umockdev.vala"
	_tmp13_ = self->priv->socket_server;
#line 1037 "../src/umockdev.vala"
	_tmp14_ = real_path;
#line 1037 "../src/umockdev.vala"
	umockdev_socket_server_add (_tmp13_, _tmp14_, fd, recordfile);
#line 1038 "../src/umockdev.vala"
	result = TRUE;
#line 1038 "../src/umockdev.vala"
	_g_free0 (real_path);
#line 1038 "../src/umockdev.vala"
	return result;
#line 5860 "umockdev.c"
}

/**
     * umockdev_testbed_load_evemu_events:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) for which to load the evemu events.
     *       %NULL is valid; in this case the events are associated with
     *       the device node it was recorded from.
     * @eventsfile: Path of the evemu events file.
     * @error: return location for a GError, or %NULL
     *
     * Load an evemu event file for a particular device into the testbed. These
     * have a very simple line-based format with 4 fields that represent the
     * data in a struct input_event:
     *
     *  E: sec.usec evtype(hex) evcode(hex) evvalue
     *
     * The timestamps in those are absolute, and are usually as they were at
     * record time. When loading them into umockdev they are interpreted
     * relatively: the first event happens immediately, and the time to the
     * next event is the difference between the corresponding timestamps in the
     * .event file.
     *
     * Returns: %TRUE on success, %FALSE if @eventsfile is invalid and an error
     *          occurred.
     */
static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result;
#line 839 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 840 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, _base);
#line 840 "glib-2.0.vapi"
	return result;
#line 5898 "umockdev.c"
}

static gulong
ulong_parse (const gchar* str,
             guint _base)
{
	gulong result;
#line 366 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0UL);
#line 367 "glib-2.0.vapi"
	result = strtoul (str, NULL, (gint) _base);
#line 367 "glib-2.0.vapi"
	return result;
#line 5912 "umockdev.c"
}

gboolean
umockdev_testbed_load_evemu_events (UMockdevTestbed* self,
                                    const gchar* dev,
                                    const gchar* eventsfile,
                                    GError** error)
{
	GFile* f_ev = NULL;
	GFile* _tmp0_;
	GFileInputStream* _tmp1_ = NULL;
	GFile* _tmp2_;
	GFileInputStream* _tmp3_;
	GDataInputStream* s_ev = NULL;
	GDataInputStream* _tmp5_;
	gchar* line = NULL;
	gchar* recorded_dev = NULL;
	gsize len = 0UL;
	GMatchInfo* match = NULL;
	struct input_event ev = {0};
	struct input_event _tmp6_ = {0};
	GRegex* default_dev_re = NULL;
	GRegex* _tmp7_;
	GRegex* event_re = NULL;
	GRegex* _tmp9_;
	gchar* script_file = NULL;
	gint script_fd = 0;
	gchar* _tmp11_ = NULL;
	gint _tmp12_;
	gint delay = 0;
	gboolean first = FALSE;
	gchar* owned_dev = NULL;
	gchar* _tmp75_;
	const gchar* _tmp76_;
	gboolean ret = FALSE;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp83_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1065 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1065 "../src/umockdev.vala"
	g_return_val_if_fail (eventsfile != NULL, FALSE);
#line 1068 "../src/umockdev.vala"
	_tmp0_ = g_file_new_for_path (eventsfile);
#line 1068 "../src/umockdev.vala"
	f_ev = _tmp0_;
#line 1069 "../src/umockdev.vala"
	_tmp2_ = f_ev;
#line 1069 "../src/umockdev.vala"
	_tmp3_ = g_file_read (_tmp2_, NULL, &_inner_error0_);
#line 1069 "../src/umockdev.vala"
	_tmp1_ = _tmp3_;
#line 1069 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5969 "umockdev.c"
		gboolean _tmp4_ = FALSE;
#line 1069 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1069 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1069 "../src/umockdev.vala"
		return _tmp4_;
#line 5977 "umockdev.c"
	}
#line 1069 "../src/umockdev.vala"
	_tmp5_ = g_data_input_stream_new ((GInputStream*) _tmp1_);
#line 1069 "../src/umockdev.vala"
	s_ev = _tmp5_;
#line 1071 "../src/umockdev.vala"
	recorded_dev = NULL;
#line 1074 "../src/umockdev.vala"
	ev = _tmp6_;
#line 1075 "../src/umockdev.vala"
	_tmp7_ = g_regex_new ("^# device (.*)$", 0, 0, &_inner_error0_);
#line 1075 "../src/umockdev.vala"
	default_dev_re = _tmp7_;
#line 1075 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5993 "umockdev.c"
		gboolean _tmp8_ = FALSE;
#line 1075 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1075 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1075 "../src/umockdev.vala"
		_g_free0 (recorded_dev);
#line 1075 "../src/umockdev.vala"
		_g_free0 (line);
#line 1075 "../src/umockdev.vala"
		_g_object_unref0 (s_ev);
#line 1075 "../src/umockdev.vala"
		_g_object_unref0 (_tmp1_);
#line 1075 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1075 "../src/umockdev.vala"
		return _tmp8_;
#line 6011 "umockdev.c"
	}
#line 1076 "../src/umockdev.vala"
	_tmp9_ = g_regex_new ("^E: ([0-9]+)\\.([0-9]+) +([0-9a-fA-F]+) +([0-9a-fA-F]+) +(-?[0-9]+) *#" \
"?", 0, 0, &_inner_error0_);
#line 1076 "../src/umockdev.vala"
	event_re = _tmp9_;
#line 1076 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6019 "umockdev.c"
		gboolean _tmp10_ = FALSE;
#line 1076 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1076 "../src/umockdev.vala"
		_g_regex_unref0 (default_dev_re);
#line 1076 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1076 "../src/umockdev.vala"
		_g_free0 (recorded_dev);
#line 1076 "../src/umockdev.vala"
		_g_free0 (line);
#line 1076 "../src/umockdev.vala"
		_g_object_unref0 (s_ev);
#line 1076 "../src/umockdev.vala"
		_g_object_unref0 (_tmp1_);
#line 1076 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1076 "../src/umockdev.vala"
		return _tmp10_;
#line 6039 "umockdev.c"
	}
#line 1079 "../src/umockdev.vala"
	_tmp12_ = g_file_open_tmp ("evemu.XXXXXX.script", &_tmp11_, &_inner_error0_);
#line 1079 "../src/umockdev.vala"
	_g_free0 (script_file);
#line 1079 "../src/umockdev.vala"
	script_file = _tmp11_;
#line 1079 "../src/umockdev.vala"
	script_fd = _tmp12_;
#line 1079 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6051 "umockdev.c"
		gboolean _tmp13_ = FALSE;
#line 1079 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1079 "../src/umockdev.vala"
		_g_free0 (script_file);
#line 1079 "../src/umockdev.vala"
		_g_regex_unref0 (event_re);
#line 1079 "../src/umockdev.vala"
		_g_regex_unref0 (default_dev_re);
#line 1079 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1079 "../src/umockdev.vala"
		_g_free0 (recorded_dev);
#line 1079 "../src/umockdev.vala"
		_g_free0 (line);
#line 1079 "../src/umockdev.vala"
		_g_object_unref0 (s_ev);
#line 1079 "../src/umockdev.vala"
		_g_object_unref0 (_tmp1_);
#line 1079 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1079 "../src/umockdev.vala"
		return _tmp13_;
#line 6075 "umockdev.c"
	}
#line 1080 "../src/umockdev.vala"
	delay = 0;
#line 1081 "../src/umockdev.vala"
	first = TRUE;
#line 1083 "../src/umockdev.vala"
	while (TRUE) {
#line 6083 "umockdev.c"
		gchar* _tmp14_ = NULL;
		GDataInputStream* _tmp15_;
		gsize _tmp16_ = 0UL;
		gchar* _tmp17_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		GRegex* _tmp21_;
		const gchar* _tmp22_;
		GMatchInfo* _tmp23_ = NULL;
		gboolean _tmp24_;
		GRegex* _tmp27_;
		const gchar* _tmp28_;
		GMatchInfo* _tmp29_ = NULL;
		gboolean _tmp30_;
		time_t ev_sec = 0;
		GMatchInfo* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		time_t _tmp36_;
		time_t ev_usec = 0;
		GMatchInfo* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		time_t _tmp40_;
		GMatchInfo* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GMatchInfo* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		GMatchInfo* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		guint8* ev_data = NULL;
		guint8* _tmp52_;
		gint ev_data_length1;
		gint _ev_data_size_;
		guint8* _tmp53_;
		gint _tmp53__length1;
		guint8* _tmp54_;
		gint _tmp54__length1;
		gchar* script_line = NULL;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		guint8* _tmp61_;
		gint _tmp61__length1;
		gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
		const gchar* _tmp72_;
		gint _tmp73_;
		gint _tmp74_;
#line 1083 "../src/umockdev.vala"
		_tmp15_ = s_ev;
#line 1083 "../src/umockdev.vala"
		_tmp17_ = g_data_input_stream_read_line (_tmp15_, &_tmp16_, NULL, &_inner_error0_);
#line 1083 "../src/umockdev.vala"
		len = _tmp16_;
#line 1083 "../src/umockdev.vala"
		_tmp14_ = _tmp17_;
#line 1083 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6157 "umockdev.c"
			gboolean _tmp18_ = FALSE;
#line 1083 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1083 "../src/umockdev.vala"
			_g_free0 (script_file);
#line 1083 "../src/umockdev.vala"
			_g_regex_unref0 (event_re);
#line 1083 "../src/umockdev.vala"
			_g_regex_unref0 (default_dev_re);
#line 1083 "../src/umockdev.vala"
			_g_match_info_unref0 (match);
#line 1083 "../src/umockdev.vala"
			_g_free0 (recorded_dev);
#line 1083 "../src/umockdev.vala"
			_g_free0 (line);
#line 1083 "../src/umockdev.vala"
			_g_object_unref0 (s_ev);
#line 1083 "../src/umockdev.vala"
			_g_object_unref0 (_tmp1_);
#line 1083 "../src/umockdev.vala"
			_g_object_unref0 (f_ev);
#line 1083 "../src/umockdev.vala"
			return _tmp18_;
#line 6181 "umockdev.c"
		}
#line 1083 "../src/umockdev.vala"
		_tmp19_ = _tmp14_;
#line 1083 "../src/umockdev.vala"
		_tmp14_ = NULL;
#line 1083 "../src/umockdev.vala"
		_g_free0 (line);
#line 1083 "../src/umockdev.vala"
		line = _tmp19_;
#line 1083 "../src/umockdev.vala"
		_tmp20_ = line;
#line 1083 "../src/umockdev.vala"
		if (!(_tmp20_ != NULL)) {
#line 1083 "../src/umockdev.vala"
			_g_free0 (_tmp14_);
#line 1083 "../src/umockdev.vala"
			break;
#line 6199 "umockdev.c"
		}
#line 1084 "../src/umockdev.vala"
		_tmp21_ = default_dev_re;
#line 1084 "../src/umockdev.vala"
		_tmp22_ = line;
#line 1084 "../src/umockdev.vala"
		_tmp24_ = g_regex_match (_tmp21_, _tmp22_, 0, &_tmp23_);
#line 1084 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1084 "../src/umockdev.vala"
		match = _tmp23_;
#line 1084 "../src/umockdev.vala"
		if (_tmp24_) {
#line 6213 "umockdev.c"
			GMatchInfo* _tmp25_;
			gchar* _tmp26_;
#line 1085 "../src/umockdev.vala"
			_tmp25_ = match;
#line 1085 "../src/umockdev.vala"
			_tmp26_ = g_match_info_fetch (_tmp25_, 1);
#line 1085 "../src/umockdev.vala"
			_g_free0 (recorded_dev);
#line 1085 "../src/umockdev.vala"
			recorded_dev = _tmp26_;
#line 1086 "../src/umockdev.vala"
			_g_free0 (_tmp14_);
#line 1086 "../src/umockdev.vala"
			continue;
#line 6228 "umockdev.c"
		}
#line 1089 "../src/umockdev.vala"
		_tmp27_ = event_re;
#line 1089 "../src/umockdev.vala"
		_tmp28_ = line;
#line 1089 "../src/umockdev.vala"
		_tmp30_ = g_regex_match (_tmp27_, _tmp28_, 0, &_tmp29_);
#line 1089 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1089 "../src/umockdev.vala"
		match = _tmp29_;
#line 1089 "../src/umockdev.vala"
		if (!_tmp30_) {
#line 6242 "umockdev.c"
			const gchar* _tmp31_;
#line 1090 "../src/umockdev.vala"
			_tmp31_ = line;
#line 1090 "../src/umockdev.vala"
			if (!g_str_has_prefix (_tmp31_, "#")) {
#line 6248 "umockdev.c"
				const gchar* _tmp32_;
#line 1091 "../src/umockdev.vala"
				_tmp32_ = line;
#line 1091 "../src/umockdev.vala"
				g_warning ("umockdev.vala:1091: Ignoring invalid line in %s: %s", eventsfile, _tmp32_);
#line 6254 "umockdev.c"
			}
#line 1092 "../src/umockdev.vala"
			_g_free0 (_tmp14_);
#line 1092 "../src/umockdev.vala"
			continue;
#line 6260 "umockdev.c"
		}
#line 1094 "../src/umockdev.vala"
		_tmp33_ = match;
#line 1094 "../src/umockdev.vala"
		_tmp34_ = g_match_info_fetch (_tmp33_, 1);
#line 1094 "../src/umockdev.vala"
		_tmp35_ = _tmp34_;
#line 1094 "../src/umockdev.vala"
		_tmp36_ = (time_t) uint64_parse (_tmp35_, (guint) 0);
#line 1094 "../src/umockdev.vala"
		_g_free0 (_tmp35_);
#line 1094 "../src/umockdev.vala"
		ev_sec = _tmp36_;
#line 1095 "../src/umockdev.vala"
		_tmp37_ = match;
#line 1095 "../src/umockdev.vala"
		_tmp38_ = g_match_info_fetch (_tmp37_, 2);
#line 1095 "../src/umockdev.vala"
		_tmp39_ = _tmp38_;
#line 1095 "../src/umockdev.vala"
		_tmp40_ = (time_t) uint64_parse (_tmp39_, (guint) 0);
#line 1095 "../src/umockdev.vala"
		_g_free0 (_tmp39_);
#line 1095 "../src/umockdev.vala"
		ev_usec = _tmp40_;
#line 1096 "../src/umockdev.vala"
		if (first) {
#line 1097 "../src/umockdev.vala"
			delay = 0;
#line 1098 "../src/umockdev.vala"
			first = FALSE;
#line 6292 "umockdev.c"
		} else {
			struct input_event _tmp41_;
			struct input_event _tmp42_;
#line 1100 "../src/umockdev.vala"
			_tmp41_ = ev;
#line 1100 "../src/umockdev.vala"
			_tmp42_ = ev;
#line 1100 "../src/umockdev.vala"
			delay = (((gint) (ev_sec - _tmp41_.input_event_sec)) * 1000) + (((gint) (ev_usec - _tmp42_.input_event_usec)) / 1000);
#line 1101 "../src/umockdev.vala"
			if (delay < 0) {
#line 1102 "../src/umockdev.vala"
				delay = 0;
#line 6306 "umockdev.c"
			}
		}
#line 1104 "../src/umockdev.vala"
		ev.input_event_sec = ev_sec;
#line 1105 "../src/umockdev.vala"
		ev.input_event_usec = (glong) ev_usec;
#line 1106 "../src/umockdev.vala"
		_tmp43_ = match;
#line 1106 "../src/umockdev.vala"
		_tmp44_ = g_match_info_fetch (_tmp43_, 3);
#line 1106 "../src/umockdev.vala"
		_tmp45_ = _tmp44_;
#line 1106 "../src/umockdev.vala"
		ev.type = (guint16) ulong_parse (_tmp45_, (guint) 16);
#line 1106 "../src/umockdev.vala"
		_g_free0 (_tmp45_);
#line 1107 "../src/umockdev.vala"
		_tmp46_ = match;
#line 1107 "../src/umockdev.vala"
		_tmp47_ = g_match_info_fetch (_tmp46_, 4);
#line 1107 "../src/umockdev.vala"
		_tmp48_ = _tmp47_;
#line 1107 "../src/umockdev.vala"
		ev.code = (guint16) ulong_parse (_tmp48_, (guint) 16);
#line 1107 "../src/umockdev.vala"
		_g_free0 (_tmp48_);
#line 1108 "../src/umockdev.vala"
		_tmp49_ = match;
#line 1108 "../src/umockdev.vala"
		_tmp50_ = g_match_info_fetch (_tmp49_, 5);
#line 1108 "../src/umockdev.vala"
		_tmp51_ = _tmp50_;
#line 1108 "../src/umockdev.vala"
		ev.value = (gint32) atoi (_tmp51_);
#line 1108 "../src/umockdev.vala"
		_g_free0 (_tmp51_);
#line 1110 "../src/umockdev.vala"
		_tmp52_ = g_new0 (guint8, sizeof (struct input_event));
#line 1110 "../src/umockdev.vala"
		ev_data = _tmp52_;
#line 1110 "../src/umockdev.vala"
		ev_data_length1 = sizeof (struct input_event);
#line 1110 "../src/umockdev.vala"
		_ev_data_size_ = ev_data_length1;
#line 1111 "../src/umockdev.vala"
		_tmp53_ = ev_data;
#line 1111 "../src/umockdev.vala"
		_tmp53__length1 = ev_data_length1;
#line 1111 "../src/umockdev.vala"
		_tmp54_ = ev_data;
#line 1111 "../src/umockdev.vala"
		_tmp54__length1 = ev_data_length1;
#line 1111 "../src/umockdev.vala"
		memcpy (_tmp53_, &ev, (gsize) _tmp54__length1);
#line 1112 "../src/umockdev.vala"
		_tmp55_ = g_strdup_printf ("%i", delay);
#line 1112 "../src/umockdev.vala"
		_tmp56_ = _tmp55_;
#line 1112 "../src/umockdev.vala"
		_tmp57_ = g_strconcat ("r ", _tmp56_, NULL);
#line 1112 "../src/umockdev.vala"
		_tmp58_ = _tmp57_;
#line 1112 "../src/umockdev.vala"
		_tmp59_ = g_strconcat (_tmp58_, " ", NULL);
#line 1112 "../src/umockdev.vala"
		_tmp60_ = _tmp59_;
#line 1112 "../src/umockdev.vala"
		_tmp61_ = ev_data;
#line 1112 "../src/umockdev.vala"
		_tmp61__length1 = ev_data_length1;
#line 1112 "../src/umockdev.vala"
		_tmp62_ = umockdev_script_runner_encode (_tmp61_, (gint) _tmp61__length1);
#line 1112 "../src/umockdev.vala"
		_tmp63_ = _tmp62_;
#line 1112 "../src/umockdev.vala"
		_tmp64_ = g_strconcat (_tmp60_, _tmp63_, NULL);
#line 1112 "../src/umockdev.vala"
		_tmp65_ = _tmp64_;
#line 1112 "../src/umockdev.vala"
		_tmp66_ = g_strconcat (_tmp65_, "\n", NULL);
#line 1112 "../src/umockdev.vala"
		_tmp67_ = _tmp66_;
#line 1112 "../src/umockdev.vala"
		_g_free0 (_tmp65_);
#line 1112 "../src/umockdev.vala"
		_g_free0 (_tmp63_);
#line 1112 "../src/umockdev.vala"
		_g_free0 (_tmp60_);
#line 1112 "../src/umockdev.vala"
		_g_free0 (_tmp58_);
#line 1112 "../src/umockdev.vala"
		_g_free0 (_tmp56_);
#line 1112 "../src/umockdev.vala"
		script_line = _tmp67_;
#line 1113 "../src/umockdev.vala"
		_tmp68_ = script_line;
#line 1113 "../src/umockdev.vala"
		_tmp69_ = script_line;
#line 1113 "../src/umockdev.vala"
		_tmp70_ = strlen (_tmp69_);
#line 1113 "../src/umockdev.vala"
		_tmp71_ = _tmp70_;
#line 1113 "../src/umockdev.vala"
		_tmp72_ = script_line;
#line 1113 "../src/umockdev.vala"
		_tmp73_ = strlen (_tmp72_);
#line 1113 "../src/umockdev.vala"
		_tmp74_ = _tmp73_;
#line 1113 "../src/umockdev.vala"
		_vala_assert (write (script_fd, _tmp68_, (gsize) _tmp71_) == ((gssize) _tmp74_), "Posix.write(script_fd, script_line, script_line.length) == script_line.length");
#line 1083 "../src/umockdev.vala"
		_g_free0 (script_line);
#line 1083 "../src/umockdev.vala"
		ev_data = (g_free (ev_data), NULL);
#line 1083 "../src/umockdev.vala"
		_g_free0 (_tmp14_);
#line 6423 "umockdev.c"
	}
#line 1116 "../src/umockdev.vala"
	close (script_fd);
#line 1118 "../src/umockdev.vala"
	_tmp75_ = g_strdup (dev);
#line 1118 "../src/umockdev.vala"
	owned_dev = _tmp75_;
#line 1119 "../src/umockdev.vala"
	_tmp76_ = owned_dev;
#line 1119 "../src/umockdev.vala"
	if (_tmp76_ == NULL) {
#line 6435 "umockdev.c"
		const gchar* _tmp77_;
		const gchar* _tmp78_;
		gchar* _tmp79_;
#line 1120 "../src/umockdev.vala"
		_tmp77_ = recorded_dev;
#line 1120 "../src/umockdev.vala"
		if (_tmp77_ == NULL) {
#line 1121 "../src/umockdev.vala"
			g_error ("umockdev.vala:1121: null passed for device node, but recording %s has " \
"no '# device' header", eventsfile);
#line 6445 "umockdev.c"
		}
#line 1122 "../src/umockdev.vala"
		_tmp78_ = recorded_dev;
#line 1122 "../src/umockdev.vala"
		_tmp79_ = g_strdup (_tmp78_);
#line 1122 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1122 "../src/umockdev.vala"
		owned_dev = _tmp79_;
#line 6455 "umockdev.c"
	}
#line 1125 "../src/umockdev.vala"
	_tmp80_ = owned_dev;
#line 1125 "../src/umockdev.vala"
	_tmp81_ = script_file;
#line 1125 "../src/umockdev.vala"
	ret = umockdev_testbed_load_script (self, _tmp80_, _tmp81_, &_inner_error0_);
#line 1125 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6465 "umockdev.c"
		gboolean _tmp82_ = FALSE;
#line 1125 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1125 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1125 "../src/umockdev.vala"
		_g_free0 (script_file);
#line 1125 "../src/umockdev.vala"
		_g_regex_unref0 (event_re);
#line 1125 "../src/umockdev.vala"
		_g_regex_unref0 (default_dev_re);
#line 1125 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1125 "../src/umockdev.vala"
		_g_free0 (recorded_dev);
#line 1125 "../src/umockdev.vala"
		_g_free0 (line);
#line 1125 "../src/umockdev.vala"
		_g_object_unref0 (s_ev);
#line 1125 "../src/umockdev.vala"
		_g_object_unref0 (_tmp1_);
#line 1125 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1125 "../src/umockdev.vala"
		return _tmp82_;
#line 6491 "umockdev.c"
	}
#line 1126 "../src/umockdev.vala"
	_tmp83_ = script_file;
#line 1126 "../src/umockdev.vala"
	g_unlink (_tmp83_);
#line 1127 "../src/umockdev.vala"
	result = ret;
#line 1127 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 1127 "../src/umockdev.vala"
	_g_free0 (script_file);
#line 1127 "../src/umockdev.vala"
	_g_regex_unref0 (event_re);
#line 1127 "../src/umockdev.vala"
	_g_regex_unref0 (default_dev_re);
#line 1127 "../src/umockdev.vala"
	_g_match_info_unref0 (match);
#line 1127 "../src/umockdev.vala"
	_g_free0 (recorded_dev);
#line 1127 "../src/umockdev.vala"
	_g_free0 (line);
#line 1127 "../src/umockdev.vala"
	_g_object_unref0 (s_ev);
#line 1127 "../src/umockdev.vala"
	_g_object_unref0 (_tmp1_);
#line 1127 "../src/umockdev.vala"
	_g_object_unref0 (f_ev);
#line 1127 "../src/umockdev.vala"
	return result;
#line 6521 "umockdev.c"
}

static GHashTable*
umockdev_testbed_create_bus_lookup (void)
{
	GHashTable* lookup = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	gchar* _tmp94_;
	gchar* _tmp95_;
	gchar* _tmp96_;
	gchar* _tmp97_;
	gchar* _tmp98_;
	gchar* _tmp99_;
	gchar* _tmp100_;
	gchar* _tmp101_;
	gchar* _tmp102_;
	gchar* _tmp103_;
	gchar* _tmp104_;
	gchar* _tmp105_;
	gchar* _tmp106_;
	gchar* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	gchar* _tmp110_;
	gchar* _tmp111_;
	gchar* _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	gchar* _tmp115_;
	gchar* _tmp116_;
	gchar* _tmp117_;
	gchar* _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	gchar* _tmp121_;
	gchar* _tmp122_;
	gchar* _tmp123_;
	gchar* _tmp124_;
	gchar* _tmp125_;
	gchar* _tmp126_;
	gchar* _tmp127_;
	gchar* _tmp128_;
	gchar* _tmp129_;
	gchar* _tmp130_;
	gchar* _tmp131_;
	gchar* _tmp132_;
	GHashTable* result;
#line 1133 "../src/umockdev.vala"
	_tmp0_ = g_str_hash;
#line 1133 "../src/umockdev.vala"
	_tmp1_ = g_str_equal;
#line 1133 "../src/umockdev.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 1133 "../src/umockdev.vala"
	lookup = _tmp2_;
#line 1136 "../src/umockdev.vala"
	_tmp3_ = g_strdup ("ac97");
#line 1136 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp3_, NULL);
#line 1137 "../src/umockdev.vala"
	_tmp4_ = g_strdup ("ac97bus");
#line 1137 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp4_, NULL);
#line 1138 "../src/umockdev.vala"
	_tmp5_ = g_strdup ("acpi");
#line 1138 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp5_, NULL);
#line 1139 "../src/umockdev.vala"
	_tmp6_ = g_strdup ("amba");
#line 1139 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp6_, NULL);
#line 1140 "../src/umockdev.vala"
	_tmp7_ = g_strdup ("anybuss");
#line 1140 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp7_, NULL);
#line 1141 "../src/umockdev.vala"
	_tmp8_ = g_strdup ("aoa-soundbus");
#line 1141 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp8_, NULL);
#line 1142 "../src/umockdev.vala"
	_tmp9_ = g_strdup ("ap");
#line 1142 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp9_, NULL);
#line 1143 "../src/umockdev.vala"
	_tmp10_ = g_strdup ("aprbus");
#line 1143 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp10_, NULL);
#line 1144 "../src/umockdev.vala"
	_tmp11_ = g_strdup ("bcma");
#line 1144 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp11_, NULL);
#line 1145 "../src/umockdev.vala"
	_tmp12_ = g_strdup ("bttv-sub");
#line 1145 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp12_, NULL);
#line 1146 "../src/umockdev.vala"
	_tmp13_ = g_strdup ("ccw");
#line 1146 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp13_, NULL);
#line 1147 "../src/umockdev.vala"
	_tmp14_ = g_strdup ("ccwgroup");
#line 1147 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp14_, NULL);
#line 1148 "../src/umockdev.vala"
	_tmp15_ = g_strdup ("cdmm");
#line 1148 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp15_, NULL);
#line 1149 "../src/umockdev.vala"
	_tmp16_ = g_strdup ("cec");
#line 1149 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp16_, NULL);
#line 1150 "../src/umockdev.vala"
	_tmp17_ = g_strdup ("coreboot");
#line 1150 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp17_, NULL);
#line 1151 "../src/umockdev.vala"
	_tmp18_ = g_strdup ("coresight");
#line 1151 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp18_, NULL);
#line 1152 "../src/umockdev.vala"
	_tmp19_ = g_strdup ("cosm_bus");
#line 1152 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp19_, NULL);
#line 1153 "../src/umockdev.vala"
	_tmp20_ = g_strdup ("counter");
#line 1153 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp20_, NULL);
#line 1154 "../src/umockdev.vala"
	_tmp21_ = g_strdup ("css");
#line 1154 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp21_, NULL);
#line 1155 "../src/umockdev.vala"
	_tmp22_ = g_strdup ("dax");
#line 1155 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp22_, NULL);
#line 1156 "../src/umockdev.vala"
	_tmp23_ = g_strdup ("dio");
#line 1156 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp23_, NULL);
#line 1157 "../src/umockdev.vala"
	_tmp24_ = g_strdup ("ecard");
#line 1157 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp24_, NULL);
#line 1158 "../src/umockdev.vala"
	_tmp25_ = g_strdup ("eisa");
#line 1158 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp25_, NULL);
#line 1159 "../src/umockdev.vala"
	_tmp26_ = g_strdup ("event_source");
#line 1159 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp26_, NULL);
#line 1160 "../src/umockdev.vala"
	_tmp27_ = g_strdup ("fcoe");
#line 1160 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp27_, NULL);
#line 1161 "../src/umockdev.vala"
	_tmp28_ = g_strdup ("firewire");
#line 1161 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp28_, NULL);
#line 1162 "../src/umockdev.vala"
	_tmp29_ = g_strdup ("fsi");
#line 1162 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp29_, NULL);
#line 1163 "../src/umockdev.vala"
	_tmp30_ = g_strdup ("fsl-mc");
#line 1163 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp30_, NULL);
#line 1164 "../src/umockdev.vala"
	_tmp31_ = g_strdup ("gameport");
#line 1164 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp31_, NULL);
#line 1165 "../src/umockdev.vala"
	_tmp32_ = g_strdup ("gbphy");
#line 1165 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp32_, NULL);
#line 1166 "../src/umockdev.vala"
	_tmp33_ = g_strdup ("genpd");
#line 1166 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp33_, NULL);
#line 1167 "../src/umockdev.vala"
	_tmp34_ = g_strdup ("gio");
#line 1167 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp34_, NULL);
#line 1168 "../src/umockdev.vala"
	_tmp35_ = g_strdup ("gpio");
#line 1168 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp35_, NULL);
#line 1169 "../src/umockdev.vala"
	_tmp36_ = g_strdup ("greybus");
#line 1169 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp36_, NULL);
#line 1170 "../src/umockdev.vala"
	_tmp37_ = g_strdup ("hdaudio");
#line 1170 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp37_, NULL);
#line 1171 "../src/umockdev.vala"
	_tmp38_ = g_strdup ("hid");
#line 1171 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp38_, NULL);
#line 1172 "../src/umockdev.vala"
	_tmp39_ = g_strdup ("host1x");
#line 1172 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp39_, NULL);
#line 1173 "../src/umockdev.vala"
	_tmp40_ = g_strdup ("hsi");
#line 1173 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp40_, NULL);
#line 1174 "../src/umockdev.vala"
	_tmp41_ = g_strdup ("i2c");
#line 1174 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp41_, NULL);
#line 1175 "../src/umockdev.vala"
	_tmp42_ = g_strdup ("i3c");
#line 1175 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp42_, NULL);
#line 1176 "../src/umockdev.vala"
	_tmp43_ = g_strdup ("ibmebus");
#line 1176 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp43_, NULL);
#line 1177 "../src/umockdev.vala"
	_tmp44_ = g_strdup ("ide");
#line 1177 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp44_, NULL);
#line 1178 "../src/umockdev.vala"
	_tmp45_ = g_strdup ("iio");
#line 1178 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp45_, NULL);
#line 1179 "../src/umockdev.vala"
	_tmp46_ = g_strdup ("iio");
#line 1179 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp46_, NULL);
#line 1180 "../src/umockdev.vala"
	_tmp47_ = g_strdup ("intel_th");
#line 1180 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp47_, NULL);
#line 1181 "../src/umockdev.vala"
	_tmp48_ = g_strdup ("ipack");
#line 1181 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp48_, NULL);
#line 1182 "../src/umockdev.vala"
	_tmp49_ = g_strdup ("isa");
#line 1182 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp49_, NULL);
#line 1183 "../src/umockdev.vala"
	_tmp50_ = g_strdup ("iscsi_flashnode");
#line 1183 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp50_, NULL);
#line 1184 "../src/umockdev.vala"
	_tmp51_ = g_strdup ("ishtp");
#line 1184 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp51_, NULL);
#line 1185 "../src/umockdev.vala"
	_tmp52_ = g_strdup ("iucv");
#line 1185 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp52_, NULL);
#line 1186 "../src/umockdev.vala"
	_tmp53_ = g_strdup ("locomo-bus");
#line 1186 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp53_, NULL);
#line 1187 "../src/umockdev.vala"
	_tmp54_ = g_strdup ("logicmodule");
#line 1187 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp54_, NULL);
#line 1188 "../src/umockdev.vala"
	_tmp55_ = g_strdup ("macio");
#line 1188 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp55_, NULL);
#line 1189 "../src/umockdev.vala"
	_tmp56_ = g_strdup ("maple");
#line 1189 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp56_, NULL);
#line 1190 "../src/umockdev.vala"
	_tmp57_ = g_strdup ("matrix");
#line 1190 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp57_, NULL);
#line 1191 "../src/umockdev.vala"
	_tmp58_ = g_strdup ("mcb");
#line 1191 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp58_, NULL);
#line 1192 "../src/umockdev.vala"
	_tmp59_ = g_strdup ("mcp");
#line 1192 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp59_, NULL);
#line 1193 "../src/umockdev.vala"
	_tmp60_ = g_strdup ("mdev");
#line 1193 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp60_, NULL);
#line 1194 "../src/umockdev.vala"
	_tmp61_ = g_strdup ("mdio_bus");
#line 1194 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp61_, NULL);
#line 1195 "../src/umockdev.vala"
	_tmp62_ = g_strdup ("media");
#line 1195 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp62_, NULL);
#line 1196 "../src/umockdev.vala"
	_tmp63_ = g_strdup ("mei");
#line 1196 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp63_, NULL);
#line 1197 "../src/umockdev.vala"
	_tmp64_ = g_strdup ("memstick");
#line 1197 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp64_, NULL);
#line 1198 "../src/umockdev.vala"
	_tmp65_ = g_strdup ("mic_bus");
#line 1198 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp65_, NULL);
#line 1199 "../src/umockdev.vala"
	_tmp66_ = g_strdup ("mipi-dsi");
#line 1199 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp66_, NULL);
#line 1200 "../src/umockdev.vala"
	_tmp67_ = g_strdup ("mmc_rpmb");
#line 1200 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp67_, NULL);
#line 1201 "../src/umockdev.vala"
	_tmp68_ = g_strdup ("mmc");
#line 1201 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp68_, NULL);
#line 1202 "../src/umockdev.vala"
	_tmp69_ = g_strdup ("most");
#line 1202 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp69_, NULL);
#line 1203 "../src/umockdev.vala"
	_tmp70_ = g_strdup ("nd");
#line 1203 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp70_, NULL);
#line 1204 "../src/umockdev.vala"
	_tmp71_ = g_strdup ("netdevsim");
#line 1204 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp71_, NULL);
#line 1205 "../src/umockdev.vala"
	_tmp72_ = g_strdup ("ntb_transport");
#line 1205 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp72_, NULL);
#line 1206 "../src/umockdev.vala"
	_tmp73_ = g_strdup ("ntb");
#line 1206 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp73_, NULL);
#line 1207 "../src/umockdev.vala"
	_tmp74_ = g_strdup ("nubus");
#line 1207 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp74_, NULL);
#line 1208 "../src/umockdev.vala"
	_tmp75_ = g_strdup ("nvmem");
#line 1208 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp75_, NULL);
#line 1209 "../src/umockdev.vala"
	_tmp76_ = g_strdup ("parisc");
#line 1209 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp76_, NULL);
#line 1210 "../src/umockdev.vala"
	_tmp77_ = g_strdup ("parport");
#line 1210 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp77_, NULL);
#line 1211 "../src/umockdev.vala"
	_tmp78_ = g_strdup ("pci-epf");
#line 1211 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp78_, NULL);
#line 1212 "../src/umockdev.vala"
	_tmp79_ = g_strdup ("pci");
#line 1212 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp79_, NULL);
#line 1213 "../src/umockdev.vala"
	_tmp80_ = g_strdup ("pcmcia");
#line 1213 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp80_, NULL);
#line 1214 "../src/umockdev.vala"
	_tmp81_ = g_strdup ("platform");
#line 1214 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp81_, NULL);
#line 1215 "../src/umockdev.vala"
	_tmp82_ = g_strdup ("pnp");
#line 1215 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp82_, NULL);
#line 1216 "../src/umockdev.vala"
	_tmp83_ = g_strdup ("ps3_system_bus");
#line 1216 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp83_, NULL);
#line 1217 "../src/umockdev.vala"
	_tmp84_ = g_strdup ("pseudo");
#line 1217 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp84_, NULL);
#line 1218 "../src/umockdev.vala"
	_tmp85_ = g_strdup ("rapidio");
#line 1218 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp85_, NULL);
#line 1219 "../src/umockdev.vala"
	_tmp86_ = g_strdup ("rbd");
#line 1219 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp86_, NULL);
#line 1220 "../src/umockdev.vala"
	_tmp87_ = g_strdup ("rmi4");
#line 1220 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp87_, NULL);
#line 1221 "../src/umockdev.vala"
	_tmp88_ = g_strdup ("rpmsg");
#line 1221 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp88_, NULL);
#line 1222 "../src/umockdev.vala"
	_tmp89_ = g_strdup ("sa1111-rab");
#line 1222 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp89_, NULL);
#line 1223 "../src/umockdev.vala"
	_tmp90_ = g_strdup ("scif_bus");
#line 1223 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp90_, NULL);
#line 1224 "../src/umockdev.vala"
	_tmp91_ = g_strdup ("scif_peer_bus");
#line 1224 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp91_, NULL);
#line 1225 "../src/umockdev.vala"
	_tmp92_ = g_strdup ("scm");
#line 1225 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp92_, NULL);
#line 1226 "../src/umockdev.vala"
	_tmp93_ = g_strdup ("scmi_protocol");
#line 1226 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp93_, NULL);
#line 1227 "../src/umockdev.vala"
	_tmp94_ = g_strdup ("scsi");
#line 1227 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp94_, NULL);
#line 1228 "../src/umockdev.vala"
	_tmp95_ = g_strdup ("sdio");
#line 1228 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp95_, NULL);
#line 1229 "../src/umockdev.vala"
	_tmp96_ = g_strdup ("serial");
#line 1229 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp96_, NULL);
#line 1230 "../src/umockdev.vala"
	_tmp97_ = g_strdup ("serio");
#line 1230 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp97_, NULL);
#line 1231 "../src/umockdev.vala"
	_tmp98_ = g_strdup ("siox");
#line 1231 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp98_, NULL);
#line 1232 "../src/umockdev.vala"
	_tmp99_ = g_strdup ("slimbus");
#line 1232 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp99_, NULL);
#line 1233 "../src/umockdev.vala"
	_tmp100_ = g_strdup ("snd_seq");
#line 1233 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp100_, NULL);
#line 1234 "../src/umockdev.vala"
	_tmp101_ = g_strdup ("soc");
#line 1234 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp101_, NULL);
#line 1235 "../src/umockdev.vala"
	_tmp102_ = g_strdup ("soundwire");
#line 1235 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp102_, NULL);
#line 1236 "../src/umockdev.vala"
	_tmp103_ = g_strdup ("spi");
#line 1236 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp103_, NULL);
#line 1237 "../src/umockdev.vala"
	_tmp104_ = g_strdup ("spmi");
#line 1237 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp104_, NULL);
#line 1238 "../src/umockdev.vala"
	_tmp105_ = g_strdup ("ssb");
#line 1238 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp105_, NULL);
#line 1239 "../src/umockdev.vala"
	_tmp106_ = g_strdup ("sunxi-rsb");
#line 1239 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp106_, NULL);
#line 1240 "../src/umockdev.vala"
	_tmp107_ = g_strdup ("superhyway");
#line 1240 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp107_, NULL);
#line 1241 "../src/umockdev.vala"
	_tmp108_ = g_strdup ("tc");
#line 1241 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp108_, NULL);
#line 1242 "../src/umockdev.vala"
	_tmp109_ = g_strdup ("tcm_loop_bus");
#line 1242 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp109_, NULL);
#line 1243 "../src/umockdev.vala"
	_tmp110_ = g_strdup ("tee");
#line 1243 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp110_, NULL);
#line 1244 "../src/umockdev.vala"
	_tmp111_ = g_strdup ("thunderbolt");
#line 1244 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp111_, NULL);
#line 1245 "../src/umockdev.vala"
	_tmp112_ = g_strdup ("tifm");
#line 1245 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp112_, NULL);
#line 1246 "../src/umockdev.vala"
	_tmp113_ = g_strdup ("tiocx");
#line 1246 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp113_, NULL);
#line 1247 "../src/umockdev.vala"
	_tmp114_ = g_strdup ("typec");
#line 1247 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp114_, NULL);
#line 1248 "../src/umockdev.vala"
	_tmp115_ = g_strdup ("ulpi");
#line 1248 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp115_, NULL);
#line 1249 "../src/umockdev.vala"
	_tmp116_ = g_strdup ("umc");
#line 1249 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp116_, NULL);
#line 1250 "../src/umockdev.vala"
	_tmp117_ = g_strdup ("usb-serial");
#line 1250 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp117_, NULL);
#line 1251 "../src/umockdev.vala"
	_tmp118_ = g_strdup ("usb");
#line 1251 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp118_, NULL);
#line 1252 "../src/umockdev.vala"
	_tmp119_ = g_strdup ("usb");
#line 1252 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp119_, NULL);
#line 1253 "../src/umockdev.vala"
	_tmp120_ = g_strdup ("uwb");
#line 1253 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp120_, NULL);
#line 1254 "../src/umockdev.vala"
	_tmp121_ = g_strdup ("vio");
#line 1254 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp121_, NULL);
#line 1255 "../src/umockdev.vala"
	_tmp122_ = g_strdup ("virtio");
#line 1255 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp122_, NULL);
#line 1256 "../src/umockdev.vala"
	_tmp123_ = g_strdup ("visorbus");
#line 1256 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp123_, NULL);
#line 1257 "../src/umockdev.vala"
	_tmp124_ = g_strdup ("vlynq");
#line 1257 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp124_, NULL);
#line 1258 "../src/umockdev.vala"
	_tmp125_ = g_strdup ("vmbus");
#line 1258 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp125_, NULL);
#line 1259 "../src/umockdev.vala"
	_tmp126_ = g_strdup ("vme");
#line 1259 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp126_, NULL);
#line 1260 "../src/umockdev.vala"
	_tmp127_ = g_strdup ("vop_bus");
#line 1260 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp127_, NULL);
#line 1261 "../src/umockdev.vala"
	_tmp128_ = g_strdup ("w1");
#line 1261 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp128_, NULL);
#line 1262 "../src/umockdev.vala"
	_tmp129_ = g_strdup ("wmi_bus");
#line 1262 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp129_, NULL);
#line 1263 "../src/umockdev.vala"
	_tmp130_ = g_strdup ("xen-backend");
#line 1263 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp130_, NULL);
#line 1264 "../src/umockdev.vala"
	_tmp131_ = g_strdup ("xen");
#line 1264 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp131_, NULL);
#line 1265 "../src/umockdev.vala"
	_tmp132_ = g_strdup ("zorro");
#line 1265 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp132_, NULL);
#line 1267 "../src/umockdev.vala"
	result = lookup;
#line 1267 "../src/umockdev.vala"
	return result;
#line 7194 "umockdev.c"
}

static gboolean
umockdev_testbed_subsystem_is_bus (const gchar* subsystem)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp2_;
	gboolean result;
#line 1270 "../src/umockdev.vala"
	g_return_val_if_fail (subsystem != NULL, FALSE);
#line 1271 "../src/umockdev.vala"
	_tmp0_ = umockdev_testbed_bus_lookup_table;
#line 1271 "../src/umockdev.vala"
	if (_tmp0_ == NULL) {
#line 7209 "umockdev.c"
		GHashTable* _tmp1_;
#line 1272 "../src/umockdev.vala"
		_tmp1_ = umockdev_testbed_create_bus_lookup ();
#line 1272 "../src/umockdev.vala"
		_g_hash_table_unref0 (umockdev_testbed_bus_lookup_table);
#line 1272 "../src/umockdev.vala"
		umockdev_testbed_bus_lookup_table = _tmp1_;
#line 7217 "umockdev.c"
	}
#line 1275 "../src/umockdev.vala"
	_tmp2_ = umockdev_testbed_bus_lookup_table;
#line 1275 "../src/umockdev.vala"
	result = g_hash_table_contains (_tmp2_, subsystem);
#line 1275 "../src/umockdev.vala"
	return result;
#line 7225 "umockdev.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1313 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1313 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1313 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7240 "umockdev.c"
	}
#line 1313 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1313 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7246 "umockdev.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1314 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1314 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1314 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7261 "umockdev.c"
	}
#line 1314 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1314 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7267 "umockdev.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1318 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1318 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1318 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7282 "umockdev.c"
	}
#line 1318 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1318 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7288 "umockdev.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1320 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1320 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1320 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7303 "umockdev.c"
	}
#line 1320 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1320 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7309 "umockdev.c"
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1326 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1326 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1326 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7324 "umockdev.c"
	}
#line 1326 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1326 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7330 "umockdev.c"
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1327 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1327 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1327 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7345 "umockdev.c"
	}
#line 1327 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1327 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7351 "umockdev.c"
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1331 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1331 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1331 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7366 "umockdev.c"
	}
#line 1331 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1331 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7372 "umockdev.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1332 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1332 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1332 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7387 "umockdev.c"
	}
#line 1332 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1332 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7393 "umockdev.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1355 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1355 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1355 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7408 "umockdev.c"
	}
#line 1355 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1355 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7414 "umockdev.c"
}

static gchar*
umockdev_testbed_add_dev_from_string (UMockdevTestbed* self,
                                      const gchar* data,
                                      GError** error)
{
	gchar type = '\0';
	gchar* key = NULL;
	gchar* val = NULL;
	gchar* devpath = NULL;
	gchar* subsystem = NULL;
	gchar* majmin = NULL;
	gchar* cur_data = NULL;
	gchar* _tmp0_;
	gchar* devnode_path = NULL;
	guint8* devnode_contents = NULL;
	guint8* _tmp1_;
	gint devnode_contents_length1;
	gint _devnode_contents_size_;
	gchar** devnode_links = NULL;
	gchar** _tmp2_;
	gint devnode_links_length1;
	gint _devnode_links_size_;
	const gchar* _tmp3_;
	gchar _tmp4_ = '\0';
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	const gchar* _tmp11_;
	const gchar* _tmp14_;
	gchar** attrs = NULL;
	gchar** _tmp15_;
	gint attrs_length1;
	gint _attrs_size_;
	gchar** binattrs = NULL;
	gchar** _tmp16_;
	gint binattrs_length1;
	gint _binattrs_size_;
	gchar** linkattrs = NULL;
	gchar** _tmp17_;
	gint linkattrs_length1;
	gint _linkattrs_size_;
	gchar** props = NULL;
	gchar** _tmp18_;
	gint props_length1;
	gint _props_size_;
	const gchar* _tmp77_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	gchar* syspath = NULL;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gchar** _tmp86_;
	gint _tmp86__length1;
	gchar** _tmp87_;
	gint _tmp87__length1;
	gchar* _tmp88_;
	gchar* _tmp89_;
	const gchar* _tmp107_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1278 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1278 "../src/umockdev.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 1283 "../src/umockdev.vala"
	devpath = NULL;
#line 1284 "../src/umockdev.vala"
	subsystem = NULL;
#line 1285 "../src/umockdev.vala"
	majmin = NULL;
#line 1286 "../src/umockdev.vala"
	_tmp0_ = g_strdup (data);
#line 1286 "../src/umockdev.vala"
	cur_data = _tmp0_;
#line 1287 "../src/umockdev.vala"
	devnode_path = NULL;
#line 1288 "../src/umockdev.vala"
	_tmp1_ = g_new0 (guint8, 0);
#line 1288 "../src/umockdev.vala"
	devnode_contents = _tmp1_;
#line 1288 "../src/umockdev.vala"
	devnode_contents_length1 = 0;
#line 1288 "../src/umockdev.vala"
	_devnode_contents_size_ = devnode_contents_length1;
#line 1289 "../src/umockdev.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 1289 "../src/umockdev.vala"
	devnode_links = _tmp2_;
#line 1289 "../src/umockdev.vala"
	devnode_links_length1 = 0;
#line 1289 "../src/umockdev.vala"
	_devnode_links_size_ = devnode_links_length1;
#line 1291 "../src/umockdev.vala"
	_tmp3_ = cur_data;
#line 1291 "../src/umockdev.vala"
	_tmp7_ = umockdev_testbed_record_parse_line (self, _tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 1291 "../src/umockdev.vala"
	type = _tmp4_;
#line 1291 "../src/umockdev.vala"
	_g_free0 (key);
#line 1291 "../src/umockdev.vala"
	key = _tmp5_;
#line 1291 "../src/umockdev.vala"
	_g_free0 (devpath);
#line 1291 "../src/umockdev.vala"
	devpath = _tmp6_;
#line 1291 "../src/umockdev.vala"
	_g_free0 (cur_data);
#line 1291 "../src/umockdev.vala"
	cur_data = _tmp7_;
#line 1292 "../src/umockdev.vala"
	_tmp9_ = cur_data;
#line 1292 "../src/umockdev.vala"
	if (_tmp9_ == NULL) {
#line 1292 "../src/umockdev.vala"
		_tmp8_ = TRUE;
#line 7537 "umockdev.c"
	} else {
#line 1292 "../src/umockdev.vala"
		_tmp8_ = type != 'P';
#line 7541 "umockdev.c"
	}
#line 1292 "../src/umockdev.vala"
	if (_tmp8_) {
#line 7545 "umockdev.c"
		GError* _tmp10_;
#line 1293 "../src/umockdev.vala"
		_tmp10_ = g_error_new_literal (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "device descriptions must start with a \"P: /devices/path/...\" line");
#line 1293 "../src/umockdev.vala"
		_inner_error0_ = _tmp10_;
#line 1293 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1293 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1293 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1293 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1293 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1293 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1293 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1293 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1293 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1293 "../src/umockdev.vala"
			_g_free0 (val);
#line 1293 "../src/umockdev.vala"
			_g_free0 (key);
#line 1293 "../src/umockdev.vala"
			return NULL;
#line 7575 "umockdev.c"
		} else {
#line 1293 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1293 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1293 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1293 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1293 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1293 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1293 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1293 "../src/umockdev.vala"
			_g_free0 (val);
#line 1293 "../src/umockdev.vala"
			_g_free0 (key);
#line 1293 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1293 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1293 "../src/umockdev.vala"
			return NULL;
#line 7601 "umockdev.c"
		}
	}
#line 1294 "../src/umockdev.vala"
	_tmp11_ = devpath;
#line 1294 "../src/umockdev.vala"
	if (!g_str_has_prefix (_tmp11_, "/devices/")) {
#line 7608 "umockdev.c"
		const gchar* _tmp12_;
		GError* _tmp13_;
#line 1295 "../src/umockdev.vala"
		_tmp12_ = devpath;
#line 1295 "../src/umockdev.vala"
		_tmp13_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_VALUE, "invalid device path '%s': must start with /devices/", _tmp12_);
#line 1295 "../src/umockdev.vala"
		_inner_error0_ = _tmp13_;
#line 1295 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1295 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1295 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1295 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1295 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1295 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1295 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1295 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1295 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1295 "../src/umockdev.vala"
			_g_free0 (val);
#line 1295 "../src/umockdev.vala"
			_g_free0 (key);
#line 1295 "../src/umockdev.vala"
			return NULL;
#line 7641 "umockdev.c"
		} else {
#line 1295 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1295 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1295 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1295 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1295 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1295 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1295 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1295 "../src/umockdev.vala"
			_g_free0 (val);
#line 1295 "../src/umockdev.vala"
			_g_free0 (key);
#line 1295 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1295 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1295 "../src/umockdev.vala"
			return NULL;
#line 7667 "umockdev.c"
		}
	}
#line 1297 "../src/umockdev.vala"
	_tmp14_ = devpath;
#line 1297 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1297: parsing device description for %s", _tmp14_);
#line 1299 "../src/umockdev.vala"
	_tmp15_ = g_new0 (gchar*, 0 + 1);
#line 1299 "../src/umockdev.vala"
	attrs = _tmp15_;
#line 1299 "../src/umockdev.vala"
	attrs_length1 = 0;
#line 1299 "../src/umockdev.vala"
	_attrs_size_ = attrs_length1;
#line 1300 "../src/umockdev.vala"
	_tmp16_ = g_new0 (gchar*, 0 + 1);
#line 1300 "../src/umockdev.vala"
	binattrs = _tmp16_;
#line 1300 "../src/umockdev.vala"
	binattrs_length1 = 0;
#line 1300 "../src/umockdev.vala"
	_binattrs_size_ = binattrs_length1;
#line 1301 "../src/umockdev.vala"
	_tmp17_ = g_new0 (gchar*, 0 + 1);
#line 1301 "../src/umockdev.vala"
	linkattrs = _tmp17_;
#line 1301 "../src/umockdev.vala"
	linkattrs_length1 = 0;
#line 1301 "../src/umockdev.vala"
	_linkattrs_size_ = linkattrs_length1;
#line 1302 "../src/umockdev.vala"
	_tmp18_ = g_new0 (gchar*, 0 + 1);
#line 1302 "../src/umockdev.vala"
	props = _tmp18_;
#line 1302 "../src/umockdev.vala"
	props_length1 = 0;
#line 1302 "../src/umockdev.vala"
	_props_size_ = props_length1;
#line 1305 "../src/umockdev.vala"
	while (TRUE) {
#line 7708 "umockdev.c"
		gboolean _tmp19_ = FALSE;
		const gchar* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		const gchar* _tmp24_;
		gchar _tmp25_ = '\0';
		gchar* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
		const gchar* _tmp29_;
#line 1305 "../src/umockdev.vala"
		_tmp20_ = cur_data;
#line 1305 "../src/umockdev.vala"
		_tmp21_ = strlen (_tmp20_);
#line 1305 "../src/umockdev.vala"
		_tmp22_ = _tmp21_;
#line 1305 "../src/umockdev.vala"
		if (_tmp22_ > 0) {
#line 7727 "umockdev.c"
			const gchar* _tmp23_;
#line 1305 "../src/umockdev.vala"
			_tmp23_ = cur_data;
#line 1305 "../src/umockdev.vala"
			_tmp19_ = string_get (_tmp23_, (glong) 0) != '\n';
#line 7733 "umockdev.c"
		} else {
#line 1305 "../src/umockdev.vala"
			_tmp19_ = FALSE;
#line 7737 "umockdev.c"
		}
#line 1305 "../src/umockdev.vala"
		if (!_tmp19_) {
#line 1305 "../src/umockdev.vala"
			break;
#line 7743 "umockdev.c"
		}
#line 1306 "../src/umockdev.vala"
		_tmp24_ = cur_data;
#line 1306 "../src/umockdev.vala"
		_tmp28_ = umockdev_testbed_record_parse_line (self, _tmp24_, &_tmp25_, &_tmp26_, &_tmp27_);
#line 1306 "../src/umockdev.vala"
		type = _tmp25_;
#line 1306 "../src/umockdev.vala"
		_g_free0 (key);
#line 1306 "../src/umockdev.vala"
		key = _tmp26_;
#line 1306 "../src/umockdev.vala"
		_g_free0 (val);
#line 1306 "../src/umockdev.vala"
		val = _tmp27_;
#line 1306 "../src/umockdev.vala"
		_g_free0 (cur_data);
#line 1306 "../src/umockdev.vala"
		cur_data = _tmp28_;
#line 1307 "../src/umockdev.vala"
		_tmp29_ = cur_data;
#line 1307 "../src/umockdev.vala"
		if (_tmp29_ == NULL) {
#line 7767 "umockdev.c"
			const gchar* _tmp30_;
			GError* _tmp31_;
#line 1308 "../src/umockdev.vala"
			_tmp30_ = devpath;
#line 1308 "../src/umockdev.vala"
			_tmp31_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "malformed attribute or property line in description of device %s", _tmp30_);
#line 1308 "../src/umockdev.vala"
			_inner_error0_ = _tmp31_;
#line 1308 "../src/umockdev.vala"
			if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1308 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 1308 "../src/umockdev.vala"
				props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				devnode_contents = (g_free (devnode_contents), NULL);
#line 1308 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1308 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 1308 "../src/umockdev.vala"
				_g_free0 (majmin);
#line 1308 "../src/umockdev.vala"
				_g_free0 (subsystem);
#line 1308 "../src/umockdev.vala"
				_g_free0 (devpath);
#line 1308 "../src/umockdev.vala"
				_g_free0 (val);
#line 1308 "../src/umockdev.vala"
				_g_free0 (key);
#line 1308 "../src/umockdev.vala"
				return NULL;
#line 7808 "umockdev.c"
			} else {
#line 1308 "../src/umockdev.vala"
				props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1308 "../src/umockdev.vala"
				devnode_contents = (g_free (devnode_contents), NULL);
#line 1308 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1308 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 1308 "../src/umockdev.vala"
				_g_free0 (majmin);
#line 1308 "../src/umockdev.vala"
				_g_free0 (subsystem);
#line 1308 "../src/umockdev.vala"
				_g_free0 (devpath);
#line 1308 "../src/umockdev.vala"
				_g_free0 (val);
#line 1308 "../src/umockdev.vala"
				_g_free0 (key);
#line 1308 "../src/umockdev.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1308 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 1308 "../src/umockdev.vala"
				return NULL;
#line 7842 "umockdev.c"
			}
		}
#line 1311 "../src/umockdev.vala"
		switch (type) {
#line 1311 "../src/umockdev.vala"
			case 'H':
#line 7849 "umockdev.c"
			{
				const gchar* _tmp32_;
				gchar* _tmp33_;
				const gchar* _tmp34_;
				gchar* _tmp35_;
#line 1313 "../src/umockdev.vala"
				_tmp32_ = key;
#line 1313 "../src/umockdev.vala"
				_tmp33_ = g_strdup (_tmp32_);
#line 1313 "../src/umockdev.vala"
				_vala_array_add3 (&binattrs, &binattrs_length1, &_binattrs_size_, _tmp33_);
#line 1314 "../src/umockdev.vala"
				_tmp34_ = val;
#line 1314 "../src/umockdev.vala"
				_tmp35_ = g_strdup (_tmp34_);
#line 1314 "../src/umockdev.vala"
				_vala_array_add4 (&binattrs, &binattrs_length1, &_binattrs_size_, _tmp35_);
#line 1315 "../src/umockdev.vala"
				break;
#line 7869 "umockdev.c"
			}
#line 1311 "../src/umockdev.vala"
			case 'A':
#line 7873 "umockdev.c"
			{
				const gchar* _tmp36_;
				gchar* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_;
				const gchar* _tmp40_;
				gchar* _tmp41_;
				const gchar* _tmp42_;
#line 1318 "../src/umockdev.vala"
				_tmp36_ = key;
#line 1318 "../src/umockdev.vala"
				_tmp37_ = g_strdup (_tmp36_);
#line 1318 "../src/umockdev.vala"
				_vala_array_add5 (&attrs, &attrs_length1, &_attrs_size_, _tmp37_);
#line 1319 "../src/umockdev.vala"
				_tmp38_ = val;
#line 1319 "../src/umockdev.vala"
				_tmp39_ = g_strcompress (_tmp38_);
#line 1319 "../src/umockdev.vala"
				_g_free0 (val);
#line 1319 "../src/umockdev.vala"
				val = _tmp39_;
#line 1320 "../src/umockdev.vala"
				_tmp40_ = val;
#line 1320 "../src/umockdev.vala"
				_tmp41_ = g_strdup (_tmp40_);
#line 1320 "../src/umockdev.vala"
				_vala_array_add6 (&attrs, &attrs_length1, &_attrs_size_, _tmp41_);
#line 1321 "../src/umockdev.vala"
				_tmp42_ = key;
#line 1321 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp42_, "dev") == 0) {
#line 7906 "umockdev.c"
					const gchar* _tmp43_;
					gchar* _tmp44_;
#line 1322 "../src/umockdev.vala"
					_tmp43_ = val;
#line 1322 "../src/umockdev.vala"
					_tmp44_ = g_strdup (_tmp43_);
#line 1322 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1322 "../src/umockdev.vala"
					majmin = _tmp44_;
#line 7917 "umockdev.c"
				}
#line 1323 "../src/umockdev.vala"
				break;
#line 7921 "umockdev.c"
			}
#line 1311 "../src/umockdev.vala"
			case 'L':
#line 7925 "umockdev.c"
			{
				const gchar* _tmp45_;
				gchar* _tmp46_;
				const gchar* _tmp47_;
				gchar* _tmp48_;
#line 1326 "../src/umockdev.vala"
				_tmp45_ = key;
#line 1326 "../src/umockdev.vala"
				_tmp46_ = g_strdup (_tmp45_);
#line 1326 "../src/umockdev.vala"
				_vala_array_add7 (&linkattrs, &linkattrs_length1, &_linkattrs_size_, _tmp46_);
#line 1327 "../src/umockdev.vala"
				_tmp47_ = val;
#line 1327 "../src/umockdev.vala"
				_tmp48_ = g_strdup (_tmp47_);
#line 1327 "../src/umockdev.vala"
				_vala_array_add8 (&linkattrs, &linkattrs_length1, &_linkattrs_size_, _tmp48_);
#line 1328 "../src/umockdev.vala"
				break;
#line 7945 "umockdev.c"
			}
#line 1311 "../src/umockdev.vala"
			case 'E':
#line 7949 "umockdev.c"
			{
				const gchar* _tmp49_;
				gchar* _tmp50_;
				const gchar* _tmp51_;
				gchar* _tmp52_;
				const gchar* _tmp53_;
#line 1331 "../src/umockdev.vala"
				_tmp49_ = key;
#line 1331 "../src/umockdev.vala"
				_tmp50_ = g_strdup (_tmp49_);
#line 1331 "../src/umockdev.vala"
				_vala_array_add9 (&props, &props_length1, &_props_size_, _tmp50_);
#line 1332 "../src/umockdev.vala"
				_tmp51_ = val;
#line 1332 "../src/umockdev.vala"
				_tmp52_ = g_strdup (_tmp51_);
#line 1332 "../src/umockdev.vala"
				_vala_array_add10 (&props, &props_length1, &_props_size_, _tmp52_);
#line 1333 "../src/umockdev.vala"
				_tmp53_ = key;
#line 1333 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp53_, "SUBSYSTEM") == 0) {
#line 7972 "umockdev.c"
					const gchar* _tmp54_;
					const gchar* _tmp57_;
					gchar* _tmp58_;
#line 1334 "../src/umockdev.vala"
					_tmp54_ = subsystem;
#line 1334 "../src/umockdev.vala"
					if (_tmp54_ != NULL) {
#line 7980 "umockdev.c"
						const gchar* _tmp55_;
						GError* _tmp56_;
#line 1335 "../src/umockdev.vala"
						_tmp55_ = devpath;
#line 1335 "../src/umockdev.vala"
						_tmp56_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_VALUE, "duplicate SUBSYSTEM property in description of device %s", _tmp55_);
#line 1335 "../src/umockdev.vala"
						_inner_error0_ = _tmp56_;
#line 1335 "../src/umockdev.vala"
						if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1335 "../src/umockdev.vala"
							g_propagate_error (error, _inner_error0_);
#line 1335 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1335 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1335 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1335 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1335 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1335 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1335 "../src/umockdev.vala"
							_g_free0 (val);
#line 1335 "../src/umockdev.vala"
							_g_free0 (key);
#line 1335 "../src/umockdev.vala"
							return NULL;
#line 8021 "umockdev.c"
						} else {
#line 1335 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1335 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1335 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1335 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1335 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1335 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1335 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1335 "../src/umockdev.vala"
							_g_free0 (val);
#line 1335 "../src/umockdev.vala"
							_g_free0 (key);
#line 1335 "../src/umockdev.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1335 "../src/umockdev.vala"
							g_clear_error (&_inner_error0_);
#line 1335 "../src/umockdev.vala"
							return NULL;
#line 8055 "umockdev.c"
						}
					}
#line 1337 "../src/umockdev.vala"
					_tmp57_ = val;
#line 1337 "../src/umockdev.vala"
					_tmp58_ = g_strdup (_tmp57_);
#line 1337 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1337 "../src/umockdev.vala"
					subsystem = _tmp58_;
#line 8066 "umockdev.c"
				}
#line 1339 "../src/umockdev.vala"
				break;
#line 8070 "umockdev.c"
			}
#line 1311 "../src/umockdev.vala"
			case 'P':
#line 8074 "umockdev.c"
			{
				const gchar* _tmp59_;
				GError* _tmp60_;
#line 1342 "../src/umockdev.vala"
				_tmp59_ = devpath;
#line 1342 "../src/umockdev.vala"
				_tmp60_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "invalid P: line in description of device %s", _tmp59_);
#line 1342 "../src/umockdev.vala"
				_inner_error0_ = _tmp60_;
#line 1342 "../src/umockdev.vala"
				if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1342 "../src/umockdev.vala"
					g_propagate_error (error, _inner_error0_);
#line 1342 "../src/umockdev.vala"
					props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1342 "../src/umockdev.vala"
					_g_free0 (devnode_path);
#line 1342 "../src/umockdev.vala"
					_g_free0 (cur_data);
#line 1342 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1342 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1342 "../src/umockdev.vala"
					_g_free0 (devpath);
#line 1342 "../src/umockdev.vala"
					_g_free0 (val);
#line 1342 "../src/umockdev.vala"
					_g_free0 (key);
#line 1342 "../src/umockdev.vala"
					return NULL;
#line 8116 "umockdev.c"
				} else {
#line 1342 "../src/umockdev.vala"
					props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1342 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1342 "../src/umockdev.vala"
					_g_free0 (devnode_path);
#line 1342 "../src/umockdev.vala"
					_g_free0 (cur_data);
#line 1342 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1342 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1342 "../src/umockdev.vala"
					_g_free0 (devpath);
#line 1342 "../src/umockdev.vala"
					_g_free0 (val);
#line 1342 "../src/umockdev.vala"
					_g_free0 (key);
#line 1342 "../src/umockdev.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1342 "../src/umockdev.vala"
					g_clear_error (&_inner_error0_);
#line 1342 "../src/umockdev.vala"
					return NULL;
#line 8150 "umockdev.c"
				}
			}
#line 1311 "../src/umockdev.vala"
			case 'N':
#line 8155 "umockdev.c"
			{
				const gchar* _tmp61_;
				const gchar* _tmp62_;
				gchar* _tmp63_;
				const gchar* _tmp64_;
#line 1346 "../src/umockdev.vala"
				_tmp61_ = self->priv->root_dir;
#line 1346 "../src/umockdev.vala"
				_tmp62_ = key;
#line 1346 "../src/umockdev.vala"
				_tmp63_ = g_build_filename (_tmp61_, "dev", _tmp62_, NULL);
#line 1346 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1346 "../src/umockdev.vala"
				devnode_path = _tmp63_;
#line 1347 "../src/umockdev.vala"
				_tmp64_ = val;
#line 1347 "../src/umockdev.vala"
				if (_tmp64_ != NULL) {
#line 8175 "umockdev.c"
					guint8* _tmp65_ = NULL;
					const gchar* _tmp66_;
					gint _tmp67_ = 0;
					guint8* _tmp68_;
					gint _tmp65__length1;
					gint __tmp65__size_;
					guint8* _tmp69_;
					gint _tmp69__length1;
#line 1348 "../src/umockdev.vala"
					_tmp66_ = val;
#line 1348 "../src/umockdev.vala"
					_tmp68_ = umockdev_decode_hex (_tmp66_, &_tmp67_, &_inner_error0_);
#line 1348 "../src/umockdev.vala"
					_tmp65_ = _tmp68_;
#line 1348 "../src/umockdev.vala"
					_tmp65__length1 = _tmp67_;
#line 1348 "../src/umockdev.vala"
					__tmp65__size_ = _tmp65__length1;
#line 1348 "../src/umockdev.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1348 "../src/umockdev.vala"
						if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1348 "../src/umockdev.vala"
							g_propagate_error (error, _inner_error0_);
#line 1348 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1348 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1348 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1348 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1348 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1348 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1348 "../src/umockdev.vala"
							_g_free0 (val);
#line 1348 "../src/umockdev.vala"
							_g_free0 (key);
#line 1348 "../src/umockdev.vala"
							return NULL;
#line 8228 "umockdev.c"
						} else {
#line 1348 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1348 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1348 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1348 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1348 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1348 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1348 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1348 "../src/umockdev.vala"
							_g_free0 (val);
#line 1348 "../src/umockdev.vala"
							_g_free0 (key);
#line 1348 "../src/umockdev.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1348 "../src/umockdev.vala"
							g_clear_error (&_inner_error0_);
#line 1348 "../src/umockdev.vala"
							return NULL;
#line 8262 "umockdev.c"
						}
					}
#line 1348 "../src/umockdev.vala"
					_tmp69_ = _tmp65_;
#line 1348 "../src/umockdev.vala"
					_tmp69__length1 = _tmp65__length1;
#line 1348 "../src/umockdev.vala"
					_tmp65_ = NULL;
#line 1348 "../src/umockdev.vala"
					_tmp65__length1 = 0;
#line 1348 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1348 "../src/umockdev.vala"
					devnode_contents = _tmp69_;
#line 1348 "../src/umockdev.vala"
					devnode_contents_length1 = _tmp69__length1;
#line 1348 "../src/umockdev.vala"
					_devnode_contents_size_ = devnode_contents_length1;
#line 1347 "../src/umockdev.vala"
					_tmp65_ = (g_free (_tmp65_), NULL);
#line 8283 "umockdev.c"
				}
#line 1349 "../src/umockdev.vala"
				break;
#line 8287 "umockdev.c"
			}
#line 1311 "../src/umockdev.vala"
			case 'S':
#line 8291 "umockdev.c"
			{
				const gchar* _tmp70_;
				const gchar* _tmp73_;
				const gchar* _tmp74_;
				gchar* _tmp75_;
#line 1353 "../src/umockdev.vala"
				_tmp70_ = val;
#line 1353 "../src/umockdev.vala"
				if (_tmp70_ == NULL) {
#line 8301 "umockdev.c"
					const gchar* _tmp71_;
					GError* _tmp72_;
#line 1354 "../src/umockdev.vala"
					_tmp71_ = devpath;
#line 1354 "../src/umockdev.vala"
					_tmp72_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "invalid S: line in description of device %s", _tmp71_);
#line 1354 "../src/umockdev.vala"
					_inner_error0_ = _tmp72_;
#line 1354 "../src/umockdev.vala"
					if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1354 "../src/umockdev.vala"
						g_propagate_error (error, _inner_error0_);
#line 1354 "../src/umockdev.vala"
						props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						devnode_contents = (g_free (devnode_contents), NULL);
#line 1354 "../src/umockdev.vala"
						_g_free0 (devnode_path);
#line 1354 "../src/umockdev.vala"
						_g_free0 (cur_data);
#line 1354 "../src/umockdev.vala"
						_g_free0 (majmin);
#line 1354 "../src/umockdev.vala"
						_g_free0 (subsystem);
#line 1354 "../src/umockdev.vala"
						_g_free0 (devpath);
#line 1354 "../src/umockdev.vala"
						_g_free0 (val);
#line 1354 "../src/umockdev.vala"
						_g_free0 (key);
#line 1354 "../src/umockdev.vala"
						return NULL;
#line 8342 "umockdev.c"
					} else {
#line 1354 "../src/umockdev.vala"
						props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
						devnode_contents = (g_free (devnode_contents), NULL);
#line 1354 "../src/umockdev.vala"
						_g_free0 (devnode_path);
#line 1354 "../src/umockdev.vala"
						_g_free0 (cur_data);
#line 1354 "../src/umockdev.vala"
						_g_free0 (majmin);
#line 1354 "../src/umockdev.vala"
						_g_free0 (subsystem);
#line 1354 "../src/umockdev.vala"
						_g_free0 (devpath);
#line 1354 "../src/umockdev.vala"
						_g_free0 (val);
#line 1354 "../src/umockdev.vala"
						_g_free0 (key);
#line 1354 "../src/umockdev.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1354 "../src/umockdev.vala"
						g_clear_error (&_inner_error0_);
#line 1354 "../src/umockdev.vala"
						return NULL;
#line 8376 "umockdev.c"
					}
				}
#line 1355 "../src/umockdev.vala"
				_tmp73_ = self->priv->root_dir;
#line 1355 "../src/umockdev.vala"
				_tmp74_ = val;
#line 1355 "../src/umockdev.vala"
				_tmp75_ = g_build_filename (_tmp73_, "dev", _tmp74_, NULL);
#line 1355 "../src/umockdev.vala"
				_vala_array_add11 (&devnode_links, &devnode_links_length1, &_devnode_links_size_, _tmp75_);
#line 1356 "../src/umockdev.vala"
				break;
#line 8389 "umockdev.c"
			}
			default:
			{
				GError* _tmp76_;
#line 1359 "../src/umockdev.vala"
				_tmp76_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "Unknown line type '%c'\n", (gint) type);
#line 1359 "../src/umockdev.vala"
				_inner_error0_ = _tmp76_;
#line 1359 "../src/umockdev.vala"
				if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1359 "../src/umockdev.vala"
					g_propagate_error (error, _inner_error0_);
#line 1359 "../src/umockdev.vala"
					props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1359 "../src/umockdev.vala"
					_g_free0 (devnode_path);
#line 1359 "../src/umockdev.vala"
					_g_free0 (cur_data);
#line 1359 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1359 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1359 "../src/umockdev.vala"
					_g_free0 (devpath);
#line 1359 "../src/umockdev.vala"
					_g_free0 (val);
#line 1359 "../src/umockdev.vala"
					_g_free0 (key);
#line 1359 "../src/umockdev.vala"
					return NULL;
#line 8430 "umockdev.c"
				} else {
#line 1359 "../src/umockdev.vala"
					props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1359 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1359 "../src/umockdev.vala"
					_g_free0 (devnode_path);
#line 1359 "../src/umockdev.vala"
					_g_free0 (cur_data);
#line 1359 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1359 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1359 "../src/umockdev.vala"
					_g_free0 (devpath);
#line 1359 "../src/umockdev.vala"
					_g_free0 (val);
#line 1359 "../src/umockdev.vala"
					_g_free0 (key);
#line 1359 "../src/umockdev.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1359 "../src/umockdev.vala"
					g_clear_error (&_inner_error0_);
#line 1359 "../src/umockdev.vala"
					return NULL;
#line 8464 "umockdev.c"
				}
			}
		}
	}
#line 1363 "../src/umockdev.vala"
	_tmp77_ = subsystem;
#line 1363 "../src/umockdev.vala"
	if (_tmp77_ == NULL) {
#line 8473 "umockdev.c"
		const gchar* _tmp78_;
		GError* _tmp79_;
#line 1364 "../src/umockdev.vala"
		_tmp78_ = devpath;
#line 1364 "../src/umockdev.vala"
		_tmp79_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_VALUE, "missing SUBSYSTEM property in description of device %s", _tmp78_);
#line 1364 "../src/umockdev.vala"
		_inner_error0_ = _tmp79_;
#line 1364 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1364 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1364 "../src/umockdev.vala"
			props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1364 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1364 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1364 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1364 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1364 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1364 "../src/umockdev.vala"
			_g_free0 (val);
#line 1364 "../src/umockdev.vala"
			_g_free0 (key);
#line 1364 "../src/umockdev.vala"
			return NULL;
#line 8514 "umockdev.c"
		} else {
#line 1364 "../src/umockdev.vala"
			props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1364 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1364 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1364 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1364 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1364 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1364 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1364 "../src/umockdev.vala"
			_g_free0 (val);
#line 1364 "../src/umockdev.vala"
			_g_free0 (key);
#line 1364 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1364 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1364 "../src/umockdev.vala"
			return NULL;
#line 8548 "umockdev.c"
		}
	}
#line 1366 "../src/umockdev.vala"
	_tmp80_ = devpath;
#line 1366 "../src/umockdev.vala"
	_tmp81_ = subsystem;
#line 1366 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1366: creating device %s (subsystem %s)", _tmp80_, _tmp81_);
#line 1367 "../src/umockdev.vala"
	_tmp82_ = subsystem;
#line 1367 "../src/umockdev.vala"
	_tmp83_ = devpath;
#line 1367 "../src/umockdev.vala"
	_tmp84_ = string_substring (_tmp83_, (glong) 9, (glong) -1);
#line 1367 "../src/umockdev.vala"
	_tmp85_ = _tmp84_;
#line 1367 "../src/umockdev.vala"
	_tmp86_ = attrs;
#line 1367 "../src/umockdev.vala"
	_tmp86__length1 = attrs_length1;
#line 1367 "../src/umockdev.vala"
	_tmp87_ = props;
#line 1367 "../src/umockdev.vala"
	_tmp87__length1 = props_length1;
#line 1367 "../src/umockdev.vala"
	_tmp88_ = umockdev_testbed_add_devicev_no_uevent (self, _tmp82_, _tmp85_, NULL, _tmp86_, _tmp87_);
#line 1367 "../src/umockdev.vala"
	_tmp89_ = _tmp88_;
#line 1367 "../src/umockdev.vala"
	_g_free0 (_tmp85_);
#line 1367 "../src/umockdev.vala"
	syspath = _tmp89_;
#line 8581 "umockdev.c"
	{
		gint i = 0;
#line 1372 "../src/umockdev.vala"
		i = 0;
#line 8586 "umockdev.c"
		{
			gboolean _tmp90_ = FALSE;
#line 1372 "../src/umockdev.vala"
			_tmp90_ = TRUE;
#line 1372 "../src/umockdev.vala"
			while (TRUE) {
#line 8593 "umockdev.c"
				gchar** _tmp91_;
				gint _tmp91__length1;
				guint8* _tmp92_ = NULL;
				gchar** _tmp93_;
				gint _tmp93__length1;
				const gchar* _tmp94_;
				gint _tmp95_ = 0;
				guint8* _tmp96_;
				gint _tmp92__length1;
				gint __tmp92__size_;
				const gchar* _tmp97_;
				gchar** _tmp98_;
				gint _tmp98__length1;
				const gchar* _tmp99_;
#line 1372 "../src/umockdev.vala"
				if (!_tmp90_) {
#line 1372 "../src/umockdev.vala"
					i += 2;
#line 8612 "umockdev.c"
				}
#line 1372 "../src/umockdev.vala"
				_tmp90_ = FALSE;
#line 1372 "../src/umockdev.vala"
				_tmp91_ = binattrs;
#line 1372 "../src/umockdev.vala"
				_tmp91__length1 = binattrs_length1;
#line 1372 "../src/umockdev.vala"
				if (!(i < _tmp91__length1)) {
#line 1372 "../src/umockdev.vala"
					break;
#line 8624 "umockdev.c"
				}
#line 1373 "../src/umockdev.vala"
				_tmp93_ = binattrs;
#line 1373 "../src/umockdev.vala"
				_tmp93__length1 = binattrs_length1;
#line 1373 "../src/umockdev.vala"
				_tmp94_ = _tmp93_[i + 1];
#line 1373 "../src/umockdev.vala"
				_tmp96_ = umockdev_decode_hex (_tmp94_, &_tmp95_, &_inner_error0_);
#line 1373 "../src/umockdev.vala"
				_tmp92_ = _tmp96_;
#line 1373 "../src/umockdev.vala"
				_tmp92__length1 = _tmp95_;
#line 1373 "../src/umockdev.vala"
				__tmp92__size_ = _tmp92__length1;
#line 1373 "../src/umockdev.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1373 "../src/umockdev.vala"
					if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1373 "../src/umockdev.vala"
						g_propagate_error (error, _inner_error0_);
#line 1373 "../src/umockdev.vala"
						_g_free0 (syspath);
#line 1373 "../src/umockdev.vala"
						props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						devnode_contents = (g_free (devnode_contents), NULL);
#line 1373 "../src/umockdev.vala"
						_g_free0 (devnode_path);
#line 1373 "../src/umockdev.vala"
						_g_free0 (cur_data);
#line 1373 "../src/umockdev.vala"
						_g_free0 (majmin);
#line 1373 "../src/umockdev.vala"
						_g_free0 (subsystem);
#line 1373 "../src/umockdev.vala"
						_g_free0 (devpath);
#line 1373 "../src/umockdev.vala"
						_g_free0 (val);
#line 1373 "../src/umockdev.vala"
						_g_free0 (key);
#line 1373 "../src/umockdev.vala"
						return NULL;
#line 8676 "umockdev.c"
					} else {
#line 1373 "../src/umockdev.vala"
						_g_free0 (syspath);
#line 1373 "../src/umockdev.vala"
						props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						devnode_contents = (g_free (devnode_contents), NULL);
#line 1373 "../src/umockdev.vala"
						_g_free0 (devnode_path);
#line 1373 "../src/umockdev.vala"
						_g_free0 (cur_data);
#line 1373 "../src/umockdev.vala"
						_g_free0 (majmin);
#line 1373 "../src/umockdev.vala"
						_g_free0 (subsystem);
#line 1373 "../src/umockdev.vala"
						_g_free0 (devpath);
#line 1373 "../src/umockdev.vala"
						_g_free0 (val);
#line 1373 "../src/umockdev.vala"
						_g_free0 (key);
#line 1373 "../src/umockdev.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1373 "../src/umockdev.vala"
						g_clear_error (&_inner_error0_);
#line 1373 "../src/umockdev.vala"
						return NULL;
#line 8712 "umockdev.c"
					}
				}
#line 1373 "../src/umockdev.vala"
				_tmp97_ = syspath;
#line 1373 "../src/umockdev.vala"
				_tmp98_ = binattrs;
#line 1373 "../src/umockdev.vala"
				_tmp98__length1 = binattrs_length1;
#line 1373 "../src/umockdev.vala"
				_tmp99_ = _tmp98_[i];
#line 1373 "../src/umockdev.vala"
				umockdev_testbed_set_attribute_binary (self, _tmp97_, _tmp99_, _tmp92_, (gint) _tmp92__length1);
#line 1372 "../src/umockdev.vala"
				_tmp92_ = (g_free (_tmp92_), NULL);
#line 8727 "umockdev.c"
			}
		}
	}
	{
		gint i = 0;
#line 1376 "../src/umockdev.vala"
		i = 0;
#line 8735 "umockdev.c"
		{
			gboolean _tmp100_ = FALSE;
#line 1376 "../src/umockdev.vala"
			_tmp100_ = TRUE;
#line 1376 "../src/umockdev.vala"
			while (TRUE) {
#line 8742 "umockdev.c"
				gchar** _tmp101_;
				gint _tmp101__length1;
				const gchar* _tmp102_;
				gchar** _tmp103_;
				gint _tmp103__length1;
				const gchar* _tmp104_;
				gchar** _tmp105_;
				gint _tmp105__length1;
				const gchar* _tmp106_;
#line 1376 "../src/umockdev.vala"
				if (!_tmp100_) {
#line 1376 "../src/umockdev.vala"
					i += 2;
#line 8756 "umockdev.c"
				}
#line 1376 "../src/umockdev.vala"
				_tmp100_ = FALSE;
#line 1376 "../src/umockdev.vala"
				_tmp101_ = linkattrs;
#line 1376 "../src/umockdev.vala"
				_tmp101__length1 = linkattrs_length1;
#line 1376 "../src/umockdev.vala"
				if (!(i < _tmp101__length1)) {
#line 1376 "../src/umockdev.vala"
					break;
#line 8768 "umockdev.c"
				}
#line 1377 "../src/umockdev.vala"
				_tmp102_ = syspath;
#line 1377 "../src/umockdev.vala"
				_tmp103_ = linkattrs;
#line 1377 "../src/umockdev.vala"
				_tmp103__length1 = linkattrs_length1;
#line 1377 "../src/umockdev.vala"
				_tmp104_ = _tmp103_[i];
#line 1377 "../src/umockdev.vala"
				_tmp105_ = linkattrs;
#line 1377 "../src/umockdev.vala"
				_tmp105__length1 = linkattrs_length1;
#line 1377 "../src/umockdev.vala"
				_tmp106_ = _tmp105_[i + 1];
#line 1377 "../src/umockdev.vala"
				umockdev_testbed_set_attribute_link (self, _tmp102_, _tmp104_, _tmp106_);
#line 8786 "umockdev.c"
			}
		}
	}
#line 1380 "../src/umockdev.vala"
	_tmp107_ = devnode_path;
#line 1380 "../src/umockdev.vala"
	if (_tmp107_ != NULL) {
#line 8794 "umockdev.c"
		const gchar* _tmp108_;
		const gchar* _tmp109_;
		guint8* _tmp110_;
		gint _tmp110__length1;
		const gchar* _tmp111_;
#line 1381 "../src/umockdev.vala"
		_tmp108_ = subsystem;
#line 1381 "../src/umockdev.vala"
		_tmp109_ = devnode_path;
#line 1381 "../src/umockdev.vala"
		_tmp110_ = devnode_contents;
#line 1381 "../src/umockdev.vala"
		_tmp110__length1 = devnode_contents_length1;
#line 1381 "../src/umockdev.vala"
		_tmp111_ = majmin;
#line 1381 "../src/umockdev.vala"
		umockdev_testbed_create_node_for_device (self, _tmp108_, _tmp109_, _tmp110_, (gint) _tmp110__length1, _tmp111_, &_inner_error0_);
#line 1381 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1381 "../src/umockdev.vala"
			if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1381 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 1381 "../src/umockdev.vala"
				_g_free0 (syspath);
#line 1381 "../src/umockdev.vala"
				props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				devnode_contents = (g_free (devnode_contents), NULL);
#line 1381 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1381 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 1381 "../src/umockdev.vala"
				_g_free0 (majmin);
#line 1381 "../src/umockdev.vala"
				_g_free0 (subsystem);
#line 1381 "../src/umockdev.vala"
				_g_free0 (devpath);
#line 1381 "../src/umockdev.vala"
				_g_free0 (val);
#line 1381 "../src/umockdev.vala"
				_g_free0 (key);
#line 1381 "../src/umockdev.vala"
				return NULL;
#line 8848 "umockdev.c"
			} else {
#line 1381 "../src/umockdev.vala"
				_g_free0 (syspath);
#line 1381 "../src/umockdev.vala"
				props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1381 "../src/umockdev.vala"
				devnode_contents = (g_free (devnode_contents), NULL);
#line 1381 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1381 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 1381 "../src/umockdev.vala"
				_g_free0 (majmin);
#line 1381 "../src/umockdev.vala"
				_g_free0 (subsystem);
#line 1381 "../src/umockdev.vala"
				_g_free0 (devpath);
#line 1381 "../src/umockdev.vala"
				_g_free0 (val);
#line 1381 "../src/umockdev.vala"
				_g_free0 (key);
#line 1381 "../src/umockdev.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1381 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 1381 "../src/umockdev.vala"
				return NULL;
#line 8884 "umockdev.c"
			}
		}
		{
			gint i = 0;
#line 1384 "../src/umockdev.vala"
			i = 0;
#line 8891 "umockdev.c"
			{
				gboolean _tmp112_ = FALSE;
#line 1384 "../src/umockdev.vala"
				_tmp112_ = TRUE;
#line 1384 "../src/umockdev.vala"
				while (TRUE) {
#line 8898 "umockdev.c"
					gchar** _tmp114_;
					gint _tmp114__length1;
					gchar** _tmp115_;
					gint _tmp115__length1;
					const gchar* _tmp116_;
					gchar* _tmp117_;
					gchar* _tmp118_;
					const gchar* _tmp119_;
					gchar** _tmp120_;
					gint _tmp120__length1;
					const gchar* _tmp121_;
#line 1384 "../src/umockdev.vala"
					if (!_tmp112_) {
#line 8912 "umockdev.c"
						gint _tmp113_;
#line 1384 "../src/umockdev.vala"
						_tmp113_ = i;
#line 1384 "../src/umockdev.vala"
						i = _tmp113_ + 1;
#line 8918 "umockdev.c"
					}
#line 1384 "../src/umockdev.vala"
					_tmp112_ = FALSE;
#line 1384 "../src/umockdev.vala"
					_tmp114_ = devnode_links;
#line 1384 "../src/umockdev.vala"
					_tmp114__length1 = devnode_links_length1;
#line 1384 "../src/umockdev.vala"
					if (!(i < _tmp114__length1)) {
#line 1384 "../src/umockdev.vala"
						break;
#line 8930 "umockdev.c"
					}
#line 1385 "../src/umockdev.vala"
					_tmp115_ = devnode_links;
#line 1385 "../src/umockdev.vala"
					_tmp115__length1 = devnode_links_length1;
#line 1385 "../src/umockdev.vala"
					_tmp116_ = _tmp115_[i];
#line 1385 "../src/umockdev.vala"
					_tmp117_ = g_path_get_dirname (_tmp116_);
#line 1385 "../src/umockdev.vala"
					_tmp118_ = _tmp117_;
#line 1385 "../src/umockdev.vala"
					umockdev_checked_mkdir_with_parents (_tmp118_, 0755);
#line 1385 "../src/umockdev.vala"
					_g_free0 (_tmp118_);
#line 1386 "../src/umockdev.vala"
					_tmp119_ = devnode_path;
#line 1386 "../src/umockdev.vala"
					_tmp120_ = devnode_links;
#line 1386 "../src/umockdev.vala"
					_tmp120__length1 = devnode_links_length1;
#line 1386 "../src/umockdev.vala"
					_tmp121_ = _tmp120_[i];
#line 1386 "../src/umockdev.vala"
					if (symlink (_tmp119_, _tmp121_) < 0) {
#line 8956 "umockdev.c"
						gchar** _tmp122_;
						gint _tmp122__length1;
						const gchar* _tmp123_;
						const gchar* _tmp124_;
						const gchar* _tmp125_;
#line 1387 "../src/umockdev.vala"
						_tmp122_ = devnode_links;
#line 1387 "../src/umockdev.vala"
						_tmp122__length1 = devnode_links_length1;
#line 1387 "../src/umockdev.vala"
						_tmp123_ = _tmp122_[i];
#line 1387 "../src/umockdev.vala"
						_tmp124_ = devnode_path;
#line 1387 "../src/umockdev.vala"
						_tmp125_ = devpath;
#line 1387 "../src/umockdev.vala"
						g_warning ("umockdev.vala:1387: failed to create %s -> %s symlink for device %s: %" \
"m", _tmp123_, _tmp124_, _tmp125_);
#line 8974 "umockdev.c"
					}
				}
			}
		}
	}
#line 1393 "../src/umockdev.vala"
	while (TRUE) {
#line 8982 "umockdev.c"
		gboolean _tmp126_ = FALSE;
		const gchar* _tmp127_;
		const gchar* _tmp129_;
		const gchar* _tmp130_;
		gchar* _tmp131_;
#line 1393 "../src/umockdev.vala"
		_tmp127_ = cur_data;
#line 1393 "../src/umockdev.vala"
		if (string_get (_tmp127_, (glong) 0) != '\0') {
#line 8992 "umockdev.c"
			const gchar* _tmp128_;
#line 1393 "../src/umockdev.vala"
			_tmp128_ = cur_data;
#line 1393 "../src/umockdev.vala"
			_tmp126_ = string_get (_tmp128_, (glong) 0) == '\n';
#line 8998 "umockdev.c"
		} else {
#line 1393 "../src/umockdev.vala"
			_tmp126_ = FALSE;
#line 9002 "umockdev.c"
		}
#line 1393 "../src/umockdev.vala"
		if (!_tmp126_) {
#line 1393 "../src/umockdev.vala"
			break;
#line 9008 "umockdev.c"
		}
#line 1394 "../src/umockdev.vala"
		_tmp129_ = cur_data;
#line 1394 "../src/umockdev.vala"
		_tmp130_ = g_utf8_next_char (_tmp129_);
#line 1394 "../src/umockdev.vala"
		_tmp131_ = g_strdup (_tmp130_);
#line 1394 "../src/umockdev.vala"
		_g_free0 (cur_data);
#line 1394 "../src/umockdev.vala"
		cur_data = _tmp131_;
#line 9020 "umockdev.c"
	}
#line 1396 "../src/umockdev.vala"
	if (umockdev_in_mock_environment ()) {
#line 9024 "umockdev.c"
		const gchar* _tmp132_;
#line 1397 "../src/umockdev.vala"
		_tmp132_ = syspath;
#line 1397 "../src/umockdev.vala"
		umockdev_testbed_uevent (self, _tmp132_, "add");
#line 9030 "umockdev.c"
	}
#line 1399 "../src/umockdev.vala"
	result = cur_data;
#line 1399 "../src/umockdev.vala"
	_g_free0 (syspath);
#line 1399 "../src/umockdev.vala"
	props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1399 "../src/umockdev.vala"
	linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1399 "../src/umockdev.vala"
	binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1399 "../src/umockdev.vala"
	attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1399 "../src/umockdev.vala"
	devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1399 "../src/umockdev.vala"
	devnode_contents = (g_free (devnode_contents), NULL);
#line 1399 "../src/umockdev.vala"
	_g_free0 (devnode_path);
#line 1399 "../src/umockdev.vala"
	_g_free0 (majmin);
#line 1399 "../src/umockdev.vala"
	_g_free0 (subsystem);
#line 1399 "../src/umockdev.vala"
	_g_free0 (devpath);
#line 1399 "../src/umockdev.vala"
	_g_free0 (val);
#line 1399 "../src/umockdev.vala"
	_g_free0 (key);
#line 1399 "../src/umockdev.vala"
	return result;
#line 9062 "umockdev.c"
}

static void
umockdev_testbed_create_node_for_device (UMockdevTestbed* self,
                                         const gchar* subsystem,
                                         const gchar* node_path,
                                         guint8* node_contents,
                                         gint node_contents_length1,
                                         const gchar* majmin,
                                         GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint ptym = 0;
	gint ptys = 0;
	gchar* ptyname_array = NULL;
	gchar* _tmp5_;
	gint ptyname_array_length1;
	gint _ptyname_array_size_;
	gchar* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_;
	gchar* ptyname = NULL;
	gchar* _tmp10_;
	gint _tmp10__length1;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	struct termios ios = {0};
	struct termios _tmp13_ = {0};
	gint _tmp14_;
	struct termios _tmp15_;
	const gchar* _tmp16_;
	gchar* devname = NULL;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gchar* _tmp31_;
	GHashTable* _tmp32_;
	const gchar* _tmp33_;
	GHashTable* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	GError* _inner_error0_ = NULL;
#line 1402 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1402 "../src/umockdev.vala"
	g_return_if_fail (subsystem != NULL);
#line 1402 "../src/umockdev.vala"
	g_return_if_fail (node_path != NULL);
#line 1406 "../src/umockdev.vala"
	_tmp0_ = g_path_get_dirname (node_path);
#line 1406 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 1406 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp1_, 0755);
#line 1406 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 1409 "../src/umockdev.vala"
	if (node_contents_length1 > 0) {
#line 1409 "../src/umockdev.vala"
		_tmp3_ = TRUE;
#line 9128 "umockdev.c"
	} else {
#line 1409 "../src/umockdev.vala"
		_tmp3_ = g_strcmp0 (subsystem, "block") == 0;
#line 9132 "umockdev.c"
	}
#line 1409 "../src/umockdev.vala"
	if (_tmp3_) {
#line 1409 "../src/umockdev.vala"
		_tmp2_ = TRUE;
#line 9138 "umockdev.c"
	} else {
#line 1409 "../src/umockdev.vala"
		_tmp2_ = g_strcmp0 (subsystem, "usb") == 0;
#line 9142 "umockdev.c"
	}
#line 1409 "../src/umockdev.vala"
	if (_tmp2_) {
#line 9146 "umockdev.c"
		{
#line 1411 "../src/umockdev.vala"
			g_debug ("umockdev.vala:1411: create_node_for_device: creating file device %s", node_path);
#line 1412 "../src/umockdev.vala"
			g_file_set_contents (node_path, (const char*) node_contents, (gsize) node_contents_length1, &_inner_error0_);
#line 1412 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1412 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 9156 "umockdev.c"
					goto __catch0_g_file_error;
				}
#line 1412 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1412 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 1412 "../src/umockdev.vala"
				return;
#line 9165 "umockdev.c"
			}
#line 1415 "../src/umockdev.vala"
			if (g_strcmp0 (subsystem, "block") == 0) {
#line 1416 "../src/umockdev.vala"
				g_chmod (node_path, 01644);
#line 9171 "umockdev.c"
			}
		}
		goto __finally0;
		__catch0_g_file_error:
		{
			GError* e = NULL;
			const gchar* _tmp4_;
#line 1410 "../src/umockdev.vala"
			e = _inner_error0_;
#line 1410 "../src/umockdev.vala"
			_inner_error0_ = NULL;
#line 1418 "../src/umockdev.vala"
			_tmp4_ = e->message;
#line 1418 "../src/umockdev.vala"
			g_error ("umockdev.vala:1418: Cannot create dev node file: %s", _tmp4_);
#line 1410 "../src/umockdev.vala"
			_g_error_free0 (e);
#line 9189 "umockdev.c"
		}
		__finally0:
#line 1410 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1410 "../src/umockdev.vala"
			if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1410 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 1410 "../src/umockdev.vala"
				return;
#line 9200 "umockdev.c"
			} else {
#line 1410 "../src/umockdev.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1410 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 1410 "../src/umockdev.vala"
				return;
#line 9208 "umockdev.c"
			}
		}
#line 1421 "../src/umockdev.vala"
		return;
#line 9213 "umockdev.c"
	}
#line 1426 "../src/umockdev.vala"
	_tmp5_ = g_new0 (gchar, 8192);
#line 1426 "../src/umockdev.vala"
	ptyname_array = _tmp5_;
#line 1426 "../src/umockdev.vala"
	ptyname_array_length1 = 8192;
#line 1426 "../src/umockdev.vala"
	_ptyname_array_size_ = ptyname_array_length1;
#line 1427 "../src/umockdev.vala"
	_tmp6_ = ptyname_array;
#line 1427 "../src/umockdev.vala"
	_tmp6__length1 = ptyname_array_length1;
#line 1427 "../src/umockdev.vala"
	_tmp9_ = openpty (&_tmp7_, &_tmp8_, _tmp6_, NULL, NULL);
#line 1427 "../src/umockdev.vala"
	ptym = _tmp7_;
#line 1427 "../src/umockdev.vala"
	ptys = _tmp8_;
#line 1427 "../src/umockdev.vala"
	if (_tmp9_ < 0) {
#line 1428 "../src/umockdev.vala"
		g_error ("umockdev.vala:1428: umockdev Testbed.create_node_for_device: openpty()" \
" failed: %m");
#line 9237 "umockdev.c"
	}
#line 1429 "../src/umockdev.vala"
	_tmp10_ = ptyname_array;
#line 1429 "../src/umockdev.vala"
	_tmp10__length1 = ptyname_array_length1;
#line 1429 "../src/umockdev.vala"
	_tmp11_ = g_strdup ((const gchar*) _tmp10_);
#line 1429 "../src/umockdev.vala"
	ptyname = _tmp11_;
#line 1430 "../src/umockdev.vala"
	_tmp12_ = ptyname;
#line 1430 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1430: create_node_for_device: creating pty device %s: go" \
"t pty %s", node_path, _tmp12_);
#line 1431 "../src/umockdev.vala"
	close (ptys);
#line 1436 "../src/umockdev.vala"
	_tmp14_ = tcgetattr (ptym, &_tmp13_);
#line 1436 "../src/umockdev.vala"
	ios = _tmp13_;
#line 1436 "../src/umockdev.vala"
	_vala_assert (_tmp14_ == 0, "Posix.tcgetattr (ptym, out ios) == 0");
#line 1437 "../src/umockdev.vala"
	ios.c_iflag = ios.c_iflag & (~((IGNCR | INLCR) | ICRNL));
#line 1438 "../src/umockdev.vala"
	ios.c_oflag = ios.c_oflag & (~(ONLCR | OCRNL));
#line 1439 "../src/umockdev.vala"
	ios.c_lflag = ios.c_lflag & (~(ICANON | ECHO));
#line 1440 "../src/umockdev.vala"
	cfmakeraw (&ios);
#line 1441 "../src/umockdev.vala"
	_tmp15_ = ios;
#line 1441 "../src/umockdev.vala"
	_vala_assert (tcsetattr (ptym, TCSANOW, &_tmp15_) == 0, "Posix.tcsetattr (ptym, Posix.TCSANOW, ios) == 0");
#line 1443 "../src/umockdev.vala"
	_tmp16_ = ptyname;
#line 1443 "../src/umockdev.vala"
	_vala_assert (symlink (_tmp16_, node_path) == 0, "FileUtils.symlink (ptyname, node_path) == 0");
#line 1447 "../src/umockdev.vala"
	if (majmin != NULL) {
#line 9277 "umockdev.c"
		gchar* mapdir = NULL;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* dest = NULL;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
#line 1448 "../src/umockdev.vala"
		_tmp17_ = self->priv->root_dir;
#line 1448 "../src/umockdev.vala"
		_tmp18_ = g_build_filename (_tmp17_, "dev", ".ptymap", NULL);
#line 1448 "../src/umockdev.vala"
		mapdir = _tmp18_;
#line 1449 "../src/umockdev.vala"
		_tmp19_ = mapdir;
#line 1449 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp19_, 0755);
#line 1450 "../src/umockdev.vala"
		_tmp20_ = mapdir;
#line 1450 "../src/umockdev.vala"
		_tmp21_ = ptyname;
#line 1450 "../src/umockdev.vala"
		_tmp22_ = string_replace (_tmp21_, "/", "_");
#line 1450 "../src/umockdev.vala"
		_tmp23_ = _tmp22_;
#line 1450 "../src/umockdev.vala"
		_tmp24_ = g_build_filename (_tmp20_, _tmp23_, NULL);
#line 1450 "../src/umockdev.vala"
		_tmp25_ = _tmp24_;
#line 1450 "../src/umockdev.vala"
		_g_free0 (_tmp23_);
#line 1450 "../src/umockdev.vala"
		dest = _tmp25_;
#line 1451 "../src/umockdev.vala"
		_tmp26_ = dest;
#line 1451 "../src/umockdev.vala"
		g_debug ("umockdev.vala:1451: create_node_for_device: creating ptymap symlink %s", _tmp26_);
#line 1452 "../src/umockdev.vala"
		_tmp27_ = dest;
#line 1452 "../src/umockdev.vala"
		_vala_assert (symlink (majmin, _tmp27_) == 0, "FileUtils.symlink(majmin, dest) == 0");
#line 1447 "../src/umockdev.vala"
		_g_free0 (dest);
#line 1447 "../src/umockdev.vala"
		_g_free0 (mapdir);
#line 9329 "umockdev.c"
	}
#line 1456 "../src/umockdev.vala"
	_tmp28_ = self->priv->root_dir;
#line 1456 "../src/umockdev.vala"
	_tmp29_ = strlen (_tmp28_);
#line 1456 "../src/umockdev.vala"
	_tmp30_ = _tmp29_;
#line 1456 "../src/umockdev.vala"
	_tmp31_ = string_substring (node_path, (glong) _tmp30_, (glong) -1);
#line 1456 "../src/umockdev.vala"
	devname = _tmp31_;
#line 1457 "../src/umockdev.vala"
	_tmp32_ = self->priv->dev_fd;
#line 1457 "../src/umockdev.vala"
	_tmp33_ = devname;
#line 1457 "../src/umockdev.vala"
	_vala_assert (!g_hash_table_contains (_tmp32_, _tmp33_), "!this.dev_fd.contains (devname)");
#line 1458 "../src/umockdev.vala"
	_tmp34_ = self->priv->dev_fd;
#line 1458 "../src/umockdev.vala"
	_tmp35_ = devname;
#line 1458 "../src/umockdev.vala"
	_tmp36_ = g_strdup (_tmp35_);
#line 1458 "../src/umockdev.vala"
	g_hash_table_insert (_tmp34_, _tmp36_, (gpointer) ((gintptr) ptym));
#line 1402 "../src/umockdev.vala"
	_g_free0 (devname);
#line 1402 "../src/umockdev.vala"
	_g_free0 (ptyname);
#line 1402 "../src/umockdev.vala"
	ptyname_array = (g_free (ptyname_array), NULL);
#line 9361 "umockdev.c"
}

/**
     * umockdev_testbed_record_parse_line:
     * @data: String to parse
     * @type: Pointer to a gchar which will get the line type (one of P, N,
     *        S, E, or H)
     * @key:  Pointer to a string which will get the key name; this will be
     *        set to %NULL for line types which do not have a key (P, N, S). You
     *        need to free this with g_free().
     * @value: Pointer to a string which will get the value. You need to
     *         free this with g_free().
     *
     * Parse one line from a device record file.
     *
     * Returns: Pointer to the next line start in @data, or %NULL if the first line
     * is not valid.
     */
static gchar*
umockdev_testbed_record_parse_line (UMockdevTestbed* self,
                                    const gchar* data,
                                    gchar* type,
                                    gchar** key,
                                    gchar** val)
{
	gchar _vala_type = '\0';
	gchar* _vala_key = NULL;
	gchar* _vala_val = NULL;
	GMatchInfo* match = NULL;
	GRegex* _tmp0_;
	GMatchInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
	gchar* type_str = NULL;
	GMatchInfo* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gint end_pos = 0;
	GMatchInfo* _tmp24_;
	gint _tmp25_ = 0;
	gboolean _tmp26_;
	gchar* _tmp27_;
	gchar* result;
#line 1478 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1478 "../src/umockdev.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 1482 "../src/umockdev.vala"
	_tmp0_ = self->priv->re_record_val;
#line 1482 "../src/umockdev.vala"
	_tmp2_ = g_regex_match (_tmp0_, data, 0, &_tmp1_);
#line 1482 "../src/umockdev.vala"
	_g_match_info_unref0 (match);
#line 1482 "../src/umockdev.vala"
	match = _tmp1_;
#line 1482 "../src/umockdev.vala"
	if (_tmp2_) {
#line 9419 "umockdev.c"
		GMatchInfo* _tmp3_;
		gchar* _tmp4_;
#line 1483 "../src/umockdev.vala"
		_g_free0 (_vala_key);
#line 1483 "../src/umockdev.vala"
		_vala_key = NULL;
#line 1484 "../src/umockdev.vala"
		_tmp3_ = match;
#line 1484 "../src/umockdev.vala"
		_tmp4_ = g_match_info_fetch (_tmp3_, 2);
#line 1484 "../src/umockdev.vala"
		_g_free0 (_vala_val);
#line 1484 "../src/umockdev.vala"
		_vala_val = _tmp4_;
#line 9434 "umockdev.c"
	} else {
		GRegex* _tmp5_;
		GMatchInfo* _tmp6_ = NULL;
		gboolean _tmp7_;
#line 1485 "../src/umockdev.vala"
		_tmp5_ = self->priv->re_record_keyval;
#line 1485 "../src/umockdev.vala"
		_tmp7_ = g_regex_match (_tmp5_, data, 0, &_tmp6_);
#line 1485 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1485 "../src/umockdev.vala"
		match = _tmp6_;
#line 1485 "../src/umockdev.vala"
		if (_tmp7_) {
#line 9449 "umockdev.c"
			GMatchInfo* _tmp8_;
			gchar* _tmp9_;
			GMatchInfo* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
#line 1486 "../src/umockdev.vala"
			_tmp8_ = match;
#line 1486 "../src/umockdev.vala"
			_tmp9_ = g_match_info_fetch (_tmp8_, 2);
#line 1486 "../src/umockdev.vala"
			_g_free0 (_vala_key);
#line 1486 "../src/umockdev.vala"
			_vala_key = _tmp9_;
#line 1487 "../src/umockdev.vala"
			_tmp10_ = match;
#line 1487 "../src/umockdev.vala"
			_tmp11_ = g_match_info_fetch (_tmp10_, 3);
#line 1487 "../src/umockdev.vala"
			_g_free0 (_vala_val);
#line 1487 "../src/umockdev.vala"
			_vala_val = _tmp11_;
#line 1488 "../src/umockdev.vala"
			_tmp12_ = _vala_val;
#line 1488 "../src/umockdev.vala"
			_vala_assert (_tmp12_ != NULL, "val != null");
#line 9475 "umockdev.c"
		} else {
			GRegex* _tmp13_;
			GMatchInfo* _tmp14_ = NULL;
			gboolean _tmp15_;
#line 1489 "../src/umockdev.vala"
			_tmp13_ = self->priv->re_record_optval;
#line 1489 "../src/umockdev.vala"
			_tmp15_ = g_regex_match (_tmp13_, data, 0, &_tmp14_);
#line 1489 "../src/umockdev.vala"
			_g_match_info_unref0 (match);
#line 1489 "../src/umockdev.vala"
			match = _tmp14_;
#line 1489 "../src/umockdev.vala"
			if (_tmp15_) {
#line 9490 "umockdev.c"
				GMatchInfo* _tmp16_;
				gchar* _tmp17_;
				GMatchInfo* _tmp18_;
				gchar* _tmp19_;
#line 1490 "../src/umockdev.vala"
				_tmp16_ = match;
#line 1490 "../src/umockdev.vala"
				_tmp17_ = g_match_info_fetch (_tmp16_, 2);
#line 1490 "../src/umockdev.vala"
				_g_free0 (_vala_key);
#line 1490 "../src/umockdev.vala"
				_vala_key = _tmp17_;
#line 1491 "../src/umockdev.vala"
				_tmp18_ = match;
#line 1491 "../src/umockdev.vala"
				_tmp19_ = g_match_info_fetch (_tmp18_, 3);
#line 1491 "../src/umockdev.vala"
				_g_free0 (_vala_val);
#line 1491 "../src/umockdev.vala"
				_vala_val = _tmp19_;
#line 9511 "umockdev.c"
			} else {
#line 1493 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1493: record_parse_line: >%s< does not match anything, f" \
"ailing", data);
#line 1494 "../src/umockdev.vala"
				_vala_type = '\0';
#line 1495 "../src/umockdev.vala"
				_g_free0 (_vala_key);
#line 1495 "../src/umockdev.vala"
				_vala_key = NULL;
#line 1496 "../src/umockdev.vala"
				_g_free0 (_vala_val);
#line 1496 "../src/umockdev.vala"
				_vala_val = NULL;
#line 1497 "../src/umockdev.vala"
				result = NULL;
#line 1497 "../src/umockdev.vala"
				_g_match_info_unref0 (match);
#line 1497 "../src/umockdev.vala"
				if (type) {
#line 1497 "../src/umockdev.vala"
					*type = _vala_type;
#line 9533 "umockdev.c"
				}
#line 1497 "../src/umockdev.vala"
				if (key) {
#line 1497 "../src/umockdev.vala"
					*key = _vala_key;
#line 9539 "umockdev.c"
				} else {
#line 1497 "../src/umockdev.vala"
					_g_free0 (_vala_key);
#line 9543 "umockdev.c"
				}
#line 1497 "../src/umockdev.vala"
				if (val) {
#line 1497 "../src/umockdev.vala"
					*val = _vala_val;
#line 9549 "umockdev.c"
				} else {
#line 1497 "../src/umockdev.vala"
					_g_free0 (_vala_val);
#line 9553 "umockdev.c"
				}
#line 1497 "../src/umockdev.vala"
				return result;
#line 9557 "umockdev.c"
			}
		}
	}
#line 1500 "../src/umockdev.vala"
	_tmp20_ = match;
#line 1500 "../src/umockdev.vala"
	_tmp21_ = g_match_info_fetch (_tmp20_, 1);
#line 1500 "../src/umockdev.vala"
	type_str = _tmp21_;
#line 1501 "../src/umockdev.vala"
	_tmp22_ = type_str;
#line 1501 "../src/umockdev.vala"
	_vala_assert (_tmp22_ != NULL, "type_str != null");
#line 1502 "../src/umockdev.vala"
	_tmp23_ = type_str;
#line 1502 "../src/umockdev.vala"
	_vala_type = string_get (_tmp23_, (glong) 0);
#line 1505 "../src/umockdev.vala"
	_tmp24_ = match;
#line 1505 "../src/umockdev.vala"
	_tmp26_ = g_match_info_fetch_pos (_tmp24_, 0, NULL, &_tmp25_);
#line 1505 "../src/umockdev.vala"
	end_pos = _tmp25_;
#line 1505 "../src/umockdev.vala"
	_vala_assert (_tmp26_, "match.fetch_pos(0, null, out end_pos)");
#line 1506 "../src/umockdev.vala"
	_tmp27_ = string_substring (data, (glong) end_pos, (glong) -1);
#line 1506 "../src/umockdev.vala"
	result = _tmp27_;
#line 1506 "../src/umockdev.vala"
	_g_free0 (type_str);
#line 1506 "../src/umockdev.vala"
	_g_match_info_unref0 (match);
#line 1506 "../src/umockdev.vala"
	if (type) {
#line 1506 "../src/umockdev.vala"
		*type = _vala_type;
#line 9595 "umockdev.c"
	}
#line 1506 "../src/umockdev.vala"
	if (key) {
#line 1506 "../src/umockdev.vala"
		*key = _vala_key;
#line 9601 "umockdev.c"
	} else {
#line 1506 "../src/umockdev.vala"
		_g_free0 (_vala_key);
#line 9605 "umockdev.c"
	}
#line 1506 "../src/umockdev.vala"
	if (val) {
#line 1506 "../src/umockdev.vala"
		*val = _vala_val;
#line 9611 "umockdev.c"
	} else {
#line 1506 "../src/umockdev.vala"
		_g_free0 (_vala_val);
#line 9615 "umockdev.c"
	}
#line 1506 "../src/umockdev.vala"
	return result;
#line 9619 "umockdev.c"
}

/**
     * umockdev_testbed_disable:
     * @self: A #UMockdevTestbed.
     *
     * Disable the testbed.  This can be used for temporarily switching back to
     * the real /sys and /dev without having to destroy or change $UMOCKDEV_DIR
     * and the #UMockdevTestbed instance. Use @umockdev_testbed_enable() to
     * re-enable the testbed.
     */
void
umockdev_testbed_disable (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	FILE* _tmp3_;
	FILE* _tmp4_;
#line 1518 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1520 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 1520 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, "disabled", NULL);
#line 1520 "../src/umockdev.vala"
	_tmp2_ = _tmp1_;
#line 1520 "../src/umockdev.vala"
	_tmp3_ = g_fopen (_tmp2_, "w");
#line 1520 "../src/umockdev.vala"
	_tmp4_ = _tmp3_;
#line 1520 "../src/umockdev.vala"
	_fclose0 (_tmp4_);
#line 1520 "../src/umockdev.vala"
	_g_free0 (_tmp2_);
#line 9655 "umockdev.c"
}

/**
     * umockdev_testbed_enable:
     * @self: A #UMockdevTestbed.
     *
     * Re-enable the testbed after @@umockdev_testbed_disable().
     */
void
umockdev_testbed_enable (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 1529 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1531 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 1531 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, "disabled", NULL);
#line 1531 "../src/umockdev.vala"
	_tmp2_ = _tmp1_;
#line 1531 "../src/umockdev.vala"
	_tmp3_ = g_remove (_tmp2_) < 0;
#line 1531 "../src/umockdev.vala"
	_g_free0 (_tmp2_);
#line 1531 "../src/umockdev.vala"
	if (_tmp3_) {
#line 1532 "../src/umockdev.vala"
		g_debug ("umockdev.vala:1532: enable: failed to remove /disabled flag, ignoring:" \
" %m");
#line 9687 "umockdev.c"
	}
}

/**
     * umockdev_testbed_clear:
     * @self: A #UMockdevTestbed.
     *
     * Remove all added devices from testbed directory.  After that, the
     * umockdev root directory will be in the same state as directly after the
     * constructor.
     */
void
umockdev_testbed_clear (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1543 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1545 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 1545 "../src/umockdev.vala"
	umockdev_utils_remove_dir (_tmp0_, FALSE);
#line 1547 "../src/umockdev.vala"
	_tmp1_ = self->priv->sys_dir;
#line 1547 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp1_, 0755);
#line 9714 "umockdev.c"
}

/**
     * umockdev_testbed_get_dev_fd:
     * @self: A #UMockdevTestbed.
     * @devnode: Device node name ("/dev/...")
     *
     * Simulated devices without a pre-defined contents are backed by a
     * stream-like device node (PTY). Return the file descriptor
     * for accessing their "master" side, i. e. the end that gets
     * controlled by test suites. The tested program opens the "slave" side,
     * which is just openening the device specified by @devnode, e. g.
     * /dev/ttyUSB2. Once that happened, your test can directly communicate
     * with the tested program over that descriptor.
     *
     * Returns: File descriptor for communicating with clients that connect to
     *           @devnode, or -1 if @devnode does not exist or is not a
     *           simulated stream device. This must not be closed!
     */
gint
umockdev_testbed_get_dev_fd (UMockdevTestbed* self,
                             const gchar* devnode)
{
	GHashTable* _tmp0_;
	gint result;
#line 1567 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1567 "../src/umockdev.vala"
	g_return_val_if_fail (devnode != NULL, 0);
#line 1571 "../src/umockdev.vala"
	_tmp0_ = self->priv->dev_fd;
#line 1571 "../src/umockdev.vala"
	if (g_hash_table_contains (_tmp0_, devnode)) {
#line 9748 "umockdev.c"
		GHashTable* _tmp1_;
		gconstpointer _tmp2_;
#line 1572 "../src/umockdev.vala"
		_tmp1_ = self->priv->dev_fd;
#line 1572 "../src/umockdev.vala"
		_tmp2_ = g_hash_table_lookup (_tmp1_, devnode);
#line 1572 "../src/umockdev.vala"
		result = (gint) ((gintptr) _tmp2_);
#line 1572 "../src/umockdev.vala"
		return result;
#line 9759 "umockdev.c"
	} else {
#line 1574 "../src/umockdev.vala"
		result = -1;
#line 1574 "../src/umockdev.vala"
		return result;
#line 9765 "umockdev.c"
	}
}

static void
umockdev_testbed_class_init (UMockdevTestbedClass * klass,
                             gpointer klass_data)
{
#line 82 "../src/umockdev.vala"
	umockdev_testbed_parent_class = g_type_class_peek_parent (klass);
#line 82 "../src/umockdev.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevTestbed_private_offset);
#line 82 "../src/umockdev.vala"
	G_OBJECT_CLASS (klass)->finalize = umockdev_testbed_finalize;
#line 9779 "umockdev.c"
}

static void
umockdev_testbed_instance_init (UMockdevTestbed * self,
                                gpointer klass)
{
#line 82 "../src/umockdev.vala"
	self->priv = umockdev_testbed_get_instance_private (self);
#line 1582 "../src/umockdev.vala"
	self->priv->ev_sender = NULL;
#line 1585 "../src/umockdev.vala"
	self->priv->socket_server = NULL;
#line 9792 "umockdev.c"
}

static void
umockdev_testbed_finalize (GObject * obj)
{
	UMockdevTestbed * self;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	UMockdevSocketServer* _tmp6_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GMainLoop* _tmp10_;
#line 82 "../src/umockdev.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_TESTBED, UMockdevTestbed);
#line 128 "../src/umockdev.vala"
	_tmp0_ = self->priv->dev_script_runner;
#line 128 "../src/umockdev.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 9814 "umockdev.c"
	{
		GList* r_collection = NULL;
		GList* r_it = NULL;
#line 128 "../src/umockdev.vala"
		r_collection = _tmp1_;
#line 128 "../src/umockdev.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 9822 "umockdev.c"
			UMockdevScriptRunner* r = NULL;
#line 128 "../src/umockdev.vala"
			r = (UMockdevScriptRunner*) r_it->data;
#line 9826 "umockdev.c"
			{
				UMockdevScriptRunner* _tmp2_;
#line 129 "../src/umockdev.vala"
				_tmp2_ = r;
#line 129 "../src/umockdev.vala"
				umockdev_script_runner_stop (_tmp2_);
#line 9833 "umockdev.c"
			}
		}
#line 128 "../src/umockdev.vala"
		(r_collection == NULL) ? NULL : (r_collection = (g_list_free (r_collection), NULL));
#line 9838 "umockdev.c"
	}
#line 130 "../src/umockdev.vala"
	_tmp3_ = self->priv->dev_script_runner;
#line 130 "../src/umockdev.vala"
	g_hash_table_remove_all (_tmp3_);
#line 132 "../src/umockdev.vala"
	_tmp4_ = self->priv->custom_handlers;
#line 132 "../src/umockdev.vala"
	g_hash_table_foreach (_tmp4_, __umockdev_testbed___lambda5__gh_func, self);
#line 135 "../src/umockdev.vala"
	_tmp5_ = self->priv->custom_handlers;
#line 135 "../src/umockdev.vala"
	g_hash_table_remove_all (_tmp5_);
#line 143 "../src/umockdev.vala"
	_tmp6_ = self->priv->socket_server;
#line 143 "../src/umockdev.vala"
	if (_tmp6_ != NULL) {
#line 9856 "umockdev.c"
		UMockdevSocketServer* _tmp7_;
#line 144 "../src/umockdev.vala"
		g_debug ("umockdev.vala:144: shutting down socket server thread");
#line 145 "../src/umockdev.vala"
		_tmp7_ = self->priv->socket_server;
#line 145 "../src/umockdev.vala"
		umockdev_socket_server_stop (_tmp7_);
#line 146 "../src/umockdev.vala"
		_umockdev_socket_server_unref0 (self->priv->socket_server);
#line 146 "../src/umockdev.vala"
		self->priv->socket_server = NULL;
#line 9868 "umockdev.c"
	}
#line 149 "../src/umockdev.vala"
	_tmp8_ = self->priv->root_dir;
#line 149 "../src/umockdev.vala"
	g_debug ("umockdev.vala:149: Removing test bed %s", _tmp8_);
#line 150 "../src/umockdev.vala"
	_tmp9_ = self->priv->root_dir;
#line 150 "../src/umockdev.vala"
	umockdev_utils_remove_dir (_tmp9_, TRUE);
#line 151 "../src/umockdev.vala"
	g_unsetenv ("UMOCKDEV_DIR");
#line 153 "../src/umockdev.vala"
	_tmp10_ = self->priv->worker_loop;
#line 153 "../src/umockdev.vala"
	g_main_loop_quit (_tmp10_);
#line 1577 "../src/umockdev.vala"
	_g_free0 (self->priv->root_dir);
#line 1578 "../src/umockdev.vala"
	_g_free0 (self->priv->sys_dir);
#line 1579 "../src/umockdev.vala"
	_g_regex_unref0 (self->priv->re_record_val);
#line 1580 "../src/umockdev.vala"
	_g_regex_unref0 (self->priv->re_record_keyval);
#line 1581 "../src/umockdev.vala"
	_g_regex_unref0 (self->priv->re_record_optval);
#line 1582 "../src/umockdev.vala"
	_uevent_sender_close0 (self->priv->ev_sender);
#line 1583 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->dev_fd);
#line 1584 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->dev_script_runner);
#line 1585 "../src/umockdev.vala"
	_umockdev_socket_server_unref0 (self->priv->socket_server);
#line 1587 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->custom_handlers);
#line 1589 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->worker_thread);
#line 1590 "../src/umockdev.vala"
	_g_main_context_unref0 (self->priv->worker_ctx);
#line 1591 "../src/umockdev.vala"
	_g_main_loop_unref0 (self->priv->worker_loop);
#line 82 "../src/umockdev.vala"
	G_OBJECT_CLASS (umockdev_testbed_parent_class)->finalize (obj);
#line 9912 "umockdev.c"
}

static GType
umockdev_testbed_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevTestbedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_testbed_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevTestbed), 0, (GInstanceInitFunc) umockdev_testbed_instance_init, NULL };
	GType umockdev_testbed_type_id;
	umockdev_testbed_type_id = g_type_register_static (G_TYPE_OBJECT, "UMockdevTestbed", &g_define_type_info, 0);
	UMockdevTestbed_private_offset = g_type_add_instance_private (umockdev_testbed_type_id, sizeof (UMockdevTestbedPrivate));
	return umockdev_testbed_type_id;
}

GType
umockdev_testbed_get_type (void)
{
	static volatile gsize umockdev_testbed_type_id__once = 0;
	if (g_once_init_enter (&umockdev_testbed_type_id__once)) {
		GType umockdev_testbed_type_id;
		umockdev_testbed_type_id = umockdev_testbed_get_type_once ();
		g_once_init_leave (&umockdev_testbed_type_id__once, umockdev_testbed_type_id);
	}
	return umockdev_testbed_type_id__once;
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 9956 "umockdev.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 9964 "umockdev.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 9970 "umockdev.c"
	}
}

gchar*
umockdev_make_dotdots (const gchar* path)
{
	gint offset = 0;
	guint count = 0U;
	gchar* dots = NULL;
	gchar* _tmp2_;
	gchar* result;
#line 1595 "../src/umockdev.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 1598 "../src/umockdev.vala"
	offset = 0;
#line 1599 "../src/umockdev.vala"
	count = (guint) 0;
#line 1602 "../src/umockdev.vala"
	while (TRUE) {
#line 9990 "umockdev.c"
		guint _tmp0_;
		gint _tmp1_;
#line 1602 "../src/umockdev.vala"
		offset = string_index_of_char (path, (gunichar) '/', offset);
#line 1602 "../src/umockdev.vala"
		if (!(offset >= 0)) {
#line 1602 "../src/umockdev.vala"
			break;
#line 9999 "umockdev.c"
		}
#line 1603 "../src/umockdev.vala"
		count = count + 1;
#line 1603 "../src/umockdev.vala"
		_tmp0_ = count;
#line 1604 "../src/umockdev.vala"
		offset = offset + 1;
#line 1604 "../src/umockdev.vala"
		_tmp1_ = offset;
#line 10009 "umockdev.c"
	}
#line 1608 "../src/umockdev.vala"
	_tmp2_ = g_strdup ("");
#line 1608 "../src/umockdev.vala"
	dots = _tmp2_;
#line 1609 "../src/umockdev.vala"
	while (TRUE) {
#line 10017 "umockdev.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		guint _tmp5_;
#line 1609 "../src/umockdev.vala"
		if (!(count > ((guint) 1))) {
#line 1609 "../src/umockdev.vala"
			break;
#line 10025 "umockdev.c"
		}
#line 1610 "../src/umockdev.vala"
		_tmp3_ = dots;
#line 1610 "../src/umockdev.vala"
		_tmp4_ = g_strconcat (_tmp3_, "../", NULL);
#line 1610 "../src/umockdev.vala"
		_g_free0 (dots);
#line 1610 "../src/umockdev.vala"
		dots = _tmp4_;
#line 1611 "../src/umockdev.vala"
		count = count - 1;
#line 1611 "../src/umockdev.vala"
		_tmp5_ = count;
#line 10039 "umockdev.c"
	}
#line 1613 "../src/umockdev.vala"
	result = dots;
#line 1613 "../src/umockdev.vala"
	return result;
#line 10045 "umockdev.c"
}

guint8
umockdev_hexdigit (gchar c)
{
	gint _tmp0_ = 0;
	guint8 result;
#line 1619 "../src/umockdev.vala"
	if (c >= 'a') {
#line 1619 "../src/umockdev.vala"
		_tmp0_ = (c - 'a') + 10;
#line 10057 "umockdev.c"
	} else {
		gint _tmp1_ = 0;
#line 1620 "../src/umockdev.vala"
		if (c >= 'A') {
#line 1620 "../src/umockdev.vala"
			_tmp1_ = (c - 'A') + 10;
#line 10064 "umockdev.c"
		} else {
#line 1621 "../src/umockdev.vala"
			_tmp1_ = (gint) (c - '0');
#line 10068 "umockdev.c"
		}
#line 1620 "../src/umockdev.vala"
		_tmp0_ = _tmp1_;
#line 10072 "umockdev.c"
	}
#line 1619 "../src/umockdev.vala"
	result = (guint8) _tmp0_;
#line 1619 "../src/umockdev.vala"
	return result;
#line 10078 "umockdev.c"
}

guint8*
umockdev_decode_hex (const gchar* data,
                     gint* result_length1,
                     GError** error)
{
	gint _tmp0_;
	gint _tmp1_;
	gint len = 0;
	gint _tmp3_;
	gint _tmp4_;
	guint8* bin = NULL;
	guint8* _tmp5_;
	gint bin_length1;
	gint _bin_size_;
	guint8* _tmp10_;
	gint _tmp10__length1;
	GError* _inner_error0_ = NULL;
	guint8* result;
#line 1624 "../src/umockdev.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 1628 "../src/umockdev.vala"
	_tmp0_ = strlen (data);
#line 1628 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 1628 "../src/umockdev.vala"
	if ((_tmp1_ % 2) != 0) {
#line 10107 "umockdev.c"
		GError* _tmp2_;
#line 1629 "../src/umockdev.vala"
		_tmp2_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "malformed hexadecimal value: %s", data);
#line 1629 "../src/umockdev.vala"
		_inner_error0_ = _tmp2_;
#line 1629 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1629 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1629 "../src/umockdev.vala"
			return NULL;
#line 10119 "umockdev.c"
		} else {
#line 1629 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1629 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1629 "../src/umockdev.vala"
			return NULL;
#line 10127 "umockdev.c"
		}
	}
#line 1630 "../src/umockdev.vala"
	_tmp3_ = strlen (data);
#line 1630 "../src/umockdev.vala"
	_tmp4_ = _tmp3_;
#line 1630 "../src/umockdev.vala"
	len = _tmp4_;
#line 1631 "../src/umockdev.vala"
	_tmp5_ = g_new0 (guint8, len / 2);
#line 1631 "../src/umockdev.vala"
	bin = _tmp5_;
#line 1631 "../src/umockdev.vala"
	bin_length1 = len / 2;
#line 1631 "../src/umockdev.vala"
	_bin_size_ = bin_length1;
#line 10144 "umockdev.c"
	{
		guint i = 0U;
#line 1633 "../src/umockdev.vala"
		i = (guint) 0;
#line 10149 "umockdev.c"
		{
			gboolean _tmp6_ = FALSE;
#line 1633 "../src/umockdev.vala"
			_tmp6_ = TRUE;
#line 1633 "../src/umockdev.vala"
			while (TRUE) {
#line 10156 "umockdev.c"
				guint8* _tmp8_;
				gint _tmp8__length1;
				guint8* _tmp9_;
				gint _tmp9__length1;
#line 1633 "../src/umockdev.vala"
				if (!_tmp6_) {
#line 10163 "umockdev.c"
					guint _tmp7_;
#line 1633 "../src/umockdev.vala"
					i = i + 1;
#line 1633 "../src/umockdev.vala"
					_tmp7_ = i;
#line 10169 "umockdev.c"
				}
#line 1633 "../src/umockdev.vala"
				_tmp6_ = FALSE;
#line 1633 "../src/umockdev.vala"
				_tmp8_ = bin;
#line 1633 "../src/umockdev.vala"
				_tmp8__length1 = bin_length1;
#line 1633 "../src/umockdev.vala"
				if (!(i < ((guint) _tmp8__length1))) {
#line 1633 "../src/umockdev.vala"
					break;
#line 10181 "umockdev.c"
				}
#line 1634 "../src/umockdev.vala"
				_tmp9_ = bin;
#line 1634 "../src/umockdev.vala"
				_tmp9__length1 = bin_length1;
#line 1634 "../src/umockdev.vala"
				_tmp9_[i] = (guint8) ((umockdev_hexdigit (string_get (data, (glong) (i * 2))) << 4) | umockdev_hexdigit (string_get (data, (glong) ((i * 2) + 1))));
#line 10189 "umockdev.c"
			}
		}
	}
#line 1636 "../src/umockdev.vala"
	_tmp10_ = bin;
#line 1636 "../src/umockdev.vala"
	_tmp10__length1 = bin_length1;
#line 1636 "../src/umockdev.vala"
	if (result_length1) {
#line 1636 "../src/umockdev.vala"
		*result_length1 = _tmp10__length1;
#line 10201 "umockdev.c"
	}
#line 1636 "../src/umockdev.vala"
	result = _tmp10_;
#line 1636 "../src/umockdev.vala"
	return result;
#line 10207 "umockdev.c"
}

gchar*
umockdev_find_devnode (const gchar* devpath)
{
	gchar* devname = NULL;
	GFile* f = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1639 "../src/umockdev.vala"
	g_return_val_if_fail (devpath != NULL, NULL);
#line 1642 "../src/umockdev.vala"
	devname = NULL;
#line 1645 "../src/umockdev.vala"
	_tmp0_ = g_build_filename (devpath, "uevent", NULL);
#line 1645 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 1645 "../src/umockdev.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 1645 "../src/umockdev.vala"
	_tmp3_ = _tmp2_;
#line 1645 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 1645 "../src/umockdev.vala"
	f = _tmp3_;
#line 10237 "umockdev.c"
	{
		GFileInputStream* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFileInputStream* _tmp6_;
		GDataInputStream* inp = NULL;
		GDataInputStream* _tmp7_;
		gchar* line = NULL;
		gsize len = 0UL;
		GDataInputStream* _tmp20_;
#line 1647 "../src/umockdev.vala"
		_tmp5_ = f;
#line 1647 "../src/umockdev.vala"
		_tmp6_ = g_file_read (_tmp5_, NULL, &_inner_error0_);
#line 1647 "../src/umockdev.vala"
		_tmp4_ = _tmp6_;
#line 1647 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10255 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1647 "../src/umockdev.vala"
		_tmp7_ = g_data_input_stream_new ((GInputStream*) _tmp4_);
#line 1647 "../src/umockdev.vala"
		inp = _tmp7_;
#line 1650 "../src/umockdev.vala"
		while (TRUE) {
#line 10264 "umockdev.c"
			gchar* _tmp8_ = NULL;
			GDataInputStream* _tmp9_;
			gsize _tmp10_ = 0UL;
			gchar* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 1650 "../src/umockdev.vala"
			_tmp9_ = inp;
#line 1650 "../src/umockdev.vala"
			_tmp11_ = g_data_input_stream_read_line (_tmp9_, &_tmp10_, NULL, &_inner_error0_);
#line 1650 "../src/umockdev.vala"
			len = _tmp10_;
#line 1650 "../src/umockdev.vala"
			_tmp8_ = _tmp11_;
#line 1650 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1650 "../src/umockdev.vala"
				_g_free0 (line);
#line 1650 "../src/umockdev.vala"
				_g_object_unref0 (inp);
#line 1650 "../src/umockdev.vala"
				_g_object_unref0 (_tmp4_);
#line 10288 "umockdev.c"
				goto __catch0_g_error;
			}
#line 1650 "../src/umockdev.vala"
			_tmp12_ = _tmp8_;
#line 1650 "../src/umockdev.vala"
			_tmp8_ = NULL;
#line 1650 "../src/umockdev.vala"
			_g_free0 (line);
#line 1650 "../src/umockdev.vala"
			line = _tmp12_;
#line 1650 "../src/umockdev.vala"
			_tmp13_ = line;
#line 1650 "../src/umockdev.vala"
			if (!(_tmp13_ != NULL)) {
#line 1650 "../src/umockdev.vala"
				_g_free0 (_tmp8_);
#line 1650 "../src/umockdev.vala"
				break;
#line 10307 "umockdev.c"
			}
#line 1651 "../src/umockdev.vala"
			_tmp14_ = line;
#line 1651 "../src/umockdev.vala"
			if (g_str_has_prefix (_tmp14_, "DEVNAME=")) {
#line 10313 "umockdev.c"
				const gchar* _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
#line 1652 "../src/umockdev.vala"
				_tmp15_ = line;
#line 1652 "../src/umockdev.vala"
				_tmp16_ = string_substring (_tmp15_, (glong) 8, (glong) -1);
#line 1652 "../src/umockdev.vala"
				_g_free0 (devname);
#line 1652 "../src/umockdev.vala"
				devname = _tmp16_;
#line 1653 "../src/umockdev.vala"
				_tmp17_ = devname;
#line 1653 "../src/umockdev.vala"
				if (!g_str_has_prefix (_tmp17_, "/dev/")) {
#line 10329 "umockdev.c"
					const gchar* _tmp18_;
					gchar* _tmp19_;
#line 1654 "../src/umockdev.vala"
					_tmp18_ = devname;
#line 1654 "../src/umockdev.vala"
					_tmp19_ = g_strconcat ("/dev/", _tmp18_, NULL);
#line 1654 "../src/umockdev.vala"
					_g_free0 (devname);
#line 1654 "../src/umockdev.vala"
					devname = _tmp19_;
#line 10340 "umockdev.c"
				}
#line 1655 "../src/umockdev.vala"
				_g_free0 (_tmp8_);
#line 1655 "../src/umockdev.vala"
				break;
#line 10346 "umockdev.c"
			}
#line 1650 "../src/umockdev.vala"
			_g_free0 (_tmp8_);
#line 10350 "umockdev.c"
		}
#line 1658 "../src/umockdev.vala"
		_tmp20_ = inp;
#line 1658 "../src/umockdev.vala"
		g_input_stream_close ((GInputStream*) _tmp20_, NULL, &_inner_error0_);
#line 1658 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1658 "../src/umockdev.vala"
			_g_free0 (line);
#line 1658 "../src/umockdev.vala"
			_g_object_unref0 (inp);
#line 1658 "../src/umockdev.vala"
			_g_object_unref0 (_tmp4_);
#line 10364 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1646 "../src/umockdev.vala"
		_g_free0 (line);
#line 1646 "../src/umockdev.vala"
		_g_object_unref0 (inp);
#line 1646 "../src/umockdev.vala"
		_g_object_unref0 (_tmp4_);
#line 10373 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 1646 "../src/umockdev.vala"
		e = _inner_error0_;
#line 1646 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 1660 "../src/umockdev.vala"
		_tmp21_ = e;
#line 1660 "../src/umockdev.vala"
		_tmp22_ = _tmp21_->message;
#line 1660 "../src/umockdev.vala"
		g_warning ("umockdev.vala:1660: Cannot read uevent file: %s\n", _tmp22_);
#line 1646 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 10393 "umockdev.c"
	}
	__finally0:
#line 1646 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1646 "../src/umockdev.vala"
		_g_object_unref0 (f);
#line 1646 "../src/umockdev.vala"
		_g_free0 (devname);
#line 1646 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1646 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 1646 "../src/umockdev.vala"
		return NULL;
#line 10408 "umockdev.c"
	}
#line 1662 "../src/umockdev.vala"
	result = devname;
#line 1662 "../src/umockdev.vala"
	_g_object_unref0 (f);
#line 1662 "../src/umockdev.vala"
	return result;
#line 10416 "umockdev.c"
}

static inline gpointer
umockdev_script_runner_get_instance_private (UMockdevScriptRunner* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevScriptRunner_private_offset);
}

static gpointer
_umockdev_script_runner_run_gthread_func (gpointer self)
{
	gpointer result;
	result = umockdev_script_runner_run ((UMockdevScriptRunner*) self);
#line 1678 "../src/umockdev.vala"
	umockdev_script_runner_unref (self);
#line 1678 "../src/umockdev.vala"
	return result;
#line 10434 "umockdev.c"
}

UMockdevScriptRunner*
umockdev_script_runner_construct (GType object_type,
                                  const gchar* device,
                                  const gchar* script_file,
                                  gint fd,
                                  GError** error)
{
	UMockdevScriptRunner* self = NULL;
	FILE* _tmp0_;
	FILE* _tmp1_;
	gchar* _tmp6_;
	GThread* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 1667 "../src/umockdev.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 1667 "../src/umockdev.vala"
	g_return_val_if_fail (script_file != NULL, NULL);
#line 1667 "../src/umockdev.vala"
	self = (UMockdevScriptRunner*) g_type_create_instance (object_type);
#line 1669 "../src/umockdev.vala"
	_tmp0_ = g_fopen (script_file, "r");
#line 1669 "../src/umockdev.vala"
	_fclose0 (self->priv->script);
#line 1669 "../src/umockdev.vala"
	self->priv->script = _tmp0_;
#line 1670 "../src/umockdev.vala"
	_tmp1_ = self->priv->script;
#line 1670 "../src/umockdev.vala"
	if (_tmp1_ == NULL) {
#line 10466 "umockdev.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 1671 "../src/umockdev.vala"
		_tmp2_ = g_strconcat ("Cannot open script record file ", script_file, NULL);
#line 1671 "../src/umockdev.vala"
		_tmp3_ = _tmp2_;
#line 1671 "../src/umockdev.vala"
		_tmp4_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp3_);
#line 1671 "../src/umockdev.vala"
		_tmp5_ = _tmp4_;
#line 1671 "../src/umockdev.vala"
		_g_free0 (_tmp3_);
#line 1671 "../src/umockdev.vala"
		_inner_error0_ = _tmp5_;
#line 1671 "../src/umockdev.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1671 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1671 "../src/umockdev.vala"
			_umockdev_script_runner_unref0 (self);
#line 1671 "../src/umockdev.vala"
			return NULL;
#line 10491 "umockdev.c"
		} else {
#line 1671 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1671 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1671 "../src/umockdev.vala"
			return NULL;
#line 10499 "umockdev.c"
		}
	}
#line 1673 "../src/umockdev.vala"
	umockdev_script_runner_set_device (self, device);
#line 1674 "../src/umockdev.vala"
	_tmp6_ = g_strdup (script_file);
#line 1674 "../src/umockdev.vala"
	_g_free0 (self->priv->script_file);
#line 1674 "../src/umockdev.vala"
	self->priv->script_file = _tmp6_;
#line 1675 "../src/umockdev.vala"
	self->priv->fd = fd;
#line 1676 "../src/umockdev.vala"
	self->priv->running = TRUE;
#line 1678 "../src/umockdev.vala"
	_tmp7_ = g_thread_new (device, _umockdev_script_runner_run_gthread_func, umockdev_script_runner_ref (self));
#line 1678 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->thread);
#line 1678 "../src/umockdev.vala"
	self->priv->thread = _tmp7_;
#line 1667 "../src/umockdev.vala"
	return self;
#line 10522 "umockdev.c"
}

UMockdevScriptRunner*
umockdev_script_runner_new (const gchar* device,
                            const gchar* script_file,
                            gint fd,
                            GError** error)
{
#line 1667 "../src/umockdev.vala"
	return umockdev_script_runner_construct (UMOCKDEV_TYPE_SCRIPT_RUNNER, device, script_file, fd, error);
#line 10533 "umockdev.c"
}

void
umockdev_script_runner_stop (UMockdevScriptRunner* self)
{
	const gchar* _tmp0_;
	GThread* _tmp1_;
#line 1686 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1688 "../src/umockdev.vala"
	if (!self->priv->running) {
#line 1689 "../src/umockdev.vala"
		return;
#line 10547 "umockdev.c"
	}
#line 1691 "../src/umockdev.vala"
	_tmp0_ = self->priv->_device;
#line 1691 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1691: Stopping script runner for %s: joining thread", _tmp0_);
#line 1692 "../src/umockdev.vala"
	self->priv->running = FALSE;
#line 1693 "../src/umockdev.vala"
	_tmp1_ = self->priv->thread;
#line 1693 "../src/umockdev.vala"
	self->priv->thread = NULL;
#line 1693 "../src/umockdev.vala"
	g_thread_join (_tmp1_);
#line 10561 "umockdev.c"
}

static void*
umockdev_script_runner_run (UMockdevScriptRunner* self)
{
	gchar op = '\0';
	guint32 delta = 0U;
	guint8* data = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	const gchar* _tmp0_;
	const gchar* _tmp22_;
	void* result;
#line 1696 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1702 "../src/umockdev.vala"
	_tmp0_ = self->priv->_device;
#line 1702 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1702: ScriptRunner[%s]: start", _tmp0_);
#line 1704 "../src/umockdev.vala"
	while (TRUE) {
#line 10583 "umockdev.c"
		gchar _tmp1_ = '\0';
		guint32 _tmp2_ = 0U;
		gint _tmp3_ = 0;
		guint8* _tmp4_;
#line 1704 "../src/umockdev.vala"
		if (!self->priv->running) {
#line 1704 "../src/umockdev.vala"
			break;
#line 10592 "umockdev.c"
		}
#line 1705 "../src/umockdev.vala"
		_tmp4_ = umockdev_script_runner_next_line (self, &_tmp1_, &_tmp2_, &_tmp3_);
#line 1705 "../src/umockdev.vala"
		op = _tmp1_;
#line 1705 "../src/umockdev.vala"
		delta = _tmp2_;
#line 1705 "../src/umockdev.vala"
		data = (g_free (data), NULL);
#line 1705 "../src/umockdev.vala"
		data = _tmp4_;
#line 1705 "../src/umockdev.vala"
		data_length1 = _tmp3_;
#line 1705 "../src/umockdev.vala"
		_data_size_ = data_length1;
#line 1707 "../src/umockdev.vala"
		switch (op) {
#line 1707 "../src/umockdev.vala"
			case 'r':
#line 10612 "umockdev.c"
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gssize l = 0L;
				guint8* _tmp10_;
				gint _tmp10__length1;
				guint8* _tmp11_;
				gint _tmp11__length1;
				guint8* _tmp13_;
				gint _tmp13__length1;
#line 1709 "../src/umockdev.vala"
				_tmp5_ = self->priv->_device;
#line 1709 "../src/umockdev.vala"
				g_debug ("ScriptRunner[%s]: read op; sleeping %" G_GUINT32_FORMAT " ms", _tmp5_, delta);
#line 1711 "../src/umockdev.vala"
				g_usleep ((gulong) (delta * 1000));
#line 1712 "../src/umockdev.vala"
				_tmp6_ = self->priv->_device;
#line 1712 "../src/umockdev.vala"
				_tmp7_ = data;
#line 1712 "../src/umockdev.vala"
				_tmp7__length1 = data_length1;
#line 1712 "../src/umockdev.vala"
				_tmp8_ = umockdev_script_runner_encode (_tmp7_, (gint) _tmp7__length1);
#line 1712 "../src/umockdev.vala"
				_tmp9_ = _tmp8_;
#line 1712 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1712: ScriptRunner[%s]: read op after sleep; writing dat" \
"a '%s'", _tmp6_, _tmp9_);
#line 1712 "../src/umockdev.vala"
				_g_free0 (_tmp9_);
#line 1713 "../src/umockdev.vala"
				_tmp10_ = data;
#line 1713 "../src/umockdev.vala"
				_tmp10__length1 = data_length1;
#line 1713 "../src/umockdev.vala"
				_tmp11_ = data;
#line 1713 "../src/umockdev.vala"
				_tmp11__length1 = data_length1;
#line 1713 "../src/umockdev.vala"
				l = write (self->priv->fd, _tmp10_, (gsize) _tmp11__length1);
#line 1714 "../src/umockdev.vala"
				if (l < ((gssize) 0)) {
#line 10659 "umockdev.c"
					const gchar* _tmp12_;
#line 1715 "../src/umockdev.vala"
					_tmp12_ = self->priv->_device;
#line 1715 "../src/umockdev.vala"
					g_error ("umockdev.vala:1715: ScriptRunner[%s]: write failed: %m", _tmp12_);
#line 10665 "umockdev.c"
				}
#line 1716 "../src/umockdev.vala"
				_tmp13_ = data;
#line 1716 "../src/umockdev.vala"
				_tmp13__length1 = data_length1;
#line 1716 "../src/umockdev.vala"
				_vala_assert (l == ((gssize) _tmp13__length1), "l == data.length");
#line 1717 "../src/umockdev.vala"
				break;
#line 10675 "umockdev.c"
			}
#line 1707 "../src/umockdev.vala"
			case 'w':
#line 10679 "umockdev.c"
			{
				const gchar* _tmp14_;
				guint8* _tmp15_;
				gint _tmp15__length1;
				gchar* _tmp16_;
				gchar* _tmp17_;
				guint8* _tmp18_;
				gint _tmp18__length1;
#line 1720 "../src/umockdev.vala"
				_tmp14_ = self->priv->_device;
#line 1720 "../src/umockdev.vala"
				_tmp15_ = data;
#line 1720 "../src/umockdev.vala"
				_tmp15__length1 = data_length1;
#line 1720 "../src/umockdev.vala"
				_tmp16_ = umockdev_script_runner_encode (_tmp15_, (gint) _tmp15__length1);
#line 1720 "../src/umockdev.vala"
				_tmp17_ = _tmp16_;
#line 1720 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1720: ScriptRunner[%s]: write op, data '%s'", _tmp14_, _tmp17_);
#line 1720 "../src/umockdev.vala"
				_g_free0 (_tmp17_);
#line 1721 "../src/umockdev.vala"
				_tmp18_ = data;
#line 1721 "../src/umockdev.vala"
				_tmp18__length1 = data_length1;
#line 1721 "../src/umockdev.vala"
				umockdev_script_runner_op_write (self, _tmp18_, (gint) _tmp18__length1, delta);
#line 1722 "../src/umockdev.vala"
				break;
#line 10710 "umockdev.c"
			}
#line 1707 "../src/umockdev.vala"
			case 'Q':
#line 10714 "umockdev.c"
			{
#line 1725 "../src/umockdev.vala"
				self->priv->running = FALSE;
#line 1726 "../src/umockdev.vala"
				break;
#line 10720 "umockdev.c"
			}
#line 1707 "../src/umockdev.vala"
			case 'f':
#line 10724 "umockdev.c"
			{
				const gchar* _tmp20_;
#line 1729 "../src/umockdev.vala"
				if (delta > ((guint32) 100)) {
#line 10729 "umockdev.c"
					const gchar* _tmp19_;
#line 1730 "../src/umockdev.vala"
					_tmp19_ = self->priv->_device;
#line 1730 "../src/umockdev.vala"
					g_error ("umockdev.vala:1730: ScriptRunner[%s]: fuzz value %u is invalid (must b" \
"e between 0 and 100)", _tmp19_, (guint) delta);
#line 10735 "umockdev.c"
				}
#line 1732 "../src/umockdev.vala"
				self->priv->fuzz = (guint) delta;
#line 1733 "../src/umockdev.vala"
				_tmp20_ = self->priv->_device;
#line 1733 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1733: ScriptRunner[%s]: setting fuzz level to %u%%", _tmp20_, self->priv->fuzz);
#line 1734 "../src/umockdev.vala"
				break;
#line 10745 "umockdev.c"
			}
#line 1707 "../src/umockdev.vala"
			case 'd':
#line 10749 "umockdev.c"
			{
#line 1738 "../src/umockdev.vala"
				break;
#line 10753 "umockdev.c"
			}
			default:
			{
				const gchar* _tmp21_;
#line 1741 "../src/umockdev.vala"
				_tmp21_ = self->priv->_device;
#line 1741 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1741: ScriptRunner[%s]: got unknown line op %c, ignoring", _tmp21_, (gint) op);
#line 1742 "../src/umockdev.vala"
				break;
#line 10764 "umockdev.c"
			}
		}
	}
#line 1746 "../src/umockdev.vala"
	_tmp22_ = self->priv->_device;
#line 1746 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1746: ScriptRunner[%s]: not running any more, ending thr" \
"ead", _tmp22_);
#line 1747 "../src/umockdev.vala"
	result = NULL;
#line 1747 "../src/umockdev.vala"
	data = (g_free (data), NULL);
#line 1747 "../src/umockdev.vala"
	return result;
#line 10778 "umockdev.c"
}

static gchar*
g_file_stream_read_line (FILE* self)
{
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp3_;
	gchar* result;
#line 3998 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4000 "glib-2.0.vapi"
	ret = NULL;
#line 4001 "glib-2.0.vapi"
	while (TRUE) {
#line 10794 "umockdev.c"
		GString* _tmp0_;
		GString* _tmp2_;
#line 4001 "glib-2.0.vapi"
		c = fgetc (self);
#line 4001 "glib-2.0.vapi"
		if (!(c != EOF)) {
#line 4001 "glib-2.0.vapi"
			break;
#line 10803 "umockdev.c"
		}
#line 4002 "glib-2.0.vapi"
		_tmp0_ = ret;
#line 4002 "glib-2.0.vapi"
		if (_tmp0_ == NULL) {
#line 10809 "umockdev.c"
			GString* _tmp1_;
#line 4003 "glib-2.0.vapi"
			_tmp1_ = g_string_new ("");
#line 4003 "glib-2.0.vapi"
			_g_string_free0 (ret);
#line 4003 "glib-2.0.vapi"
			ret = _tmp1_;
#line 10817 "umockdev.c"
		}
#line 4005 "glib-2.0.vapi"
		if (c == ((gint) '\n')) {
#line 4006 "glib-2.0.vapi"
			break;
#line 10823 "umockdev.c"
		}
#line 4008 "glib-2.0.vapi"
		_tmp2_ = ret;
#line 4008 "glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp2_, (gchar) c);
#line 10829 "umockdev.c"
	}
#line 4010 "glib-2.0.vapi"
	_tmp3_ = ret;
#line 4010 "glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 4011 "glib-2.0.vapi"
		result = NULL;
#line 4011 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4011 "glib-2.0.vapi"
		return result;
#line 10841 "umockdev.c"
	} else {
		GString* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 4013 "glib-2.0.vapi"
		_tmp4_ = ret;
#line 4013 "glib-2.0.vapi"
		_tmp5_ = ((GString*) _tmp4_)->str;
#line 4013 "glib-2.0.vapi"
		_tmp6_ = g_strdup (_tmp5_);
#line 4013 "glib-2.0.vapi"
		result = _tmp6_;
#line 4013 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4013 "glib-2.0.vapi"
		return result;
#line 10858 "umockdev.c"
	}
}

static guint8*
umockdev_script_runner_next_line (UMockdevScriptRunner* self,
                                  gchar* op,
                                  guint32* delta,
                                  gint* result_length1)
{
	gchar _vala_op = '\0';
	guint32 _vala_delta = 0U;
	gint c = 0;
	glong cur_pos = 0L;
	FILE* _tmp9_;
	FILE* _tmp10_;
	FILE* _tmp12_;
	FILE* _tmp13_;
	guint32 _tmp14_ = 0U;
	gint _tmp15_;
	gchar* line = NULL;
	FILE* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gint _tmp21_ = 0;
	guint8* _tmp22_;
	guint8* _tmp23_;
	gint _tmp23__length1;
	guint8* result;
#line 1750 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10890 "umockdev.c"
	{
		gboolean _tmp0_ = FALSE;
#line 1754 "../src/umockdev.vala"
		_tmp0_ = TRUE;
#line 1754 "../src/umockdev.vala"
		while (TRUE) {
#line 10897 "umockdev.c"
			FILE* _tmp1_;
#line 1754 "../src/umockdev.vala"
			if (!_tmp0_) {
#line 10901 "umockdev.c"
			}
#line 1754 "../src/umockdev.vala"
			_tmp0_ = FALSE;
#line 1755 "../src/umockdev.vala"
			_tmp1_ = self->priv->script;
#line 1755 "../src/umockdev.vala"
			c = fgetc (_tmp1_);
#line 1756 "../src/umockdev.vala"
			if (c == EOF) {
#line 10911 "umockdev.c"
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				guint8* _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
#line 1757 "../src/umockdev.vala"
				_tmp2_ = self->priv->_device;
#line 1757 "../src/umockdev.vala"
				_tmp3_ = self->priv->script_file;
#line 1757 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1757: ScriptRunner[%s]: end of script %s, closing", _tmp2_, _tmp3_);
#line 1758 "../src/umockdev.vala"
				_vala_op = 'Q';
#line 1759 "../src/umockdev.vala"
				_vala_delta = (guint32) 0;
#line 1760 "../src/umockdev.vala"
				_tmp4_ = g_new0 (guint8, 0);
#line 1760 "../src/umockdev.vala"
				_tmp5_ = _tmp4_;
#line 1760 "../src/umockdev.vala"
				_tmp5__length1 = 0;
#line 1760 "../src/umockdev.vala"
				if (result_length1) {
#line 1760 "../src/umockdev.vala"
					*result_length1 = _tmp5__length1;
#line 10937 "umockdev.c"
				}
#line 1760 "../src/umockdev.vala"
				result = _tmp5_;
#line 1760 "../src/umockdev.vala"
				if (op) {
#line 1760 "../src/umockdev.vala"
					*op = _vala_op;
#line 10945 "umockdev.c"
				}
#line 1760 "../src/umockdev.vala"
				if (delta) {
#line 1760 "../src/umockdev.vala"
					*delta = _vala_delta;
#line 10951 "umockdev.c"
				}
#line 1760 "../src/umockdev.vala"
				return result;
#line 10955 "umockdev.c"
			} else {
#line 1761 "../src/umockdev.vala"
				if (c == ((gint) '#')) {
#line 10959 "umockdev.c"
					FILE* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
#line 1762 "../src/umockdev.vala"
					_tmp6_ = self->priv->script;
#line 1762 "../src/umockdev.vala"
					_tmp7_ = g_file_stream_read_line (_tmp6_);
#line 1762 "../src/umockdev.vala"
					_tmp8_ = _tmp7_;
#line 1762 "../src/umockdev.vala"
					_vala_assert (_tmp8_ != NULL, "this.script.read_line () != null");
#line 1762 "../src/umockdev.vala"
					_g_free0 (_tmp8_);
#line 10973 "umockdev.c"
				} else {
#line 1763 "../src/umockdev.vala"
					if (c != ((gint) '\n')) {
#line 1764 "../src/umockdev.vala"
						_vala_op = (gchar) c;
#line 1765 "../src/umockdev.vala"
						break;
#line 10981 "umockdev.c"
					}
				}
			}
		}
	}
#line 1769 "../src/umockdev.vala"
	_tmp9_ = self->priv->script;
#line 1769 "../src/umockdev.vala"
	cur_pos = ftell (_tmp9_);
#line 1770 "../src/umockdev.vala"
	_tmp10_ = self->priv->script;
#line 1770 "../src/umockdev.vala"
	if (fgetc (_tmp10_) != ((gint) ' ')) {
#line 10995 "umockdev.c"
		const gchar* _tmp11_;
#line 1771 "../src/umockdev.vala"
		_tmp11_ = self->priv->script_file;
#line 1771 "../src/umockdev.vala"
		g_error ("umockdev.vala:1771: Missing space after operation code in %s at positi" \
"on %li", _tmp11_, cur_pos);
#line 11001 "umockdev.c"
	}
#line 1774 "../src/umockdev.vala"
	_tmp12_ = self->priv->script;
#line 1774 "../src/umockdev.vala"
	cur_pos = ftell (_tmp12_);
#line 1775 "../src/umockdev.vala"
	_tmp13_ = self->priv->script;
#line 1775 "../src/umockdev.vala"
	_tmp15_ = fscanf (_tmp13_, "%" G_GUINT32_FORMAT " ", &_tmp14_);
#line 1775 "../src/umockdev.vala"
	_vala_delta = _tmp14_;
#line 1775 "../src/umockdev.vala"
	if (_tmp15_ != 1) {
#line 11015 "umockdev.c"
		const gchar* _tmp16_;
#line 1776 "../src/umockdev.vala"
		_tmp16_ = self->priv->script_file;
#line 1776 "../src/umockdev.vala"
		g_error ("umockdev.vala:1776: Cannot parse time in %s at position %li", _tmp16_, cur_pos);
#line 11021 "umockdev.c"
	}
#line 1779 "../src/umockdev.vala"
	_tmp17_ = self->priv->script;
#line 1779 "../src/umockdev.vala"
	_tmp18_ = g_file_stream_read_line (_tmp17_);
#line 1779 "../src/umockdev.vala"
	line = _tmp18_;
#line 1780 "../src/umockdev.vala"
	_tmp19_ = line;
#line 1780 "../src/umockdev.vala"
	_vala_assert (_tmp19_ != NULL, "line != null");
#line 1782 "../src/umockdev.vala"
	_tmp20_ = line;
#line 1782 "../src/umockdev.vala"
	_tmp22_ = umockdev_script_runner_decode (_tmp20_, &_tmp21_);
#line 1782 "../src/umockdev.vala"
	_tmp23_ = _tmp22_;
#line 1782 "../src/umockdev.vala"
	_tmp23__length1 = _tmp21_;
#line 1782 "../src/umockdev.vala"
	if (result_length1) {
#line 1782 "../src/umockdev.vala"
		*result_length1 = _tmp23__length1;
#line 11045 "umockdev.c"
	}
#line 1782 "../src/umockdev.vala"
	result = _tmp23_;
#line 1782 "../src/umockdev.vala"
	_g_free0 (line);
#line 1782 "../src/umockdev.vala"
	if (op) {
#line 1782 "../src/umockdev.vala"
		*op = _vala_op;
#line 11055 "umockdev.c"
	}
#line 1782 "../src/umockdev.vala"
	if (delta) {
#line 1782 "../src/umockdev.vala"
		*delta = _vala_delta;
#line 11061 "umockdev.c"
	}
#line 1782 "../src/umockdev.vala"
	return result;
#line 11065 "umockdev.c"
}

static void
umockdev_script_runner_op_write (UMockdevScriptRunner* self,
                                 guint8* data,
                                 gint data_length1,
                                 guint32 delta)
{
	fd_set fds = {0};
	struct timeval timeout = {0};
	struct timeval _tmp0_ = {0};
	gssize len = 0L;
	guint8* buf = NULL;
	guint8* _tmp1_;
	gint buf_length1;
	gint _buf_size_;
#line 1785 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1788 "../src/umockdev.vala"
	_tmp0_.tv_sec = (time_t) 0;
#line 1788 "../src/umockdev.vala"
	_tmp0_.tv_usec = (glong) 200000;
#line 1788 "../src/umockdev.vala"
	timeout = _tmp0_;
#line 1789 "../src/umockdev.vala"
	len = (gssize) 0;
#line 1790 "../src/umockdev.vala"
	_tmp1_ = g_new0 (guint8, data_length1);
#line 1790 "../src/umockdev.vala"
	buf = _tmp1_;
#line 1790 "../src/umockdev.vala"
	buf_length1 = data_length1;
#line 1790 "../src/umockdev.vala"
	_buf_size_ = buf_length1;
#line 1794 "../src/umockdev.vala"
	while (TRUE) {
#line 11102 "umockdev.c"
		gboolean _tmp2_ = FALSE;
		fd_set _tmp3_ = {0};
		gint res = 0;
		struct timeval _tmp4_;
		gssize ret = 0L;
		guint8* _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp14_;
#line 1794 "../src/umockdev.vala"
		if (self->priv->running) {
#line 1794 "../src/umockdev.vala"
			_tmp2_ = len < ((gssize) data_length1);
#line 11115 "umockdev.c"
		} else {
#line 1794 "../src/umockdev.vala"
			_tmp2_ = FALSE;
#line 11119 "umockdev.c"
		}
#line 1794 "../src/umockdev.vala"
		if (!_tmp2_) {
#line 1794 "../src/umockdev.vala"
			break;
#line 11125 "umockdev.c"
		}
#line 1795 "../src/umockdev.vala"
		FD_ZERO (&_tmp3_);
#line 1795 "../src/umockdev.vala"
		fds = _tmp3_;
#line 1796 "../src/umockdev.vala"
		FD_SET (self->priv->fd, &fds);
#line 1797 "../src/umockdev.vala"
		_tmp4_ = timeout;
#line 1797 "../src/umockdev.vala"
		res = select (self->priv->fd + 1, &fds, NULL, NULL, &_tmp4_);
#line 1798 "../src/umockdev.vala"
		if (res < 0) {
#line 11139 "umockdev.c"
			const gchar* _tmp5_;
#line 1799 "../src/umockdev.vala"
			if (errno == EINTR) {
#line 1800 "../src/umockdev.vala"
				continue;
#line 11145 "umockdev.c"
			}
#line 1801 "../src/umockdev.vala"
			_tmp5_ = self->priv->_device;
#line 1801 "../src/umockdev.vala"
			g_error ("umockdev.vala:1801: ScriptRunner op_write[%s]: select() failed: %m", _tmp5_);
#line 11151 "umockdev.c"
		}
#line 1804 "../src/umockdev.vala"
		if (res == 0) {
#line 11155 "umockdev.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 1805 "../src/umockdev.vala"
			_tmp6_ = self->priv->_device;
#line 1805 "../src/umockdev.vala"
			_tmp7_ = umockdev_script_runner_encode (data + ((gint) len), (gint) (data_length1 - ((gint) len)));
#line 1805 "../src/umockdev.vala"
			_tmp8_ = _tmp7_;
#line 1805 "../src/umockdev.vala"
			g_debug ("umockdev.vala:1805: ScriptRunner[%s]: timed out on read operation on e" \
"xpected block '%s', trying again", _tmp6_, _tmp8_);
#line 1805 "../src/umockdev.vala"
			_g_free0 (_tmp8_);
#line 1807 "../src/umockdev.vala"
			continue;
#line 11171 "umockdev.c"
		}
#line 1810 "../src/umockdev.vala"
		_tmp9_ = buf;
#line 1810 "../src/umockdev.vala"
		_tmp9__length1 = buf_length1;
#line 1810 "../src/umockdev.vala"
		ret = read (self->priv->fd, &_tmp9_[len], (gsize) (data_length1 - len));
#line 1812 "../src/umockdev.vala"
		if (ret <= ((gssize) 0)) {
#line 11181 "umockdev.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			FILE* _tmp13_;
#line 1813 "../src/umockdev.vala"
			_tmp10_ = self->priv->_device;
#line 1813 "../src/umockdev.vala"
			_tmp11_ = umockdev_script_runner_encode (data + ((gint) len), (gint) (data_length1 - ((gint) len)));
#line 1813 "../src/umockdev.vala"
			_tmp12_ = _tmp11_;
#line 1813 "../src/umockdev.vala"
			g_debug ("umockdev.vala:1813: ScriptRunner[%s]: got failure or EOF on read opera" \
"tion on expected block '%s', resetting", _tmp10_, _tmp12_);
#line 1813 "../src/umockdev.vala"
			_g_free0 (_tmp12_);
#line 1815 "../src/umockdev.vala"
			_tmp13_ = self->priv->script;
#line 1815 "../src/umockdev.vala"
			fseek (_tmp13_, (glong) 0, SEEK_SET);
#line 1816 "../src/umockdev.vala"
			buf = (g_free (buf), NULL);
#line 1816 "../src/umockdev.vala"
			return;
#line 11204 "umockdev.c"
		}
#line 1819 "../src/umockdev.vala"
		len += ret;
#line 1820 "../src/umockdev.vala"
		_tmp14_ = self->priv->_device;
#line 1820 "../src/umockdev.vala"
		g_debug ("ScriptRunner[%s]: op_write, got %" G_GSSIZE_FORMAT " bytes; expecting  %" G_GSSIZE_FORMAT " more, full block size %i", _tmp14_, ret, data_length1 - len, data_length1);
#line 11212 "umockdev.c"
	}
#line 1825 "../src/umockdev.vala"
	if (!self->priv->running) {
#line 1826 "../src/umockdev.vala"
		buf = (g_free (buf), NULL);
#line 1826 "../src/umockdev.vala"
		return;
#line 11220 "umockdev.c"
	}
#line 1828 "../src/umockdev.vala"
	_vala_assert (len == ((gssize) data_length1), "len == data.length");
#line 1830 "../src/umockdev.vala"
	if (self->priv->fuzz == ((guint) 0)) {
#line 11226 "umockdev.c"
		guint8* _tmp15_;
		gint _tmp15__length1;
#line 1831 "../src/umockdev.vala"
		_tmp15_ = buf;
#line 1831 "../src/umockdev.vala"
		_tmp15__length1 = buf_length1;
#line 1831 "../src/umockdev.vala"
		if (memcmp (_tmp15_, data, (gsize) len) != 0) {
#line 11235 "umockdev.c"
			const gchar* _tmp16_;
			guint8* _tmp17_;
			gint _tmp17__length1;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 1832 "../src/umockdev.vala"
			_tmp16_ = self->priv->_device;
#line 1832 "../src/umockdev.vala"
			_tmp17_ = buf;
#line 1832 "../src/umockdev.vala"
			_tmp17__length1 = buf_length1;
#line 1832 "../src/umockdev.vala"
			_tmp18_ = umockdev_script_runner_encode (_tmp17_, (gint) _tmp17__length1);
#line 1832 "../src/umockdev.vala"
			_tmp19_ = _tmp18_;
#line 1832 "../src/umockdev.vala"
			_tmp20_ = umockdev_script_runner_encode (data, (gint) data_length1);
#line 1832 "../src/umockdev.vala"
			_tmp21_ = _tmp20_;
#line 1832 "../src/umockdev.vala"
			g_error ("ScriptRunner op_write[%s]: data mismatch; got block '%s' (%" G_GSSIZE_FORMAT " bytes), expected block '%s'", _tmp16_, _tmp19_, len, _tmp21_);
#line 1832 "../src/umockdev.vala"
			_g_free0 (_tmp21_);
#line 1832 "../src/umockdev.vala"
			_g_free0 (_tmp19_);
#line 11263 "umockdev.c"
		}
	} else {
		guint d = 0U;
		guint8* _tmp22_;
		gint _tmp22__length1;
#line 1836 "../src/umockdev.vala"
		_tmp22_ = buf;
#line 1836 "../src/umockdev.vala"
		_tmp22__length1 = buf_length1;
#line 1836 "../src/umockdev.vala"
		d = umockdev_script_runner_hamming (_tmp22_, (gint) _tmp22__length1, data, (gint) data_length1);
#line 1837 "../src/umockdev.vala"
		if (((gssize) (d * 100)) > (self->priv->fuzz * len)) {
#line 11277 "umockdev.c"
			const gchar* _tmp23_;
			guint8* _tmp24_;
			gint _tmp24__length1;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
#line 1838 "../src/umockdev.vala"
			_tmp23_ = self->priv->_device;
#line 1838 "../src/umockdev.vala"
			_tmp24_ = buf;
#line 1838 "../src/umockdev.vala"
			_tmp24__length1 = buf_length1;
#line 1838 "../src/umockdev.vala"
			_tmp25_ = umockdev_script_runner_encode (_tmp24_, (gint) _tmp24__length1);
#line 1838 "../src/umockdev.vala"
			_tmp26_ = _tmp25_;
#line 1838 "../src/umockdev.vala"
			_tmp27_ = umockdev_script_runner_encode (data, (gint) data_length1);
#line 1838 "../src/umockdev.vala"
			_tmp28_ = _tmp27_;
#line 1838 "../src/umockdev.vala"
			g_error ("ScriptRunner op_write[%s]: data mismatch; got block '%s' (%" G_GSSIZE_FORMAT " bytes), expected block '%s', difference %u%% > fuzz level %u%%", _tmp23_, _tmp26_, len, _tmp28_, ((guint) (((d * 1000) / len) + 5)) / 10, self->priv->fuzz);
#line 1838 "../src/umockdev.vala"
			_g_free0 (_tmp28_);
#line 1838 "../src/umockdev.vala"
			_g_free0 (_tmp26_);
#line 11305 "umockdev.c"
		} else {
			const gchar* _tmp29_;
			guint8* _tmp30_;
			gint _tmp30__length1;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
#line 1843 "../src/umockdev.vala"
			_tmp29_ = self->priv->_device;
#line 1843 "../src/umockdev.vala"
			_tmp30_ = buf;
#line 1843 "../src/umockdev.vala"
			_tmp30__length1 = buf_length1;
#line 1843 "../src/umockdev.vala"
			_tmp31_ = umockdev_script_runner_encode (_tmp30_, (gint) _tmp30__length1);
#line 1843 "../src/umockdev.vala"
			_tmp32_ = _tmp31_;
#line 1843 "../src/umockdev.vala"
			_tmp33_ = umockdev_script_runner_encode (data, (gint) data_length1);
#line 1843 "../src/umockdev.vala"
			_tmp34_ = _tmp33_;
#line 1843 "../src/umockdev.vala"
			g_debug ("ScriptRunner op_write[%s]: data matches: got block '%s' (%" G_GSSIZE_FORMAT " bytes), expected block '%s', difference %u%% <= fuzz level %u%%", _tmp29_, _tmp32_, len, _tmp34_, ((guint) (((d * 1000) / len) + 5)) / 10, self->priv->fuzz);
#line 1843 "../src/umockdev.vala"
			_g_free0 (_tmp34_);
#line 1843 "../src/umockdev.vala"
			_g_free0 (_tmp32_);
#line 11334 "umockdev.c"
		}
	}
#line 1785 "../src/umockdev.vala"
	buf = (g_free (buf), NULL);
#line 11339 "umockdev.c"
}

static void
_vala_array_add12 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1857 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1857 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1857 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11354 "umockdev.c"
	}
#line 1857 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11358 "umockdev.c"
}

static void
_vala_array_add13 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1860 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1860 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1860 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11373 "umockdev.c"
	}
#line 1860 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11377 "umockdev.c"
}

static guint8*
umockdev_script_runner_decode (const gchar* quoted,
                               gint* result_length1)
{
	guint8* data = NULL;
	guint8* _tmp0_;
	gint data_length1;
	gint _data_size_;
	guint8* _tmp25_;
	gint _tmp25__length1;
	guint8* result;
#line 1851 "../src/umockdev.vala"
	g_return_val_if_fail (quoted != NULL, NULL);
#line 1853 "../src/umockdev.vala"
	_tmp0_ = g_new0 (guint8, 0);
#line 1853 "../src/umockdev.vala"
	data = _tmp0_;
#line 1853 "../src/umockdev.vala"
	data_length1 = 0;
#line 1853 "../src/umockdev.vala"
	_data_size_ = data_length1;
#line 11401 "umockdev.c"
	{
		gint i = 0;
#line 1854 "../src/umockdev.vala"
		i = 0;
#line 11406 "umockdev.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1854 "../src/umockdev.vala"
			_tmp1_ = TRUE;
#line 1854 "../src/umockdev.vala"
			while (TRUE) {
#line 11413 "umockdev.c"
				gint _tmp3_;
				gint _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
				gint _tmp6_ = 0;
				guint8* _tmp7_;
				gint _tmp7__length1;
				guint8 _tmp8_;
#line 1854 "../src/umockdev.vala"
				if (!_tmp1_) {
#line 11424 "umockdev.c"
					gint _tmp2_;
#line 1854 "../src/umockdev.vala"
					i = i + 1;
#line 1854 "../src/umockdev.vala"
					_tmp2_ = i;
#line 11430 "umockdev.c"
				}
#line 1854 "../src/umockdev.vala"
				_tmp1_ = FALSE;
#line 1854 "../src/umockdev.vala"
				_tmp3_ = strlen (quoted);
#line 1854 "../src/umockdev.vala"
				_tmp4_ = _tmp3_;
#line 1854 "../src/umockdev.vala"
				if (!(i < _tmp4_)) {
#line 1854 "../src/umockdev.vala"
					break;
#line 11442 "umockdev.c"
				}
#line 1855 "../src/umockdev.vala"
				_tmp5_ = string_get_data (quoted, &_tmp6_);
#line 1855 "../src/umockdev.vala"
				_tmp5__length1 = _tmp6_;
#line 1855 "../src/umockdev.vala"
				_tmp7_ = _tmp5_;
#line 1855 "../src/umockdev.vala"
				_tmp7__length1 = _tmp5__length1;
#line 1855 "../src/umockdev.vala"
				_tmp8_ = _tmp7_[i];
#line 1855 "../src/umockdev.vala"
				if (_tmp8_ == ((guint8) '^')) {
#line 11456 "umockdev.c"
					gint _tmp9_;
					gint _tmp10_;
					gchar _tmp11_ = '\0';
					guint8* _tmp12_;
					gint _tmp12__length1;
					gint _tmp13_ = 0;
					guint8* _tmp14_;
					gint _tmp14__length1;
					guint8 _tmp15_;
					gint _tmp20_;
#line 1856 "../src/umockdev.vala"
					_tmp9_ = strlen (quoted);
#line 1856 "../src/umockdev.vala"
					_tmp10_ = _tmp9_;
#line 1856 "../src/umockdev.vala"
					_vala_assert ((i + 1) < _tmp10_, "i + 1 < quoted.length");
#line 1857 "../src/umockdev.vala"
					_tmp12_ = string_get_data (quoted, &_tmp13_);
#line 1857 "../src/umockdev.vala"
					_tmp12__length1 = _tmp13_;
#line 1857 "../src/umockdev.vala"
					_tmp14_ = _tmp12_;
#line 1857 "../src/umockdev.vala"
					_tmp14__length1 = _tmp12__length1;
#line 1857 "../src/umockdev.vala"
					_tmp15_ = _tmp14_[i + 1];
#line 1857 "../src/umockdev.vala"
					if (_tmp15_ == ((guint8) '`')) {
#line 1857 "../src/umockdev.vala"
						_tmp11_ = '^';
#line 11487 "umockdev.c"
					} else {
						guint8* _tmp16_;
						gint _tmp16__length1;
						gint _tmp17_ = 0;
						guint8* _tmp18_;
						gint _tmp18__length1;
						guint8 _tmp19_;
#line 1857 "../src/umockdev.vala"
						_tmp16_ = string_get_data (quoted, &_tmp17_);
#line 1857 "../src/umockdev.vala"
						_tmp16__length1 = _tmp17_;
#line 1857 "../src/umockdev.vala"
						_tmp18_ = _tmp16_;
#line 1857 "../src/umockdev.vala"
						_tmp18__length1 = _tmp16__length1;
#line 1857 "../src/umockdev.vala"
						_tmp19_ = _tmp18_[i + 1];
#line 1857 "../src/umockdev.vala"
						_tmp11_ = (gchar) (_tmp19_ - 64);
#line 11507 "umockdev.c"
					}
#line 1857 "../src/umockdev.vala"
					_vala_array_add12 (&data, &data_length1, &_data_size_, (guint8) _tmp11_);
#line 1858 "../src/umockdev.vala"
					i = i + 1;
#line 1858 "../src/umockdev.vala"
					_tmp20_ = i;
#line 11515 "umockdev.c"
				} else {
					guint8* _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_ = 0;
					guint8* _tmp23_;
					gint _tmp23__length1;
					guint8 _tmp24_;
#line 1860 "../src/umockdev.vala"
					_tmp21_ = string_get_data (quoted, &_tmp22_);
#line 1860 "../src/umockdev.vala"
					_tmp21__length1 = _tmp22_;
#line 1860 "../src/umockdev.vala"
					_tmp23_ = _tmp21_;
#line 1860 "../src/umockdev.vala"
					_tmp23__length1 = _tmp21__length1;
#line 1860 "../src/umockdev.vala"
					_tmp24_ = _tmp23_[i];
#line 1860 "../src/umockdev.vala"
					_vala_array_add13 (&data, &data_length1, &_data_size_, _tmp24_);
#line 11535 "umockdev.c"
				}
			}
		}
	}
#line 1862 "../src/umockdev.vala"
	_tmp25_ = data;
#line 1862 "../src/umockdev.vala"
	_tmp25__length1 = data_length1;
#line 1862 "../src/umockdev.vala"
	if (result_length1) {
#line 1862 "../src/umockdev.vala"
		*result_length1 = _tmp25__length1;
#line 11548 "umockdev.c"
	}
#line 1862 "../src/umockdev.vala"
	result = _tmp25_;
#line 1862 "../src/umockdev.vala"
	return result;
#line 11554 "umockdev.c"
}

static void
_vala_array_add14 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1870 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1870 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1870 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11569 "umockdev.c"
	}
#line 1870 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11573 "umockdev.c"
}

static void
_vala_array_add15 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1871 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1871 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1871 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11588 "umockdev.c"
	}
#line 1871 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11592 "umockdev.c"
}

static void
_vala_array_add16 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1875 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1875 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1875 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11607 "umockdev.c"
	}
#line 1875 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11611 "umockdev.c"
}

static void
_vala_array_add17 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1876 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1876 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1876 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11626 "umockdev.c"
	}
#line 1876 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11630 "umockdev.c"
}

static void
_vala_array_add18 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1878 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1878 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1878 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11645 "umockdev.c"
	}
#line 1878 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11649 "umockdev.c"
}

static void
_vala_array_add19 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1882 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1882 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1882 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11664 "umockdev.c"
	}
#line 1882 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11668 "umockdev.c"
}

gchar*
umockdev_script_runner_encode (guint8* data,
                               gint data_length1)
{
	guint8* quoted = NULL;
	guint8* _tmp0_;
	gint quoted_length1;
	gint _quoted_size_;
	guint8* _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_;
	gchar* result;
#line 1867 "../src/umockdev.vala"
	_tmp0_ = g_new0 (guint8, 0);
#line 1867 "../src/umockdev.vala"
	quoted = _tmp0_;
#line 1867 "../src/umockdev.vala"
	quoted_length1 = 0;
#line 1867 "../src/umockdev.vala"
	_quoted_size_ = quoted_length1;
#line 11691 "umockdev.c"
	{
		gint i = 0;
#line 1868 "../src/umockdev.vala"
		i = 0;
#line 11696 "umockdev.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1868 "../src/umockdev.vala"
			_tmp1_ = TRUE;
#line 1868 "../src/umockdev.vala"
			while (TRUE) {
#line 11703 "umockdev.c"
				guint8 _tmp3_;
#line 1868 "../src/umockdev.vala"
				if (!_tmp1_) {
#line 11707 "umockdev.c"
					gint _tmp2_;
#line 1868 "../src/umockdev.vala"
					i = i + 1;
#line 1868 "../src/umockdev.vala"
					_tmp2_ = i;
#line 11713 "umockdev.c"
				}
#line 1868 "../src/umockdev.vala"
				_tmp1_ = FALSE;
#line 1868 "../src/umockdev.vala"
				if (!(i < data_length1)) {
#line 1868 "../src/umockdev.vala"
					break;
#line 11721 "umockdev.c"
				}
#line 1869 "../src/umockdev.vala"
				_tmp3_ = data[i];
#line 1869 "../src/umockdev.vala"
				if (((gint) _tmp3_) < 32) {
#line 11727 "umockdev.c"
					guint8 _tmp4_;
#line 1870 "../src/umockdev.vala"
					_vala_array_add14 (&quoted, &quoted_length1, &_quoted_size_, (guint8) '^');
#line 1871 "../src/umockdev.vala"
					_tmp4_ = data[i];
#line 1871 "../src/umockdev.vala"
					_vala_array_add15 (&quoted, &quoted_length1, &_quoted_size_, (guint8) (_tmp4_ + 64));
#line 11735 "umockdev.c"
				} else {
					guint8 _tmp5_;
#line 1872 "../src/umockdev.vala"
					_tmp5_ = data[i];
#line 1872 "../src/umockdev.vala"
					if (_tmp5_ == ((guint8) '^')) {
#line 1875 "../src/umockdev.vala"
						_vala_array_add16 (&quoted, &quoted_length1, &_quoted_size_, (guint8) '^');
#line 1876 "../src/umockdev.vala"
						_vala_array_add17 (&quoted, &quoted_length1, &_quoted_size_, (guint8) '`');
#line 11746 "umockdev.c"
					} else {
						guint8 _tmp6_;
#line 1878 "../src/umockdev.vala"
						_tmp6_ = data[i];
#line 1878 "../src/umockdev.vala"
						_vala_array_add18 (&quoted, &quoted_length1, &_quoted_size_, _tmp6_);
#line 11753 "umockdev.c"
					}
				}
			}
		}
	}
#line 1882 "../src/umockdev.vala"
	_vala_array_add19 (&quoted, &quoted_length1, &_quoted_size_, (guint8) 0);
#line 1883 "../src/umockdev.vala"
	_tmp7_ = quoted;
#line 1883 "../src/umockdev.vala"
	_tmp7__length1 = quoted_length1;
#line 1883 "../src/umockdev.vala"
	_tmp8_ = g_strdup ((const gchar*) _tmp7_);
#line 1883 "../src/umockdev.vala"
	result = _tmp8_;
#line 1883 "../src/umockdev.vala"
	quoted = (g_free (quoted), NULL);
#line 1883 "../src/umockdev.vala"
	return result;
#line 11773 "umockdev.c"
}

static guint
umockdev_script_runner_hamming (guint8* d1,
                                gint d1_length1,
                                guint8* d2,
                                gint d2_length1)
{
	guint d = 0U;
	guint i = 0U;
	guint result;
#line 1888 "../src/umockdev.vala"
	_vala_assert (d1_length1 == d2_length1, "d1.length == d2.length");
#line 1889 "../src/umockdev.vala"
	d = (guint) 0;
#line 11789 "umockdev.c"
	{
		gboolean _tmp0_ = FALSE;
#line 1893 "../src/umockdev.vala"
		i = (guint) 0;
#line 1893 "../src/umockdev.vala"
		_tmp0_ = TRUE;
#line 1893 "../src/umockdev.vala"
		while (TRUE) {
#line 11798 "umockdev.c"
			guint8 _tmp2_;
			guint8 _tmp3_;
#line 1893 "../src/umockdev.vala"
			if (!_tmp0_) {
#line 11803 "umockdev.c"
				guint _tmp1_;
#line 1893 "../src/umockdev.vala"
				i = i + 1;
#line 1893 "../src/umockdev.vala"
				_tmp1_ = i;
#line 11809 "umockdev.c"
			}
#line 1893 "../src/umockdev.vala"
			_tmp0_ = FALSE;
#line 1893 "../src/umockdev.vala"
			if (!(i < ((guint) d1_length1))) {
#line 1893 "../src/umockdev.vala"
				break;
#line 11817 "umockdev.c"
			}
#line 1894 "../src/umockdev.vala"
			_tmp2_ = d1[i];
#line 1894 "../src/umockdev.vala"
			_tmp3_ = d2[i];
#line 1894 "../src/umockdev.vala"
			d += (guint) (((gint) (_tmp2_ ^ _tmp3_)) > 0);
#line 11825 "umockdev.c"
		}
	}
#line 1895 "../src/umockdev.vala"
	result = d;
#line 1895 "../src/umockdev.vala"
	return result;
#line 11832 "umockdev.c"
}

const gchar*
umockdev_script_runner_get_device (UMockdevScriptRunner* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1898 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1898 "../src/umockdev.vala"
	_tmp0_ = self->priv->_device;
#line 1898 "../src/umockdev.vala"
	result = _tmp0_;
#line 1898 "../src/umockdev.vala"
	return result;
#line 11848 "umockdev.c"
}

static void
umockdev_script_runner_set_device (UMockdevScriptRunner* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 1898 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1898 "../src/umockdev.vala"
	_tmp0_ = g_strdup (value);
#line 1898 "../src/umockdev.vala"
	_g_free0 (self->priv->_device);
#line 1898 "../src/umockdev.vala"
	self->priv->_device = _tmp0_;
#line 11864 "umockdev.c"
}

static void
umockdev_value_script_runner_init (GValue* value)
{
#line 1665 "../src/umockdev.vala"
	value->data[0].v_pointer = NULL;
#line 11872 "umockdev.c"
}

static void
umockdev_value_script_runner_free_value (GValue* value)
{
#line 1665 "../src/umockdev.vala"
	if (value->data[0].v_pointer) {
#line 1665 "../src/umockdev.vala"
		umockdev_script_runner_unref (value->data[0].v_pointer);
#line 11882 "umockdev.c"
	}
}

static void
umockdev_value_script_runner_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 1665 "../src/umockdev.vala"
	if (src_value->data[0].v_pointer) {
#line 1665 "../src/umockdev.vala"
		dest_value->data[0].v_pointer = umockdev_script_runner_ref (src_value->data[0].v_pointer);
#line 11894 "umockdev.c"
	} else {
#line 1665 "../src/umockdev.vala"
		dest_value->data[0].v_pointer = NULL;
#line 11898 "umockdev.c"
	}
}

static gpointer
umockdev_value_script_runner_peek_pointer (const GValue* value)
{
#line 1665 "../src/umockdev.vala"
	return value->data[0].v_pointer;
#line 11907 "umockdev.c"
}

static gchar*
umockdev_value_script_runner_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 1665 "../src/umockdev.vala"
	if (collect_values[0].v_pointer) {
#line 11918 "umockdev.c"
		UMockdevScriptRunner * object;
		object = collect_values[0].v_pointer;
#line 1665 "../src/umockdev.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1665 "../src/umockdev.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11925 "umockdev.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1665 "../src/umockdev.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11929 "umockdev.c"
		}
#line 1665 "../src/umockdev.vala"
		value->data[0].v_pointer = umockdev_script_runner_ref (object);
#line 11933 "umockdev.c"
	} else {
#line 1665 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 11937 "umockdev.c"
	}
#line 1665 "../src/umockdev.vala"
	return NULL;
#line 11941 "umockdev.c"
}

static gchar*
umockdev_value_script_runner_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	UMockdevScriptRunner ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1665 "../src/umockdev.vala"
	if (!object_p) {
#line 1665 "../src/umockdev.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 11956 "umockdev.c"
	}
#line 1665 "../src/umockdev.vala"
	if (!value->data[0].v_pointer) {
#line 1665 "../src/umockdev.vala"
		*object_p = NULL;
#line 11962 "umockdev.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1665 "../src/umockdev.vala"
		*object_p = value->data[0].v_pointer;
#line 11966 "umockdev.c"
	} else {
#line 1665 "../src/umockdev.vala"
		*object_p = umockdev_script_runner_ref (value->data[0].v_pointer);
#line 11970 "umockdev.c"
	}
#line 1665 "../src/umockdev.vala"
	return NULL;
#line 11974 "umockdev.c"
}

GParamSpec*
umockdev_param_spec_script_runner (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	UMockdevParamSpecScriptRunner* spec;
#line 1665 "../src/umockdev.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UMOCKDEV_TYPE_SCRIPT_RUNNER), NULL);
#line 1665 "../src/umockdev.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1665 "../src/umockdev.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1665 "../src/umockdev.vala"
	return G_PARAM_SPEC (spec);
#line 11993 "umockdev.c"
}

gpointer
umockdev_value_get_script_runner (const GValue* value)
{
#line 1665 "../src/umockdev.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SCRIPT_RUNNER), NULL);
#line 1665 "../src/umockdev.vala"
	return value->data[0].v_pointer;
#line 12003 "umockdev.c"
}

void
umockdev_value_set_script_runner (GValue* value,
                                  gpointer v_object)
{
	UMockdevScriptRunner * old;
#line 1665 "../src/umockdev.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SCRIPT_RUNNER));
#line 1665 "../src/umockdev.vala"
	old = value->data[0].v_pointer;
#line 1665 "../src/umockdev.vala"
	if (v_object) {
#line 1665 "../src/umockdev.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_SCRIPT_RUNNER));
#line 1665 "../src/umockdev.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1665 "../src/umockdev.vala"
		value->data[0].v_pointer = v_object;
#line 1665 "../src/umockdev.vala"
		umockdev_script_runner_ref (value->data[0].v_pointer);
#line 12025 "umockdev.c"
	} else {
#line 1665 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 12029 "umockdev.c"
	}
#line 1665 "../src/umockdev.vala"
	if (old) {
#line 1665 "../src/umockdev.vala"
		umockdev_script_runner_unref (old);
#line 12035 "umockdev.c"
	}
}

void
umockdev_value_take_script_runner (GValue* value,
                                   gpointer v_object)
{
	UMockdevScriptRunner * old;
#line 1665 "../src/umockdev.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SCRIPT_RUNNER));
#line 1665 "../src/umockdev.vala"
	old = value->data[0].v_pointer;
#line 1665 "../src/umockdev.vala"
	if (v_object) {
#line 1665 "../src/umockdev.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_SCRIPT_RUNNER));
#line 1665 "../src/umockdev.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1665 "../src/umockdev.vala"
		value->data[0].v_pointer = v_object;
#line 12056 "umockdev.c"
	} else {
#line 1665 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 12060 "umockdev.c"
	}
#line 1665 "../src/umockdev.vala"
	if (old) {
#line 1665 "../src/umockdev.vala"
		umockdev_script_runner_unref (old);
#line 12066 "umockdev.c"
	}
}

static void
umockdev_script_runner_class_init (UMockdevScriptRunnerClass * klass,
                                   gpointer klass_data)
{
#line 1665 "../src/umockdev.vala"
	umockdev_script_runner_parent_class = g_type_class_peek_parent (klass);
#line 1665 "../src/umockdev.vala"
	((UMockdevScriptRunnerClass *) klass)->finalize = umockdev_script_runner_finalize;
#line 1665 "../src/umockdev.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevScriptRunner_private_offset);
#line 12080 "umockdev.c"
}

static void
umockdev_script_runner_instance_init (UMockdevScriptRunner * self,
                                      gpointer klass)
{
#line 1665 "../src/umockdev.vala"
	self->priv = umockdev_script_runner_get_instance_private (self);
#line 1904 "../src/umockdev.vala"
	self->priv->fuzz = (guint) 0;
#line 1665 "../src/umockdev.vala"
	self->ref_count = 1;
#line 12093 "umockdev.c"
}

static void
umockdev_script_runner_finalize (UMockdevScriptRunner * obj)
{
	UMockdevScriptRunner * self;
#line 1665 "../src/umockdev.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_SCRIPT_RUNNER, UMockdevScriptRunner);
#line 1665 "../src/umockdev.vala"
	g_signal_handlers_destroy (self);
#line 1683 "../src/umockdev.vala"
	umockdev_script_runner_stop (self);
#line 1898 "../src/umockdev.vala"
	_g_free0 (self->priv->_device);
#line 1899 "../src/umockdev.vala"
	_g_free0 (self->priv->script_file);
#line 1900 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->thread);
#line 1901 "../src/umockdev.vala"
	_fclose0 (self->priv->script);
#line 12114 "umockdev.c"
}

static GType
umockdev_script_runner_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { umockdev_value_script_runner_init, umockdev_value_script_runner_free_value, umockdev_value_script_runner_copy_value, umockdev_value_script_runner_peek_pointer, "p", umockdev_value_script_runner_collect_value, "p", umockdev_value_script_runner_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevScriptRunnerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_script_runner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevScriptRunner), 0, (GInstanceInitFunc) umockdev_script_runner_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType umockdev_script_runner_type_id;
	umockdev_script_runner_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UMockdevScriptRunner", &g_define_type_info, &g_define_type_fundamental_info, 0);
	UMockdevScriptRunner_private_offset = g_type_add_instance_private (umockdev_script_runner_type_id, sizeof (UMockdevScriptRunnerPrivate));
	return umockdev_script_runner_type_id;
}

GType
umockdev_script_runner_get_type (void)
{
	static volatile gsize umockdev_script_runner_type_id__once = 0;
	if (g_once_init_enter (&umockdev_script_runner_type_id__once)) {
		GType umockdev_script_runner_type_id;
		umockdev_script_runner_type_id = umockdev_script_runner_get_type_once ();
		g_once_init_leave (&umockdev_script_runner_type_id__once, umockdev_script_runner_type_id);
	}
	return umockdev_script_runner_type_id__once;
}

gpointer
umockdev_script_runner_ref (gpointer instance)
{
	UMockdevScriptRunner * self;
	self = instance;
#line 1665 "../src/umockdev.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1665 "../src/umockdev.vala"
	return instance;
#line 12150 "umockdev.c"
}

void
umockdev_script_runner_unref (gpointer instance)
{
	UMockdevScriptRunner * self;
	self = instance;
#line 1665 "../src/umockdev.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1665 "../src/umockdev.vala"
		UMOCKDEV_SCRIPT_RUNNER_GET_CLASS (self)->finalize (self);
#line 1665 "../src/umockdev.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 12164 "umockdev.c"
	}
}

static inline gpointer
umockdev_socket_server_get_instance_private (UMockdevSocketServer* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevSocketServer_private_offset);
}

static gpointer
_umockdev_socket_server_run_gthread_func (gpointer self)
{
	gpointer result;
	result = umockdev_socket_server_run ((UMockdevSocketServer*) self);
#line 1923 "../src/umockdev.vala"
	umockdev_socket_server_unref (self);
#line 1923 "../src/umockdev.vala"
	return result;
#line 12183 "umockdev.c"
}

UMockdevSocketServer*
umockdev_socket_server_construct (GType object_type)
{
	UMockdevSocketServer* self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	gint* fds = NULL;
	gint* _tmp6_;
	gint fds_length1;
	gint _fds_size_;
	gint _tmp7_;
	gint _tmp8_;
	GThread* _tmp9_;
#line 1910 "../src/umockdev.vala"
	self = (UMockdevSocketServer*) g_type_create_instance (object_type);
#line 1912 "../src/umockdev.vala"
	self->priv->running = TRUE;
#line 1913 "../src/umockdev.vala"
	_tmp0_ = g_str_hash;
#line 1913 "../src/umockdev.vala"
	_tmp1_ = g_str_equal;
#line 1913 "../src/umockdev.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 1913 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->socket_scriptfile);
#line 1913 "../src/umockdev.vala"
	self->priv->socket_scriptfile = _tmp2_;
#line 1914 "../src/umockdev.vala"
	_tmp3_ = g_str_hash;
#line 1914 "../src/umockdev.vala"
	_tmp4_ = g_str_equal;
#line 1914 "../src/umockdev.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _umockdev_script_runner_unref0_);
#line 1914 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->script_runners);
#line 1914 "../src/umockdev.vala"
	self->priv->script_runners = _tmp5_;
#line 1918 "../src/umockdev.vala"
	_tmp6_ = g_new0 (gint, 2);
#line 1918 "../src/umockdev.vala"
	fds = _tmp6_;
#line 1918 "../src/umockdev.vala"
	fds_length1 = 2;
#line 1918 "../src/umockdev.vala"
	_fds_size_ = fds_length1;
#line 1919 "../src/umockdev.vala"
	_vala_assert (pipe (fds) == 0, "Posix.pipe (fds) == 0");
#line 1920 "../src/umockdev.vala"
	_tmp7_ = fds[0];
#line 1920 "../src/umockdev.vala"
	self->priv->ctrl_r = _tmp7_;
#line 1921 "../src/umockdev.vala"
	_tmp8_ = fds[1];
#line 1921 "../src/umockdev.vala"
	self->priv->ctrl_w = _tmp8_;
#line 1923 "../src/umockdev.vala"
	_tmp9_ = g_thread_new ("SocketServer", _umockdev_socket_server_run_gthread_func, umockdev_socket_server_ref (self));
#line 1923 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->thread);
#line 1923 "../src/umockdev.vala"
	self->priv->thread = _tmp9_;
#line 1910 "../src/umockdev.vala"
	fds = (g_free (fds), NULL);
#line 1910 "../src/umockdev.vala"
	return self;
#line 12255 "umockdev.c"
}

UMockdevSocketServer*
umockdev_socket_server_new (void)
{
#line 1910 "../src/umockdev.vala"
	return umockdev_socket_server_construct (UMOCKDEV_TYPE_SOCKET_SERVER);
#line 12263 "umockdev.c"
}

void
umockdev_socket_server_stop (UMockdevSocketServer* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GHashTable* _tmp3_;
	GThread* _tmp4_;
#line 1931 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1933 "../src/umockdev.vala"
	if (!self->priv->running) {
#line 1934 "../src/umockdev.vala"
		return;
#line 12279 "umockdev.c"
	}
#line 1937 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1937: Stopping SocketServer: signalling thread");
#line 1938 "../src/umockdev.vala"
	close (self->priv->ctrl_w);
#line 1941 "../src/umockdev.vala"
	_tmp0_ = self->priv->script_runners;
#line 1941 "../src/umockdev.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 12289 "umockdev.c"
	{
		GList* r_collection = NULL;
		GList* r_it = NULL;
#line 1941 "../src/umockdev.vala"
		r_collection = _tmp1_;
#line 1941 "../src/umockdev.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 12297 "umockdev.c"
			UMockdevScriptRunner* r = NULL;
#line 1941 "../src/umockdev.vala"
			r = (UMockdevScriptRunner*) r_it->data;
#line 12301 "umockdev.c"
			{
				UMockdevScriptRunner* _tmp2_;
#line 1942 "../src/umockdev.vala"
				_tmp2_ = r;
#line 1942 "../src/umockdev.vala"
				umockdev_script_runner_stop (_tmp2_);
#line 12308 "umockdev.c"
			}
		}
#line 1941 "../src/umockdev.vala"
		(r_collection == NULL) ? NULL : (r_collection = (g_list_free (r_collection), NULL));
#line 12313 "umockdev.c"
	}
#line 1943 "../src/umockdev.vala"
	_tmp3_ = self->priv->script_runners;
#line 1943 "../src/umockdev.vala"
	g_hash_table_remove_all (_tmp3_);
#line 1945 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1945: Stopping SocketServer: joining thread");
#line 1946 "../src/umockdev.vala"
	_tmp4_ = self->priv->thread;
#line 1946 "../src/umockdev.vala"
	self->priv->thread = NULL;
#line 1946 "../src/umockdev.vala"
	g_thread_join (_tmp4_);
#line 12327 "umockdev.c"
}

static void
_vala_array_add20 (GSocket** * array,
                   gint* length,
                   gint* size,
                   GSocket* value)
{
#line 1956 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1956 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1956 "../src/umockdev.vala"
		*array = g_renew (GSocket*, *array, (*size) + 1);
#line 12342 "umockdev.c"
	}
#line 1956 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1956 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 12348 "umockdev.c"
}

void
umockdev_socket_server_add (UMockdevSocketServer* self,
                            const gchar* sock_path,
                            gint fd,
                            const gchar* record_file)
{
	GHashTable* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar b = '\0';
	GError* _inner_error0_ = NULL;
#line 1949 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1949 "../src/umockdev.vala"
	g_return_if_fail (sock_path != NULL);
#line 1949 "../src/umockdev.vala"
	g_return_if_fail (record_file != NULL);
#line 12368 "umockdev.c"
	{
		GSocket* s = NULL;
		GSocket* _tmp0_;
		GSocket* _tmp1_;
		gboolean _tmp2_ = FALSE;
		GSocket* _tmp3_;
		GUnixSocketAddress* _tmp4_;
		GUnixSocketAddress* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_ = FALSE;
		GSocket* _tmp8_;
		GSocket* _tmp9_;
		GSocket* _tmp10_;
#line 1952 "../src/umockdev.vala"
		_tmp0_ = g_socket_new_from_fd (fd, &_inner_error0_);
#line 1952 "../src/umockdev.vala"
		s = _tmp0_;
#line 1952 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12388 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1953 "../src/umockdev.vala"
		_tmp1_ = s;
#line 1953 "../src/umockdev.vala"
		_vala_assert (_tmp1_ != NULL, "s != null");
#line 1954 "../src/umockdev.vala"
		_tmp3_ = s;
#line 1954 "../src/umockdev.vala"
		_tmp4_ = (GUnixSocketAddress*) g_unix_socket_address_new (sock_path);
#line 1954 "../src/umockdev.vala"
		_tmp5_ = _tmp4_;
#line 1954 "../src/umockdev.vala"
		_tmp6_ = g_socket_bind (_tmp3_, (GSocketAddress*) _tmp5_, TRUE, &_inner_error0_);
#line 1954 "../src/umockdev.vala"
		_g_object_unref0 (_tmp5_);
#line 1954 "../src/umockdev.vala"
		_tmp2_ = _tmp6_;
#line 1954 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1954 "../src/umockdev.vala"
			_g_object_unref0 (s);
#line 12411 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1954 "../src/umockdev.vala"
		_vala_assert (_tmp2_, "s.bind (new UnixSocketAddress (sock_path), true)");
#line 1955 "../src/umockdev.vala"
		_tmp8_ = s;
#line 1955 "../src/umockdev.vala"
		_tmp7_ = g_socket_listen (_tmp8_, &_inner_error0_);
#line 1955 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1955 "../src/umockdev.vala"
			_g_object_unref0 (s);
#line 12424 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1955 "../src/umockdev.vala"
		_vala_assert (_tmp7_, "s.listen ()");
#line 1956 "../src/umockdev.vala"
		_tmp9_ = s;
#line 1956 "../src/umockdev.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1956 "../src/umockdev.vala"
		_vala_array_add20 (&self->priv->listen_sockets, &self->priv->listen_sockets_length1, &self->priv->_listen_sockets_size_, _tmp10_);
#line 1951 "../src/umockdev.vala"
		_g_object_unref0 (s);
#line 12437 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp11_;
#line 1951 "../src/umockdev.vala"
		e = _inner_error0_;
#line 1951 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 1958 "../src/umockdev.vala"
		_tmp11_ = e->message;
#line 1958 "../src/umockdev.vala"
		g_error ("umockdev.vala:1958: load_socket_script(): cannot create Socket: %s", _tmp11_);
#line 1951 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 12454 "umockdev.c"
	}
	__finally0:
#line 1951 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1951 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1951 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 1951 "../src/umockdev.vala"
		return;
#line 12465 "umockdev.c"
	}
#line 1961 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1961: SocketServer.add: Created socket path %s, fd %i", sock_path, fd);
#line 1963 "../src/umockdev.vala"
	_tmp12_ = self->priv->socket_scriptfile;
#line 1963 "../src/umockdev.vala"
	_tmp13_ = g_strdup (sock_path);
#line 1963 "../src/umockdev.vala"
	_tmp14_ = g_strdup (record_file);
#line 1963 "../src/umockdev.vala"
	g_hash_table_insert (_tmp12_, _tmp13_, _tmp14_);
#line 1966 "../src/umockdev.vala"
	b = '1';
#line 1967 "../src/umockdev.vala"
	_vala_assert (write (self->priv->ctrl_w, &b, (gsize) 1) == ((gssize) 1), "Posix.write (this.ctrl_w, &b, 1) == 1");
#line 12481 "umockdev.c"
}

static void*
umockdev_socket_server_run (UMockdevSocketServer* self)
{
	GError* _inner_error0_ = NULL;
	void* result;
#line 1970 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1972 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1972: starting SocketServer thread");
#line 1973 "../src/umockdev.vala"
	while (TRUE) {
#line 12495 "umockdev.c"
		fd_set fds = {0};
		fd_set _tmp0_ = {0};
		gint max = 0;
		GSocket** _tmp1_;
		gint _tmp1__length1;
		gint res = 0;
		struct timeval _tmp11_ = {0};
		fd_set _tmp12_;
		GSocket** _tmp13_;
		gint _tmp13__length1;
#line 1973 "../src/umockdev.vala"
		if (!self->priv->running) {
#line 1973 "../src/umockdev.vala"
			break;
#line 12510 "umockdev.c"
		}
#line 1976 "../src/umockdev.vala"
		FD_ZERO (&_tmp0_);
#line 1976 "../src/umockdev.vala"
		fds = _tmp0_;
#line 1977 "../src/umockdev.vala"
		FD_SET (self->priv->ctrl_r, &fds);
#line 1978 "../src/umockdev.vala"
		max = self->priv->ctrl_r;
#line 1979 "../src/umockdev.vala"
		_tmp1_ = self->priv->listen_sockets;
#line 1979 "../src/umockdev.vala"
		_tmp1__length1 = self->priv->listen_sockets_length1;
#line 12524 "umockdev.c"
		{
			GSocket** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 1979 "../src/umockdev.vala"
			s_collection = _tmp1_;
#line 1979 "../src/umockdev.vala"
			s_collection_length1 = _tmp1__length1;
#line 1979 "../src/umockdev.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 12536 "umockdev.c"
				GSocket* s = NULL;
#line 1979 "../src/umockdev.vala"
				s = s_collection[s_it];
#line 12540 "umockdev.c"
				{
					GSocket* _tmp2_;
					gint _tmp3_;
					gint _tmp4_;
					GSocket* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
#line 1980 "../src/umockdev.vala"
					_tmp2_ = s;
#line 1980 "../src/umockdev.vala"
					_tmp3_ = g_socket_get_fd (_tmp2_);
#line 1980 "../src/umockdev.vala"
					_tmp4_ = _tmp3_;
#line 1980 "../src/umockdev.vala"
					FD_SET (_tmp4_, &fds);
#line 1981 "../src/umockdev.vala"
					_tmp5_ = s;
#line 1981 "../src/umockdev.vala"
					_tmp6_ = g_socket_get_fd (_tmp5_);
#line 1981 "../src/umockdev.vala"
					_tmp7_ = _tmp6_;
#line 1981 "../src/umockdev.vala"
					if (_tmp7_ > max) {
#line 12564 "umockdev.c"
						GSocket* _tmp8_;
						gint _tmp9_;
						gint _tmp10_;
#line 1982 "../src/umockdev.vala"
						_tmp8_ = s;
#line 1982 "../src/umockdev.vala"
						_tmp9_ = g_socket_get_fd (_tmp8_);
#line 1982 "../src/umockdev.vala"
						_tmp10_ = _tmp9_;
#line 1982 "../src/umockdev.vala"
						max = _tmp10_;
#line 12576 "umockdev.c"
					}
				}
			}
		}
#line 1987 "../src/umockdev.vala"
		_tmp11_.tv_sec = (time_t) 0;
#line 1987 "../src/umockdev.vala"
		_tmp11_.tv_usec = (glong) 500000;
#line 1987 "../src/umockdev.vala"
		res = select (max + 1, &fds, NULL, NULL, &_tmp11_);
#line 1988 "../src/umockdev.vala"
		if (res < 0) {
#line 1989 "../src/umockdev.vala"
			if (errno == EINTR) {
#line 1990 "../src/umockdev.vala"
				continue;
#line 12593 "umockdev.c"
			}
#line 1991 "../src/umockdev.vala"
			g_error ("umockdev.vala:1991: socket server thread: select() failed: %m");
#line 12597 "umockdev.c"
		}
#line 1993 "../src/umockdev.vala"
		if (res == 0) {
#line 1994 "../src/umockdev.vala"
			continue;
#line 12603 "umockdev.c"
		}
#line 1997 "../src/umockdev.vala"
		_tmp12_ = fds;
#line 1997 "../src/umockdev.vala"
		if (FD_ISSET (self->priv->ctrl_r, &_tmp12_) > 0) {
#line 12609 "umockdev.c"
			gchar buf = '\0';
			gssize r = 0L;
#line 1998 "../src/umockdev.vala"
			g_debug ("umockdev.vala:1998: socket server thread: woken up by control fd");
#line 2000 "../src/umockdev.vala"
			r = read (self->priv->ctrl_r, &buf, (gsize) 1);
#line 2001 "../src/umockdev.vala"
			if (r == ((gssize) 0)) {
#line 2003 "../src/umockdev.vala"
				self->priv->running = FALSE;
#line 2004 "../src/umockdev.vala"
				close (self->priv->ctrl_r);
#line 12622 "umockdev.c"
			} else {
#line 2006 "../src/umockdev.vala"
				_vala_assert (r == ((gssize) 1), "r == 1");
#line 12626 "umockdev.c"
			}
#line 2008 "../src/umockdev.vala"
			continue;
#line 12630 "umockdev.c"
		}
#line 2011 "../src/umockdev.vala"
		g_debug ("umockdev.vala:2011: socket server thread: select() got requests");
#line 2014 "../src/umockdev.vala"
		_tmp13_ = self->priv->listen_sockets;
#line 2014 "../src/umockdev.vala"
		_tmp13__length1 = self->priv->listen_sockets_length1;
#line 12638 "umockdev.c"
		{
			GSocket** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 2014 "../src/umockdev.vala"
			s_collection = _tmp13_;
#line 2014 "../src/umockdev.vala"
			s_collection_length1 = _tmp13__length1;
#line 2014 "../src/umockdev.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 12650 "umockdev.c"
				GSocket* s = NULL;
#line 2014 "../src/umockdev.vala"
				s = s_collection[s_it];
#line 12654 "umockdev.c"
				{
					GSocket* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					fd_set _tmp17_;
#line 2015 "../src/umockdev.vala"
					_tmp14_ = s;
#line 2015 "../src/umockdev.vala"
					_tmp15_ = g_socket_get_fd (_tmp14_);
#line 2015 "../src/umockdev.vala"
					_tmp16_ = _tmp15_;
#line 2015 "../src/umockdev.vala"
					_tmp17_ = fds;
#line 2015 "../src/umockdev.vala"
					if (FD_ISSET (_tmp16_, &_tmp17_) > 0) {
#line 12670 "umockdev.c"
						gint fd = 0;
						GSocket* _tmp18_;
						gint _tmp19_;
						gint _tmp20_;
						gchar* sock_path = NULL;
#line 2016 "../src/umockdev.vala"
						_tmp18_ = s;
#line 2016 "../src/umockdev.vala"
						_tmp19_ = g_socket_get_fd (_tmp18_);
#line 2016 "../src/umockdev.vala"
						_tmp20_ = _tmp19_;
#line 2016 "../src/umockdev.vala"
						fd = accept (_tmp20_, NULL, NULL);
#line 2017 "../src/umockdev.vala"
						if (fd < 0) {
#line 2018 "../src/umockdev.vala"
							g_error ("umockdev.vala:2018: socket server thread: accept() failed: %m");
#line 12688 "umockdev.c"
						}
#line 2019 "../src/umockdev.vala"
						sock_path = NULL;
#line 12692 "umockdev.c"
						{
							GSocketAddress* _tmp21_ = NULL;
							GSocket* _tmp22_;
							GSocketAddress* _tmp23_;
							const gchar* _tmp24_;
							const gchar* _tmp25_;
							gchar* _tmp26_;
							gchar* script = NULL;
							GHashTable* _tmp27_;
							const gchar* _tmp28_;
							gconstpointer _tmp29_;
							gchar* _tmp30_;
							GSocket* _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							const gchar* _tmp34_;
							const gchar* _tmp35_;
							gchar* key = NULL;
							const gchar* _tmp36_;
							gchar* _tmp37_;
							UMockdevScriptRunner* _tmp38_ = NULL;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							UMockdevScriptRunner* _tmp41_;
							GHashTable* _tmp42_;
							const gchar* _tmp43_;
							gchar* _tmp44_;
							UMockdevScriptRunner* _tmp45_;
#line 2021 "../src/umockdev.vala"
							_tmp22_ = s;
#line 2021 "../src/umockdev.vala"
							_tmp23_ = g_socket_get_local_address (_tmp22_, &_inner_error0_);
#line 2021 "../src/umockdev.vala"
							_tmp21_ = _tmp23_;
#line 2021 "../src/umockdev.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12729 "umockdev.c"
								goto __catch0_g_error;
							}
#line 2021 "../src/umockdev.vala"
							_tmp24_ = g_unix_socket_address_get_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, G_TYPE_UNIX_SOCKET_ADDRESS, GUnixSocketAddress));
#line 2021 "../src/umockdev.vala"
							_tmp25_ = _tmp24_;
#line 2021 "../src/umockdev.vala"
							_tmp26_ = g_strdup (_tmp25_);
#line 2021 "../src/umockdev.vala"
							_g_free0 (sock_path);
#line 2021 "../src/umockdev.vala"
							sock_path = _tmp26_;
#line 2022 "../src/umockdev.vala"
							_tmp27_ = self->priv->socket_scriptfile;
#line 2022 "../src/umockdev.vala"
							_tmp28_ = sock_path;
#line 2022 "../src/umockdev.vala"
							_tmp29_ = g_hash_table_lookup (_tmp27_, _tmp28_);
#line 2022 "../src/umockdev.vala"
							_tmp30_ = g_strdup ((const gchar*) _tmp29_);
#line 2022 "../src/umockdev.vala"
							script = _tmp30_;
#line 2023 "../src/umockdev.vala"
							_tmp31_ = s;
#line 2023 "../src/umockdev.vala"
							_tmp32_ = g_socket_get_fd (_tmp31_);
#line 2023 "../src/umockdev.vala"
							_tmp33_ = _tmp32_;
#line 2023 "../src/umockdev.vala"
							_tmp34_ = sock_path;
#line 2023 "../src/umockdev.vala"
							_tmp35_ = script;
#line 2023 "../src/umockdev.vala"
							g_debug ("umockdev.vala:2023: socket server thread: accepted request on server s" \
"ocket fd %i, path %s, script %s", _tmp33_, _tmp34_, _tmp35_);
#line 2025 "../src/umockdev.vala"
							_tmp36_ = sock_path;
#line 2025 "../src/umockdev.vala"
							_tmp37_ = g_strdup_printf ("%s%i", _tmp36_, fd);
#line 2025 "../src/umockdev.vala"
							key = _tmp37_;
#line 2026 "../src/umockdev.vala"
							_tmp39_ = key;
#line 2026 "../src/umockdev.vala"
							_tmp40_ = script;
#line 2026 "../src/umockdev.vala"
							_tmp41_ = umockdev_script_runner_new (_tmp39_, _tmp40_, fd, &_inner_error0_);
#line 2026 "../src/umockdev.vala"
							_tmp38_ = _tmp41_;
#line 2026 "../src/umockdev.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2026 "../src/umockdev.vala"
								_g_free0 (key);
#line 2026 "../src/umockdev.vala"
								_g_free0 (script);
#line 2026 "../src/umockdev.vala"
								_g_object_unref0 (_tmp21_);
#line 12786 "umockdev.c"
								goto __catch0_g_error;
							}
#line 2026 "../src/umockdev.vala"
							_tmp42_ = self->priv->script_runners;
#line 2026 "../src/umockdev.vala"
							_tmp43_ = key;
#line 2026 "../src/umockdev.vala"
							_tmp44_ = g_strdup (_tmp43_);
#line 2026 "../src/umockdev.vala"
							_tmp45_ = _tmp38_;
#line 2026 "../src/umockdev.vala"
							_tmp38_ = NULL;
#line 2026 "../src/umockdev.vala"
							g_hash_table_insert (_tmp42_, _tmp44_, _tmp45_);
#line 2020 "../src/umockdev.vala"
							_umockdev_script_runner_unref0 (_tmp38_);
#line 2020 "../src/umockdev.vala"
							_g_free0 (key);
#line 2020 "../src/umockdev.vala"
							_g_free0 (script);
#line 2020 "../src/umockdev.vala"
							_g_object_unref0 (_tmp21_);
#line 12809 "umockdev.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* e = NULL;
							const gchar* _tmp46_;
#line 2020 "../src/umockdev.vala"
							e = _inner_error0_;
#line 2020 "../src/umockdev.vala"
							_inner_error0_ = NULL;
#line 2028 "../src/umockdev.vala"
							_tmp46_ = e->message;
#line 2028 "../src/umockdev.vala"
							g_error ("umockdev.vala:2028: socket server thread: cannot launch ScriptRunner: " \
"%s", _tmp46_);
#line 2020 "../src/umockdev.vala"
							_g_error_free0 (e);
#line 12826 "umockdev.c"
						}
						__finally0:
#line 2020 "../src/umockdev.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2020 "../src/umockdev.vala"
							_g_free0 (sock_path);
#line 2020 "../src/umockdev.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2020 "../src/umockdev.vala"
							g_clear_error (&_inner_error0_);
#line 2020 "../src/umockdev.vala"
							return NULL;
#line 12839 "umockdev.c"
						}
#line 2015 "../src/umockdev.vala"
						_g_free0 (sock_path);
#line 12843 "umockdev.c"
					}
				}
			}
		}
	}
#line 2034 "../src/umockdev.vala"
	g_debug ("umockdev.vala:2034: socket server thread: end");
#line 2035 "../src/umockdev.vala"
	result = NULL;
#line 2035 "../src/umockdev.vala"
	return result;
#line 12855 "umockdev.c"
}

static void
umockdev_value_socket_server_init (GValue* value)
{
#line 1908 "../src/umockdev.vala"
	value->data[0].v_pointer = NULL;
#line 12863 "umockdev.c"
}

static void
umockdev_value_socket_server_free_value (GValue* value)
{
#line 1908 "../src/umockdev.vala"
	if (value->data[0].v_pointer) {
#line 1908 "../src/umockdev.vala"
		umockdev_socket_server_unref (value->data[0].v_pointer);
#line 12873 "umockdev.c"
	}
}

static void
umockdev_value_socket_server_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 1908 "../src/umockdev.vala"
	if (src_value->data[0].v_pointer) {
#line 1908 "../src/umockdev.vala"
		dest_value->data[0].v_pointer = umockdev_socket_server_ref (src_value->data[0].v_pointer);
#line 12885 "umockdev.c"
	} else {
#line 1908 "../src/umockdev.vala"
		dest_value->data[0].v_pointer = NULL;
#line 12889 "umockdev.c"
	}
}

static gpointer
umockdev_value_socket_server_peek_pointer (const GValue* value)
{
#line 1908 "../src/umockdev.vala"
	return value->data[0].v_pointer;
#line 12898 "umockdev.c"
}

static gchar*
umockdev_value_socket_server_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 1908 "../src/umockdev.vala"
	if (collect_values[0].v_pointer) {
#line 12909 "umockdev.c"
		UMockdevSocketServer * object;
		object = collect_values[0].v_pointer;
#line 1908 "../src/umockdev.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1908 "../src/umockdev.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 12916 "umockdev.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1908 "../src/umockdev.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 12920 "umockdev.c"
		}
#line 1908 "../src/umockdev.vala"
		value->data[0].v_pointer = umockdev_socket_server_ref (object);
#line 12924 "umockdev.c"
	} else {
#line 1908 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 12928 "umockdev.c"
	}
#line 1908 "../src/umockdev.vala"
	return NULL;
#line 12932 "umockdev.c"
}

static gchar*
umockdev_value_socket_server_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	UMockdevSocketServer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1908 "../src/umockdev.vala"
	if (!object_p) {
#line 1908 "../src/umockdev.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 12947 "umockdev.c"
	}
#line 1908 "../src/umockdev.vala"
	if (!value->data[0].v_pointer) {
#line 1908 "../src/umockdev.vala"
		*object_p = NULL;
#line 12953 "umockdev.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1908 "../src/umockdev.vala"
		*object_p = value->data[0].v_pointer;
#line 12957 "umockdev.c"
	} else {
#line 1908 "../src/umockdev.vala"
		*object_p = umockdev_socket_server_ref (value->data[0].v_pointer);
#line 12961 "umockdev.c"
	}
#line 1908 "../src/umockdev.vala"
	return NULL;
#line 12965 "umockdev.c"
}

GParamSpec*
umockdev_param_spec_socket_server (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	UMockdevParamSpecSocketServer* spec;
#line 1908 "../src/umockdev.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UMOCKDEV_TYPE_SOCKET_SERVER), NULL);
#line 1908 "../src/umockdev.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1908 "../src/umockdev.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1908 "../src/umockdev.vala"
	return G_PARAM_SPEC (spec);
#line 12984 "umockdev.c"
}

gpointer
umockdev_value_get_socket_server (const GValue* value)
{
#line 1908 "../src/umockdev.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SOCKET_SERVER), NULL);
#line 1908 "../src/umockdev.vala"
	return value->data[0].v_pointer;
#line 12994 "umockdev.c"
}

void
umockdev_value_set_socket_server (GValue* value,
                                  gpointer v_object)
{
	UMockdevSocketServer * old;
#line 1908 "../src/umockdev.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SOCKET_SERVER));
#line 1908 "../src/umockdev.vala"
	old = value->data[0].v_pointer;
#line 1908 "../src/umockdev.vala"
	if (v_object) {
#line 1908 "../src/umockdev.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_SOCKET_SERVER));
#line 1908 "../src/umockdev.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1908 "../src/umockdev.vala"
		value->data[0].v_pointer = v_object;
#line 1908 "../src/umockdev.vala"
		umockdev_socket_server_ref (value->data[0].v_pointer);
#line 13016 "umockdev.c"
	} else {
#line 1908 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 13020 "umockdev.c"
	}
#line 1908 "../src/umockdev.vala"
	if (old) {
#line 1908 "../src/umockdev.vala"
		umockdev_socket_server_unref (old);
#line 13026 "umockdev.c"
	}
}

void
umockdev_value_take_socket_server (GValue* value,
                                   gpointer v_object)
{
	UMockdevSocketServer * old;
#line 1908 "../src/umockdev.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SOCKET_SERVER));
#line 1908 "../src/umockdev.vala"
	old = value->data[0].v_pointer;
#line 1908 "../src/umockdev.vala"
	if (v_object) {
#line 1908 "../src/umockdev.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_SOCKET_SERVER));
#line 1908 "../src/umockdev.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1908 "../src/umockdev.vala"
		value->data[0].v_pointer = v_object;
#line 13047 "umockdev.c"
	} else {
#line 1908 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 13051 "umockdev.c"
	}
#line 1908 "../src/umockdev.vala"
	if (old) {
#line 1908 "../src/umockdev.vala"
		umockdev_socket_server_unref (old);
#line 13057 "umockdev.c"
	}
}

static void
umockdev_socket_server_class_init (UMockdevSocketServerClass * klass,
                                   gpointer klass_data)
{
#line 1908 "../src/umockdev.vala"
	umockdev_socket_server_parent_class = g_type_class_peek_parent (klass);
#line 1908 "../src/umockdev.vala"
	((UMockdevSocketServerClass *) klass)->finalize = umockdev_socket_server_finalize;
#line 1908 "../src/umockdev.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevSocketServer_private_offset);
#line 13071 "umockdev.c"
}

static void
umockdev_socket_server_instance_init (UMockdevSocketServer * self,
                                      gpointer klass)
{
	GSocket** _tmp0_;
#line 1908 "../src/umockdev.vala"
	self->priv = umockdev_socket_server_get_instance_private (self);
#line 2038 "../src/umockdev.vala"
	_tmp0_ = g_new0 (GSocket*, 0 + 1);
#line 2038 "../src/umockdev.vala"
	self->priv->listen_sockets = _tmp0_;
#line 2038 "../src/umockdev.vala"
	self->priv->listen_sockets_length1 = 0;
#line 2038 "../src/umockdev.vala"
	self->priv->_listen_sockets_size_ = self->priv->listen_sockets_length1;
#line 1908 "../src/umockdev.vala"
	self->ref_count = 1;
#line 13091 "umockdev.c"
}

static void
umockdev_socket_server_finalize (UMockdevSocketServer * obj)
{
	UMockdevSocketServer * self;
#line 1908 "../src/umockdev.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_SOCKET_SERVER, UMockdevSocketServer);
#line 1908 "../src/umockdev.vala"
	g_signal_handlers_destroy (self);
#line 1928 "../src/umockdev.vala"
	umockdev_socket_server_stop (self);
#line 2038 "../src/umockdev.vala"
	self->priv->listen_sockets = (_vala_array_free (self->priv->listen_sockets, self->priv->listen_sockets_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2039 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->socket_scriptfile);
#line 2040 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->script_runners);
#line 2041 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->thread);
#line 13112 "umockdev.c"
}

static GType
umockdev_socket_server_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { umockdev_value_socket_server_init, umockdev_value_socket_server_free_value, umockdev_value_socket_server_copy_value, umockdev_value_socket_server_peek_pointer, "p", umockdev_value_socket_server_collect_value, "p", umockdev_value_socket_server_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevSocketServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_socket_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevSocketServer), 0, (GInstanceInitFunc) umockdev_socket_server_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType umockdev_socket_server_type_id;
	umockdev_socket_server_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UMockdevSocketServer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	UMockdevSocketServer_private_offset = g_type_add_instance_private (umockdev_socket_server_type_id, sizeof (UMockdevSocketServerPrivate));
	return umockdev_socket_server_type_id;
}

GType
umockdev_socket_server_get_type (void)
{
	static volatile gsize umockdev_socket_server_type_id__once = 0;
	if (g_once_init_enter (&umockdev_socket_server_type_id__once)) {
		GType umockdev_socket_server_type_id;
		umockdev_socket_server_type_id = umockdev_socket_server_get_type_once ();
		g_once_init_leave (&umockdev_socket_server_type_id__once, umockdev_socket_server_type_id);
	}
	return umockdev_socket_server_type_id__once;
}

gpointer
umockdev_socket_server_ref (gpointer instance)
{
	UMockdevSocketServer * self;
	self = instance;
#line 1908 "../src/umockdev.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1908 "../src/umockdev.vala"
	return instance;
#line 13148 "umockdev.c"
}

void
umockdev_socket_server_unref (gpointer instance)
{
	UMockdevSocketServer * self;
	self = instance;
#line 1908 "../src/umockdev.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1908 "../src/umockdev.vala"
		UMOCKDEV_SOCKET_SERVER_GET_CLASS (self)->finalize (self);
#line 1908 "../src/umockdev.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 13162 "umockdev.c"
	}
}

/**
 * umockdev_in_mock_environment:
 *
 * Check whether the current process is running under umockdev-wrapper, i. e.
 * the umockdev preload library.
 *
 * Returns: %TRUE if running under preload with mocked devices, %FALSE if
 *          running against the real system.
 */
gboolean
umockdev_in_mock_environment (void)
{
	gboolean result;
#line 2067 "../src/umockdev.vala"
	if (!umockdev___in_mock_env_initialized) {
#line 13181 "umockdev.c"
		struct stat st = {0};
		struct stat _tmp0_ = {0};
		gint _tmp1_;
#line 2069 "../src/umockdev.vala"
		_tmp1_ = stat ("/sys", &_tmp0_);
#line 2069 "../src/umockdev.vala"
		st = _tmp0_;
#line 2069 "../src/umockdev.vala"
		if (_tmp1_ >= 0) {
#line 13191 "umockdev.c"
			struct stat _tmp2_;
#line 2070 "../src/umockdev.vala"
			_tmp2_ = st;
#line 2070 "../src/umockdev.vala"
			umockdev___in_mock_env_result = _tmp2_.st_ino > ((ino_t) 1);
#line 13197 "umockdev.c"
		}
#line 2071 "../src/umockdev.vala"
		umockdev___in_mock_env_initialized = TRUE;
#line 13201 "umockdev.c"
	}
#line 2074 "../src/umockdev.vala"
	result = umockdev___in_mock_env_result;
#line 2074 "../src/umockdev.vala"
	return result;
#line 13207 "umockdev.c"
}

GQuark
umockdev_error_quark (void)
{
	return g_quark_from_static_string ("umockdev-error-quark");
}

static GType
umockdev_error_get_type_once (void)
{
	static const GEnumValue values[] = {{UMOCKDEV_ERROR_PARSE, "UMOCKDEV_ERROR_PARSE", "parse"}, {UMOCKDEV_ERROR_VALUE, "UMOCKDEV_ERROR_VALUE", "value"}, {0, NULL, NULL}};
	GType umockdev_error_type_id;
	umockdev_error_type_id = g_enum_register_static ("UMockdevError", values);
	return umockdev_error_type_id;
}

GType
umockdev_error_get_type (void)
{
	static volatile gsize umockdev_error_type_id__once = 0;
	if (g_once_init_enter (&umockdev_error_type_id__once)) {
		GType umockdev_error_type_id;
		umockdev_error_type_id = umockdev_error_get_type_once ();
		g_once_init_leave (&umockdev_error_type_id__once, umockdev_error_type_id);
	}
	return umockdev_error_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

